2005-06-05  Robert Epprecht  <epprecht@solnet.ch>

	* cvs-tags: brew_0_2_0.

	* TAGS: Updated.

	* benchmark-results.txt: Benchmark results for 0.2.0
	  I left older results from 22.5.05 in here, to document the change
	  in bigFORTH timings (they have been inconsistent up to this version
	  and are back to normal now).

2005-06-02  Robert Epprecht  <epprecht@solnet.ch>

	* README: Updated.

	* NEXT: Added plans for experimental 0.3 series.

	* VERSION-README: Minor edit.

	* DEVELOPMENT: File depreciated.
	  (See files NEXT and VERSION-README).

	* genes-0.3.fs: Use parse-word in:  internal'  internal'?  GENE:

	* advanced.fs: get-name uses parse-word now.

	* system-dependent.fs:
	  Dependency on parse-word moved to system-dependent.fs.

	* BUGS: minor edit.

2005-06-01  Robert Epprecht  <epprecht@solnet.ch>

	* parse-word.fs: Define parse-word as proposed by Anton Ertl.
	  Based on
	  http://www.complang.tuwien.ac.at/forth/ansforth/reference-implementations/parse-name.fs
	  which is Public Domain. Courtesy Anton Ertl.

	* brew.fs:
	  Fixed compatibility bug, when brew-crash-test is defined
	  in "my-compile-options.fs".

2005-05-29  Robert Epprecht  <epprecht@solnet.ch>

	* brew.fs:
	  Fixed key binding in .menu-population-elitistic
	  .menus-menu  adapts to small screens.

	* brew.fs: System menu adapts to small screen sizes.

	* brew.fs: Fixed bug around (diversification-menu-type):
	  Added: diversification-menu-types  save-listed-enum-variable
	  Initialize it depending compile time configuration.
	  Rewrote cycle-div-menu-type (using diversification-menu-types).
	  Changed save-menu-configuration.

	* lists.fs: Added: key>list-index

2005-05-22  Robert Epprecht  <epprecht@solnet.ch>

	* texi/brew.texi, texi/brew.info: Minor update.

	* benchmark-results.txt: updated.

	* bigFORTH.fs: Check for bug in v2.1.00
	  v2.1.00 leaves a zero on stack. Check for the bug and drop.

2005-05-15  Robert Epprecht  <epprecht@solnet.ch>

	* statistics.fs: Fix statistic display on broad screens:
	  statistics-status-line-int  statistics-status-line-float
	  (statistic-display)

	* brew.fs: goodbye: cosmetics on broad screens.

2005-05-14  Robert Epprecht  <epprecht@solnet.ch>

	* texi/brew.texi, texi/brew.info: block-variables depreciated.

	* brew.fs:
	  Screen size cosmetics in .info-line.
	  block-variables depreciated.

	* brew-basics.fs: Screen size cosmetics in ?list-created-files.

2005-05-11  Robert Epprecht  <epprecht@solnet.ch>

	* tests/test-for_at-x-y.fs: removed test-for_at-x-y.fs

	* tests/test-for-at_x_y.fs: removed test-for-at_x_y.fs

	* tests/test2.fs: removed test2.fs

	* tests/test.fs: removed test.fs

	* OUTPUT/rec-play/intro.fs: removed intro.fs

	* speed-align.fs: removed speed-align.fs

	* TAGS, texi/brew.info, texi/brew.texi, texi/TODO, TODO, README-SECURITY, README, NEXT, BUGS:
	updated.

2005-05-11  Robert Epprecht  <epprecht@solnet.ch>

	* tests/test-for_at-x-y.fs: removed test-for_at-x-y.fs

	* tests/test-for-at_x_y.fs: removed test-for-at_x_y.fs

	* tests/test2.fs: removed test2.fs

	* tests/test.fs: removed test.fs

	* OUTPUT/rec-play/intro.fs: removed intro.fs

	* speed-align.fs: removed speed-align.fs

	* TAGS, texi/brew.info, texi/brew.texi, texi/TODO, TODO, README-SECURITY, README, NEXT, BUGS:
	updated.

2005-05-11  Robert Epprecht  <epprecht@solnet.ch>

	* TAGS, texi/brew.info, texi/brew.texi, texi/TODO, TODO, README-SECURITY, README, NEXT, BUGS:
	updated.

2005-05-10  Robert Epprecht  <epprecht@solnet.ch>

	* worlds.fs, brew.fs, bcompat-11-12.fs:
	  Fixed typo: free-neighbor-spot? renamed to free-neighbour-spot?

2005-04-23  Robert Epprecht  <epprecht@solnet.ch>

	* brew.fs: Defining a range in bar scan displays.

	  Added:  stop-defining-rectangle  line>step-item?  is-bar-graph?
	  (slice-range-low)  (slice-range-high)  defining-bar-range-off
	  (index)  define-bar-range  x-bar-ranged-subset

	  Changed: bar-ranged-subset
	  (bar-ranged-subset-int)  (bar-ranged-subset-dfloat)
	  scan-display-reaction  set-border-expression-float
	  maybe-fix-condition

	  Bugfix: removed (double) definition of locality types.
	          see brew-basics.fs
	  global% removed, use global-locality% instead.

	  Moved to display.fs:  color-miss-fg-xt   color-miss-bg-xt
	  color-selected-fg-xt  color-below-fg-xt  color-above-fg-xt
	  color-selected-bg-xt  color-below-bg-xt  color-above-bg-xt
	  .last-line

	* maybe-do.fs: Added:  >=  <=  f>=  f<=

	* common-words.fs: Added:  f>=  f<=

	* brew-basics.fs: Support for multi bar ranges:
	  defining-range removed, its function is now split into
	  defining-rectangle  and  defining-bar-range

	* statistics.fs:
	  Support for range definitions over multiple slices:
	  (stat-displ-coloured-range)  (slice-range-low)  (slice-range-high)

	* display.fs: Moved stuff from brew.fs to here:
	  .last-line
	  color-selected-fg-xt  color-below-fg-xt  color-above-fg-xt
	  color-miss-fg-xt  color-miss-bg-xt
	  color-selected-bg-xt  color-below-bg-xt  color-above-bg-xt

2005-04-20  Robert Epprecht  <epprecht@solnet.ch>

	* brew.fs: upper-slice-border unused.

	* brew.fs: More screen size adaptions.
	  New:     xy>spot  spot>xy
	  Renamed: spot>at to spot-at
	  Changed: mouse-in-field?

	  Marked some spots for coming world scrolling adaption with
	  MARK: scrolling

	  Use mid-screen.

	  Define rectangle ranges in world display:  define-rectangle
	  (range-low)  (range-high)  spot-in-rectangle?
	  rectangle>bg-col  (bg-col-was)
	  define-rectangle-off  rectangle-subset
	  Adapted:  react-on-mouse

	  Edited  .keybindings  .brew

	* world-loop.fs: spot>at is named spot-at now.

	* brew-basics.fs: New run-mode mask  defining-range.

	* statistics.fs: Removed redundant line.

	* menu.fs: Renamed >menu-flags to >menu-cell-flags.
	  Fixed typos in stack-2-is-xt and stack-3-is-xt.

	* dynamic-key-bindings.fs: removed show-ABC*. from '*'
	  ('*' gets used for define-rectangle now.)

	* display.fs: mid-screen

2005-04-18  Robert Epprecht  <epprecht@solnet.ch>

	* configure-console.fs, iForth.fs: Removed:  c-x  c-y

	* screen-size.fs: Brew does not need to know font size.
	  Removed:  c-x  c-y.

	* menu.fs: Dropped font size dependendy.
	  Eliminated:  c-x  c-y  xy-pix>c-cells
	  Adapted:  what  do-menu

	* brew.fs: Eliminated dependency on font size.
	  Brew does not need to know about font size any more, as long as
	  it is a *fixed width font*.

	  Changed: scan-display-reaction  mouse-in-field?  step-display-reaction
	  react-on-mouse  ?|see-genome-or-spot|  |individuals-menu|

	* cvs-tags: brew_0_2-pre-1

	* TODO: Another update.

	* TAGS, TODO: Updated.

	* brew.fs: Fixed typo.

	* texi/brew.info, texi/brew.texi, texi/HOWTO, texi/TODO: Updated.

	* profiling.fs: File brew-profile uses indentity-string now.

	* NEXT: Updated.

	* brew.fs: Include configure-console.fs from system menu.
	  |configure-console|

	* word-usage.fs: Much improved CREATE DOES> version.
	  CREATE DOES> works now, (CREATE without DOES> not yet).
	  create-does-words

	  I use a pending stack to compile CREATE DOES> words:
	  (pending-data)  (pending-stack-pointer)  pending-stack-size#
	  push-pending  pop-pending?
	  compile-pending

	  Counting can be switched off now.
	  (don't-count-words)  count?

2005-04-18  Robert Epprecht  <epprecht@solnet.ch>

	* cvs-tags: brew_0_2-pre-1

	* TODO: Another update.

	* TAGS, TODO: Updated.

	* brew.fs: Fixed typo.

	* texi/brew.info, texi/brew.texi, texi/HOWTO, texi/TODO: Updated.

	* profiling.fs: File brew-profile uses indentity-string now.

	* NEXT: Updated.

	* brew.fs: Include configure-console.fs from system menu.
	  |configure-console|

	* word-usage.fs: Much improved CREATE DOES> version.
	  CREATE DOES> works now, (CREATE without DOES> not yet).
	  create-does-words

	  I use a pending stack to compile CREATE DOES> words:
	  (pending-data)  (pending-stack-pointer)  pending-stack-size#
	  push-pending  pop-pending?
	  compile-pending

	  Counting can be switched off now.
	  (don't-count-words)  count?

2005-04-17  Robert Epprecht  <epprecht@solnet.ch>

	* INPUTS/experiments/sum/default-0.1.0.fs: Comment on the end edited.

	* system-dependent.fs: Check for pfe before gforth.
	  (pfe knows 's" gforth" environment?' too).

	  Removed stupid 64Bit blockage (only relevant for benchmarks and
	  maybe for old demos).

	* old-demos.fs: Comments edited.

2005-04-16  Robert Epprecht  <epprecht@solnet.ch>

	* profiling.fs: Added write-CREATE-DOES>-usage

	* brew.fs: System menu structure edited
	  (was a horrible mess).

	  Shortened very long words:
	  choose-nuc&spot-df-funct-xt-entry  choose-n&s-df-funct-xt-entry
	  choose-nuc&spot-function-xt-entry  choose-n&s-function-xt-entry

	  Adaptions to new word-usage.fs and profiling.fs
	  Dependency from allocation-pointers.fs
	  System menu uses .create-does>-usage

2005-04-14  Robert Epprecht  <epprecht@solnet.ch>

	* scan.fs: New scanning mechanism, in development.
	  A bit tested, but not used in brew yet.
	  This first version does all the scanning in float
	  (I think I want int too, later).

2005-04-13  Robert Epprecht  <epprecht@solnet.ch>

	* brew.fs: minor edits

	* brew.fs: df-function-number  df-function-within
	  dfloat-nuc-functions  dfloat-spot-functions
	  choose-df-nuc-funct-xt-entry  choose-df-spot-funct-xt-entry
	  (all-dfloat-funct-xts)  all-dfloat-functs-xts
	  choose-nuc&spot-df-funct-xt-entry  choose-df-funct-xt-entry

	  Changed: type-mismatch?  choose-expression

	  Try to fix type mismatches after user input:  choose-expression
	  maybe-fix-type-mismatch  dummy  dummy-int  dummy-float

	  factored out (bar-ranged-subset-dfloat)
	  bar-ranged-subset-dfloat  bar-ranged-subset-df-funct

	* maybe-do.fs: df-function-number df-function-within

	* menu.fs: Warning about giving xt's in xt-user-input.

	* probability-lists.fs: Renamed is-list to prob-is-list
	  Probability lists use a separate is-list flag, but I can't remember
	  why. To avoid confusions I gave it a separate name now.

2005-04-10  Robert Epprecht  <epprecht@solnet.ch>

	* brew-init.fs, brew-defaults.fs:
	  Adaptions to new features and names.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, OUTPUT/rec-play/intro.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/default-0.1.0.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs, old-demos.fs, brew.fs:
	Renamed (scan-detail-index) to (scan-detail)

	* brew.fs:
	  Function data can be scanned in real time (i.e. scoing, score)
	  and used in maybe-do. Changes in too many places to mention them all.

	  nuc-function-scan  (scan-nuc-int-function)  int-function-2-min-max
	  nuc-df-detail-2-min-max  nuc-df-function-2-min-max  (both untested)
	  nuc-scan-int-funct-display  nuc-scan-func-dspl
	  nuc-int-functions  select-nuc-int-function  (scan-locality)

	  Adaptions scan-status-line-reaction  step-display-reaction

	  adaptions in bar-ranged-subset
	  set-border-expression  upper-slice-border
	  (bar-ranged-subset-int)  bar-ranged-subset-int
	  bar-ranged-subset-int-funct  zero-range?

	  New maybe-do-expressions  function-within  function-number
	  can be used for the same functions, i.e. for colouring.
	  Used in:
	    generic-range>fg-color  generic-range>bg-color
	    coloured-on-range-possible?
	    conditional-expression-entries

	  all-lists get re-built on each usage to make sure they are up to date
	    all-int-var-xts    (all-int-var-xts)
	    all-dfloat-var-xts (all-dfloat-var-xts)
	    all-int-functions  (all-int-functions)

	  choose-nuc-function-xt-entry
	  spot-int-functions  choose-spot-function-xt-entry
	  choose-nuc&spot-function-xt-entry  choose-function-xt-entry

	  maybe-fix-condition replaces maybe-fix
	  choose-expression

	  Better error reporting in:
	    generic-range>fg-color  generic-range>bg-color
	    .menu-step-display-item
	    needs-float-condition?  conditional-expression-entries

	  Use new type codes.
	  determine-types  determine-type  .type  type-mismatch?

	  listed-enum>string  moved to brew-basics.fs

	* brew-basics.fs: minor edits

	* brew-basics.fs: is-int? is-dfloat?

	* lists.fs: concat-lists-simple sum-lists-simple

2005-04-09  Robert Epprecht  <epprecht@solnet.ch>

	* statistics.fs: Use renamed type codes.

	* maybe-do.fs: function results for conditions
	  function-within  function-number  (more to come).
	  The menus for configuration need more work.
	  The whole mechanism should be rewritten anyway.

	  Better error messages in  maybe-string  and  maybe-FORTH-string

	* brew-basics.fs: Type and locality codes extended.

	  variable-types defined here now. Renamed and extended.
	  type-unknown% type-int% type-df% type-int-addr% type-df-addr%
	  var-type-string

	  locality-types  Locality type's for scans:
	  unknown-locality% global-locality% world-local%
	  spot-local% nuc-local% ( now defined as LISTED-ENUM: )
	  locality-string

	  listed-enum>string  moved from brew.fs to here

	* basics.fs: defining dfloat offset variables
	  BASE+dfloatOFFSET:  POINTER+dfloatOFFSET:

	  allocate-clean

	* advanced.fs: variable-types moved to brew-basics.fs
	  types moved and renamed:  type-unknown% type-integer% type-dfloat%
	  brew-basics.fs new names: type-int-addr% type-df-addr%

	* lists.fs: Typo here-list-allocate renamed to here-list-allot.
	  (unused anyway)

	* common-words.fs: maxaligned

2005-04-07  Robert Epprecht  <epprecht@solnet.ch>

	* brew-basics.fs: Locality type codes renamed.
	  type-spot and type-nuc renamed to spot-local% and nuc-local%

	  (scan-type) renamed to (scan-locality) and moved to brew.fs

2005-04-06  Robert Epprecht  <epprecht@solnet.ch>

	* brew.fs: Changed .hits implementation.
	  New generic nuc and spot test result counting words.
	  test-and-count-everybody  test-and-count-everywhere
	  Added: (test&count)  hit?     Removed: (count-hits)

	* brew.fs: New slot display word .hits
	  Uses (count-hits).

	* brew.fs: Avoid undefined step-display-items
	  Better managment in menu-step-display  and  display-menu
	  step-menu-leave?  .menu-step-display-item .menu-step-display
	  Hack: (don't-leave)
	  .display-menu

2005-04-05  Robert Epprecht  <epprecht@solnet.ch>

	* mutation-0.3.fs:
	  renamed  top-level-skip-IF-ELSE-branch  to
	  top-level-snip-IF-ELSE-branch

	* mutation-0.3.fs: top-level-skip-IF-ELSE-branch  mutation-must-differ
	  Deconstruct IF-THEN or IF-ELSE-THEN
	  top-level-skip-IF-ELSE-branch drops the condition flag and executes
	  one of the branches unconditionally. In case of IF-THEN the branch
	  is either snipped or executed unconditionally.
	  Elimination of flag producing code is left to other (snip) types.

	  A list of structure relevant data is built, to simplify finding and
	  selecting the conditional clause to mutate.
	  Added: >index-in-gene-sequence  >gene-xt  >nesting-level
	         (gene-struct-list-size)  gene>structure-list
	         build-structure-list  count-xt  .structure-list (testing)
	         (n'th-occurance)  (next-xt-on-level)  find-n'th-if-structure
	         find-n'th-if-in-genome  top-level-skip-IF-ELSE-branch

	  do-token-replacement does not accept building pseudo genes as token
	  replacement. (It was trying to replace drop(C-) by g-IF-ELSE-THEN).

	  New: mutation-must-differ (Run time switch for compatibility).
	  Avoid re-inventing the same genome over and over again.

	  play-&-add stack comment fixed.

	* INPUTS/genes/basic-stack.fs: Added: drop(C-)
	  Needed by mutation type  top-level-skip-IF-ELSE-branch.

	* genes-0.3.fs:
	  Some words added for top-level-skip-IF-ELSE-branch mutation type.
	  internal'?  gene-n'th-xt-addr  scan-genome-for-gene  genome-has-gene?

	* brew.fs:
	  Adaptions to different screen sizes:
	  Include my-console.conf.fs unless old-bench-compatible-mode?
	  Use new keep-but-scroll-rest instead of menu-scroll-lines !

	  Use screen-sized-big-bang instead of big-bang.

	  Automatic size adaption in step display:
	  Added:   step-display-item-sizes item-adaptable?
	           step-display-used-fixed used-adaptable-lines
	           available-adaptable-lines step-display-adaptable-items
	           adapt-proportional fine-tune-size step-display-adapt-size
	           step-display-undefined
	  Changed: ?step-display-sanity step-display-adapt-size
	           menu-step-display .display-menu display-menu
	           toggle-display-&-go
	  Removed: not-adaptable-lines

	  Compatibility: added: mutation-must-differ old-bench-compatible-mode?

	  Errors in loaded confiruration files do THROW now.

	  Configure brew-at-xy-xt in system-menu. Save brew-at-xy-xt.

	  Replaced .quit-brew? by .quit-brew-or-stop-modes which ends
	  clone mode if it's active.

2005-04-04  Robert Epprecht  <epprecht@solnet.ch>

	* display.fs: Added: at-y

	* configure-console.fs:
	  Helper application to determine and configure console screen size
	  on a typical Linux text console.
	  Generates my-console.conf.fs which is read by brew, if it exists.

	  I don't know if it runs on anything else than a Linux text console.

	* keybuf.fs: ekey-outside displays on left border now.

	* INPUTS/experiments/sum/default-0.1.0.fs: Screen size adaptions:
	  Run in a demo world on systems other than 80 25
	  Value demo-world-created stores a flag

	  Mutation compatibility: mutation-must-differ off

	  Comments edited.

2005-03-31  Robert Epprecht  <epprecht@solnet.ch>

	* gforth.fs: Another <page-up> <page-down> adaption...

	* display.fs: Cursor movement and screen borders.
	  As relative cursor moving words do not use console codes any more
	  I moved this stuff from console-codes.fs to here:
	  brew-at-xy-xt  cursor-up  cursor-down  cursor-right  cursor-left

	  Deal with screen borders when moving cursor: Cursor stays inside
	  brews screen, wrapping/stopping at borders as run time option.
	  Added: at-xy-stopping  at-xy-wrapping  toggle-cursor-wrapping

	  File structure edited.

	* console-codes.fs: moved some stuff to display.fs
	  As relative cursor moving words do not use console codes any more
	  I moved this stuff out of here:
	  brew-at-xy-xt  cursor-up  cursor-down  cursor-right  cursor-left

	* console-codes.fs: More flexible cursor moving words definitions:
	  Added: brew-at-xy-xt  Vectored version of at-xy used in
	  cursor-up cursor-down cursor-right cursor-left
	  Currently used to keep cursor inside screen and switch
	  stopping/wrapping on screen borders.

	* screen-size.fs: Now only used as savety net
	  If my-console.conf.fs exists, it is read before.
	  Now only define conservative defaults to *undefined* constants.

	* gene-edit.fs, fileselect.fs: Use keep-but-scroll-rest

	* worlds.fs: Added: : screen-sized-big-bang ( -- )
	  Create a 2 dimensional world that fits on screen:
	  (c-l l-s aware alternative to conservative 80 25 big-bang).

	* menu.fs: adaption to console size:
	  Added: keep-but-scroll-rest ( reserved-lines -- )
	  Reserve a number of lines but set scrolling for the rest

	  Comment about dependency on screen-size.fs

2005-03-30  Robert Epprecht  <epprecht@solnet.ch>

	* compile-options.fs: removed cursor-wrap
	  It is a run time switch now, see brew-at-xy-xt

	* brew-defaults.fs: scoring-hit>bg-color as default.
	  make step display size better adapted to different screen size.

	* compile-options.fs: added cursor-wrap

2005-03-28  Robert Epprecht  <epprecht@solnet.ch>

	* system-dependent.fs: comments and user information extended.

2005-03-27  Robert Epprecht  <epprecht@solnet.ch>

	* basics.fs:
		added  'file-exists?'.

2003-08-27  Robert Epprecht  <epprecht@solnet.ch>

	* brew-basics.fs: Dependencies resolved.
	  (make-ekey-map.fs can be run standalone now, and depends on it).

	* stringbuf-0.4.fs, statistics.fs, sorted-lists.fs, required.fs, probability-lists.fs, lists.fs, listed-masks.fs, keybuf.fs, display.fs, compile-switches.fs, common-words.fs, basics.fs, allocation-pointers.fs, advanced.fs:
	  Dependency issues:
	  consequent handling of case of marker words.

	* menu.fs: Use  RETURN%  to deal with iForth <RETURN> key code.

	* system-dependent.fs: Display a message when including.

	* pfe.fs: New constant '<return>' (needed for iForth).

	  allowed-key-codes#  no longer defined here.

	* gforth.fs: New constant '<return>' (needed for iForth).

	  [DEFINED] and [UNDEFINED] come already with 0.6.x versions:
	  check before defining.

	* make-ekey-map.fs: Can be run as standalone program now.
	  Resolved all file dependencies.
	  Writes new constant '<return>' for iForth.

	* key-mapping.fs:
	  iForth KEY and EKEY return decimal 10 for <RETURN> on Linux.
	  Added <return> for key mapping and redefined KEY.

	* iForth.fs:
	iForth KEY and EKEY return decimal 10 for <RETURN> on Linux.
	  Added <return> for key mapping.
	  Redefined KEY.

2003-08-25  Robert Epprecht  <epprecht@solnet.ch>

	* stringbuf-0.4.fs, statistics.fs, sorted-lists.fs, simple-stringbuf.fs, probability-lists.fs, menu.fs, lists.fs, listed-masks.fs, keybuf.fs, display.fs, compile-switches.fs, allocation-pointers.fs, advanced.fs, basics.fs:
		Resolving file dependencies:
		replaced the  ' ' CATCH some-word [IF] ...  construct
		which does not work on iForth, as it implements the
		standard literally (restoring input source location).

	* compile-switches.fs:
	Comments editet and dependencies for tests resolved.

2003-08-23  Robert Epprecht  <epprecht@solnet.ch>

	* README: Updated Forth versions.

2003-08-02  Robert Epprecht  <epprecht@solnet.ch>

	* texi/brew.info, texi/brew.texi: Version 0.1-pre-3

2003-03-12  Robert Epprecht  <epprecht@solnet.ch>

	* README: URL fixed.

	* association-lists.fs: key-to-list  better structured.

2003-02-17  Robert Epprecht  <epprecht@solnet.ch>

	* cvs-tags: brew_0_1-pre-3

	* TAGS: Updated.

	* benchmark-results.txt: brew_0_1-pre-3 results.
	  Including benchmarks on gforth-0.5.9-20030201 snapshot.

	* benchmark-results.txt: No, last bench was not 0.1.0 yet...

	* texi/brew.texi, texi/brew.info:
	  Brew homepage has moved to 'http://reppre51.home.solnet.ch/'.

	* texi/brew.texi, texi/brew.info, INPUTS/extensions/debugging/crash-test-README, stringbuf-0.4.fs, simple-stringbuf.fs, probability-lists.fs, menu.fs, lists.fs, listed-masks.fs, fileselect.fs, environmental.test.fs, cvs-tags, compile-switches.fs, compile-options.fs, brew.fs, basics.fs, README-SECURITY, README:
	  Changed email address:  Robert Epprecht <epprecht@solnet.ch>

2003-02-17  Robert Epprecht  <epprecht@solnet.ch>

	* cvs-tags: brew_0_1-pre-3

	* TAGS: Updated.

	* benchmark-results.txt: brew_0_1-pre-3 results.
	  Including benchmarks on gforth-0.5.9-20030201 snapshot.

	* benchmark-results.txt: No, last bench was not 0.1.0 yet...

	* texi/brew.texi, texi/brew.info:
	  Brew homepage has moved to 'http://reppre51.home.solnet.ch/'.

	* texi/brew.texi, texi/brew.info, INPUTS/extensions/debugging/crash-test-README, stringbuf-0.4.fs, simple-stringbuf.fs, probability-lists.fs, menu.fs, lists.fs, listed-masks.fs, fileselect.fs, environmental.test.fs, cvs-tags, compile-switches.fs, compile-options.fs, brew.fs, basics.fs, README-SECURITY, README:
	  Changed email address:  Robert Epprecht <epprecht@solnet.ch>

2003-02-03  Robert Epprecht  <epprecht@solnet.ch>

	* texi/brew.texi, texi/brew.info, benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/default-0.1.0.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs, mutation-0.3.fs, brew-defaults.fs, brew.fs:
	  Shortened some very long names.
	  (Gforth snapshot xt>name did not work with too long names).
	  old name:				new name:
	  spot-diversification-closeness	spot-diversifictn-closeness
	  global-i-diversification-rate		global-i-diversifictn-rate
	  globals-diversification-range		globals-diversifictn-range
	  globals-diversifctn-closeness		globals-divers-closeness
	  global-f-diversification-rate		global-f-diversifctn-rate
	  global-f-diversification-range	global-f-diversifctn-range
	  global-f-diversification-factor	global-f-diversifctn-factor
	  top-level-address-replacement		top-level-address-replacemnt

	* fileselect.fs: Fixed file count display.

2002-11-20  Robert Epprecht  <epprecht@solnet.ch>

	* stringbuf-0.4.fs: Fixed file name in LICENSE.
	  Fixed dependencies.

	* simple-stringbuf.fs, probability-lists.fs, menu.fs, lists.fs, listed-masks.fs, fileselect.fs:
	  Fixed file name in LICENSE.

	* compile-switches.fs, allocation-pointers.fs:
	  Added/fixed dependencies.

	* advanced.fs: Added/fixed dependencies.

2002-11-19  Robert Epprecht  <epprecht@solnet.ch>

	* lists.fs: Testcode changed a bit.

	* INPUTS/extensions/debugging/brew-crash-test.fs:
	Edits for screens > 25 lines.

	* menu.fs: show-key-bindings  can be left with 'q'.
	  keybinding-reaction  returns exit flag.

	* INPUTS/experiments/sum/default-0.1.0.fs: Minor edit.

	* lists.fs: Added usage comments,
	  edited stack comment wording.

2002-11-18  Robert Epprecht  <epprecht@solnet.ch>

	* DEVELOPMENT: Changed list implementation.
	  Well I know one should not change a running system...

	* NEXT: Updated.

	* brew.fs: System menu 'Q' key binding.

	* lists.fs: Save last node address in descriptor,
	  makes  >list  fast (see benches at the end of the file).

2002-11-17  Robert Epprecht  <epprecht@solnet.ch>

	* lists.fs: to-last-nodes-sublist!  use  last-node

	* lists.fs: Compute double offsets at run time:
	  Literals instead  '>node-descriptor >link' and similar.

	  >list-descriptor  got it's own, real definition now,
	  and is not immediate any more (does same as  >node-descriptor).

	* lists.fs: Comments edited and added.

2002-11-16  Robert Epprecht  <epprecht@solnet.ch>

	* advanced.fs, brew-basics.fs:
	  variable-types moved from basics.fs to advanced.fs

	* benchmarks/block-var-speed-test.fs, word-usage.fs, system-dependent.fs:
	Use INCLUDED instead of INCLUDE.

	* fileselect.fs: File dependencies edited.

	* tests/test-for_at-x-y.fs, tests/test-for-at_x_y.fs, symbols-stack.fs, statistics.fs, sorted-lists.fs, my-brew-options.fs, mutation-0.3.fs, mouse.fs, menu.fs, maybe-run-benchmark.fs, lists.fs, iForth.fs, genes-0.3.fs, faked-genes.fs, console-codes.fs, compile-options.fs, code-chapters.txt, brew.fs, bigFORTH.fs, DEVELOPMENT:
	  Spelling: case.

	* mutation.fs: Removed mutation.fs.

	* stringbuf.fs: Removed stringbuf.fs.

2002-11-15  Robert Epprecht  <epprecht@solnet.ch>

	* cvs-tags: brew_0_1-pre-2

	* TAGS: Updated.

	* texi/brew.info, texi/brew.texi:
	  Documented new factorized files:
	  advanced.fs  listed-masks.fs  user-IO.fs .

	* texi/TODO: Updated.

	* compile-options.fs, required.fs, system-dependent.fs, pfe.fs, menu.fs, manual.fs, console-codes.fs, compile-switches.fs, association-lists.fs, advanced.fs, stringbuf-0.4.fs, sorted-string-lists.fs, user-IO.fs, string-replace.fs, string-lists.fs, sorted-lists.fs, simple-stringbuf.fs, random.fs, probability-lists.fs, fileselect.fs, listed-masks.fs, lists.fs, display.fs, brew-basics.fs, keybuf.fs, common-words.fs, basics.fs, brew.fs:
	  File dependencies and file factorisation:
	  Making basic brew tools usable independent of brew.
	  Edited source file comments.
	  Fixed REQUESTED issues with pfe.

	* DEVELOPMENT: File dependencies and file factorisation:
	  Making basic brew tools usable independent of brew.
	  Edited source file comments.
	  Fixed REQUESTED issues with pfe.

2002-11-15  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew_0_1-pre-2

	* TAGS: Updated.

	* texi/brew.info, texi/brew.texi:
	  Documented new factorized files:
	  advanced.fs  listed-masks.fs  user-IO.fs .

	* texi/TODO: Updated.

	* compile-options.fs, required.fs, system-dependent.fs, pfe.fs, menu.fs, manual.fs, console-codes.fs, compile-switches.fs, association-lists.fs, advanced.fs, stringbuf-0.4.fs, sorted-string-lists.fs, user-IO.fs, string-replace.fs, string-lists.fs, sorted-lists.fs, simple-stringbuf.fs, random.fs, probability-lists.fs, fileselect.fs, listed-masks.fs, lists.fs, display.fs, brew-basics.fs, keybuf.fs, common-words.fs, basics.fs, brew.fs:
	  File dependencies and file factorisation:
	  Making basic brew tools usable independent of brew.
	  Edited source file comments.
	  Fixed REQUESTED issues with pfe.

	* DEVELOPMENT: File dependencies and file factorisation:
	  Making basic brew tools usable independent of brew.
	  Edited source file comments.
	  Fixed REQUESTED issues with pfe.

2002-11-15  Robert Epprecht  <epprecht@sunweb.ch>

	* compile-options.fs, required.fs, system-dependent.fs, pfe.fs, menu.fs, manual.fs, console-codes.fs, compile-switches.fs, association-lists.fs, advanced.fs, stringbuf-0.4.fs, sorted-string-lists.fs, user-IO.fs, string-replace.fs, string-lists.fs, sorted-lists.fs, simple-stringbuf.fs, random.fs, probability-lists.fs, fileselect.fs, listed-masks.fs, lists.fs, display.fs, brew-basics.fs, keybuf.fs, common-words.fs, basics.fs, brew.fs:
	  File dependencies and file factorisation:
	  Making basic brew tools usable independent of brew.
	  Edited source file comments.
	  Fixed REQUESTED issues with pfe.

	* DEVELOPMENT: File dependencies and file factorisation:
	  Making basic brew tools usable independent of brew.
	  Edited source file comments.
	  Fixed REQUESTED issues with pfe.

2002-11-14  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/genes/mixed-maths.fs, INPUTS/genes/dfloat-store.fs, INPUTS/genes/dfloat-fetch.fs, world-loop.fs, maybe-do.fs, gene-edit.fs, debuging.fs, common-words.fs, brew.fs, basics.fs:
	  Changed case of some definitions and word usage.
	  (For pfe case issues).

	* DEVELOPMENT:
	  Keep case sensitivity of pfe happy: Change case where appropriate.

2002-11-14  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/genes/mixed-maths.fs, INPUTS/genes/dfloat-store.fs, INPUTS/genes/dfloat-fetch.fs, world-loop.fs, maybe-do.fs, gene-edit.fs, debuging.fs, common-words.fs, brew.fs, basics.fs:
	  Changed case of some definitions and word usage.
	  (For pfe case issues).

	* DEVELOPMENT:
	  Keep case sensitivity of pfe happy: Change case where appropriate.

2002-11-12  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Key reaction in fileselect-menu.

	* TODO: Updated.

	* fileselect.fs: Key reaction in  fileselect-menu :
	  filename-1st-char  scroll-to-line
	  Removed:  (start-char)

	* menu-0.3.fs:  menu-0.3.fs removed

2002-11-11  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew_0_1-pre-1

2002-11-12  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Key reaction in fileselect-menu.

	* TODO: Updated.

	* fileselect.fs: Key reaction in  fileselect-menu :
	  filename-1st-char  scroll-to-line
	  Removed:  (start-char)

	* menu-0.3.fs:  menu-0.3.fs removed

2002-11-11  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew_0_1-pre-1

	* TODO, TAGS, NEXT: Updated.

	* DEVELOPMENT:
	Fileselect sorting files alphabetically, directories first.

	* fileselect.fs: Sorting alphabetically, directories first.
	  Mostly rewritten.

	  Attention:  (start-char)  unused.

	* sorted-string-lists.fs: Build alphabetically sorted string lists.
	  Very simple insertion sort implementation.

	* lists.fs: Defined list-user-flag#
	  start bit for available user list node flags.

	* string-lists.fs: File dependencies resolved.

	* stringbuf-0.4.fs: string-compare  compares handled strings.

2002-11-11  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew_0_1-pre-1

	* TODO, TAGS, NEXT: Updated.

	* DEVELOPMENT:
	Fileselect sorting files alphabetically, directories first.

	* fileselect.fs: Sorting alphabetically, directories first.
	  Mostly rewritten.

	  Attention:  (start-char)  unused.

	* sorted-string-lists.fs: Build alphabetically sorted string lists.
	  Very simple insertion sort implementation.

	* lists.fs: Defined list-user-flag#
	  start bit for available user list node flags.

	* string-lists.fs: File dependencies resolved.

	* stringbuf-0.4.fs: string-compare  compares handled strings.

2002-11-11  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT:
	Fileselect sorting files alphabetically, directories first.

	* fileselect.fs: Sorting alphabetically, directories first.
	  Mostly rewritten.

	  Attention:  (start-char)  unused.

	* sorted-string-lists.fs: Build alphabetically sorted string lists.
	  Very simple insertion sort implementation.

	* lists.fs: Defined list-user-flag#
	  start bit for available user list node flags.

	* string-lists.fs: File dependencies resolved.

	* stringbuf-0.4.fs: string-compare  compares handled strings.

2002-11-10  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Some adaptions for old demos.

	* INPUTS/experiments/sum/default-0.1.0.fs: Edited.

	* old-demos.fs: Better adapting old demos to current brew.

	* README-SECURITY: Edited.

	* brew.fs: Quick exit key-binding 'yy'.

	* dynamic-key-bindings.fs: Leave 'y' key free for quick escape by 'yy'.

	* cvs-tags: cvs wants no dots in tag names :-(
	  had to rename it to  brew_0_1-pre-0

	* cvs-tags: brew-0.1-pre-0

	* DEVELOPMENT: brew-0.1.0 release pre test.

	* TAGS: Updated.

	* brew.fs: Polishing  start-help  and  |goodbye| .

	* brew-defaults.fs: Some minor adaptions.

	* NEXT: Updated.

	* texi/brew.info, texi/brew.texi:
	  Mentioning 'default' demo and some minor adaptions.

	* old-demos.fs: Added  demo default-0.1.0
	  Switch  elitism-off  in old demos.

	* README: Mentioning 'default' demo.

	* reporting.fs: file-scoring  unused yet.

	* INPUTS/experiments/sum/default-0.1.0.fs:
	Demo related to brew-0.1.0 default initialisation.

	* INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/default-0.1.0.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs:
	  <F12> gives  |goodbye|  instead of  goodbye .

2002-11-10  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Some adaptions for old demos.

	* INPUTS/experiments/sum/default-0.1.0.fs: Edited.

	* old-demos.fs: Better adapting old demos to current brew.

	* README-SECURITY: Edited.

	* brew.fs: Quick exit key-binding 'yy'.

	* dynamic-key-bindings.fs: Leave 'y' key free for quick escape by 'yy'.

	* cvs-tags: cvs wants no dots in tag names :-(
	  had to rename it to  brew_0_1-pre-0

	* cvs-tags: brew-0.1-pre-0

	* DEVELOPMENT: brew-0.1.0 release pre test.

	* TAGS: Updated.

	* brew.fs: Polishing  start-help  and  |goodbye| .

	* brew-defaults.fs: Some minor adaptions.

	* NEXT: Updated.

	* texi/brew.info, texi/brew.texi:
	  Mentioning 'default' demo and some minor adaptions.

	* old-demos.fs: Added  demo default-0.1.0
	  Switch  elitism-off  in old demos.

	* README: Mentioning 'default' demo.

	* reporting.fs: file-scoring  unused yet.

	* INPUTS/experiments/sum/default-0.1.0.fs:
	Demo related to brew-0.1.0 default initialisation.

	* INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/default-0.1.0.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs:
	  <F12> gives  |goodbye|  instead of  goodbye .

2002-11-10  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: cvs wants no dots in tag names :-(
	  had to rename it to  brew_0_1-pre-0

	* cvs-tags: brew-0.1-pre-0

	* DEVELOPMENT: brew-0.1.0 release pre test.

	* TAGS: Updated.

	* brew.fs: Polishing  start-help  and  |goodbye| .

	* brew-defaults.fs: Some minor adaptions.

	* NEXT: Updated.

	* texi/brew.info, texi/brew.texi:
	  Mentioning 'default' demo and some minor adaptions.

	* old-demos.fs: Added  demo default-0.1.0
	  Switch  elitism-off  in old demos.

	* README: Mentioning 'default' demo.

	* reporting.fs: file-scoring  unused yet.

	* INPUTS/experiments/sum/default-0.1.0.fs:
	Demo related to brew-0.1.0 default initialisation.

	* INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/default-0.1.0.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs:
	  <F12> gives  |goodbye|  instead of  goodbye .

2002-11-10  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-0.1-pre-0

	* DEVELOPMENT: brew-0.1.0 release pre test.

	* TAGS: Updated.

	* brew.fs: Polishing  start-help  and  |goodbye| .

	* brew-defaults.fs: Some minor adaptions.

	* NEXT: Updated.

	* texi/brew.info, texi/brew.texi:
	  Mentioning 'default' demo and some minor adaptions.

	* old-demos.fs: Added  demo default-0.1.0
	  Switch  elitism-off  in old demos.

	* README: Mentioning 'default' demo.

	* reporting.fs: file-scoring  unused yet.

	* INPUTS/experiments/sum/default-0.1.0.fs:
	Demo related to brew-0.1.0 default initialisation.

	* INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/default-0.1.0.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs:
	  <F12> gives  |goodbye|  instead of  goodbye .

2002-11-10  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi:
	  Mentioning 'default' demo and some minor adaptions.

	* old-demos.fs: Added  demo default-0.1.0
	  Switch  elitism-off  in old demos.

	* README: Mentioning 'default' demo.

	* reporting.fs: file-scoring  unused yet.

	* INPUTS/experiments/sum/default-0.1.0.fs:
	Demo related to brew-0.1.0 default initialisation.

	* INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/default-0.1.0.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs:
	  <F12> gives  |goodbye|  instead of  goodbye .

2002-11-09  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: fix-elitism-setup  as a small nice hack.

	* brew.fs: save-brew-variables  save elitism switch.

	* brew-basics.fs: Added  elitism-off .

	* brew.fs: nuc-menu  show score.

	* menu.fs: Fixed stack comment of  noop-entry .

	* brew-basics.fs: >message  use  string! .

2002-11-07  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi, brew.fs:
	  'Menu elite' edited.

2002-11-06  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi:
	Edited wording related to generated gene code.

2002-11-06  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi:
	Edited wording related to generated gene code.

2002-11-05  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Added score related colouring functions:
	  scoring>color  score>color  scoring-hit>bg-color

	* texi/brew.info, texi/brew.texi:
	  Document score related colouring functions:
	  scoring>color  score>color  scoring-hit>bg-color

	* brew-defaults.fs: Changed step display defaults:
	  Fixed code cost scan range.

	* texi/brew.info, texi/brew.texi:
	  Work on node 'Why Forth?'.

2002-11-04  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs:
	  Fixed code length scan display range.

	* INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/sum-init.fs:
	  Fixed code cost scan.

	* texi/brew.info, texi/brew.texi:
	  Use the term 'artificial code evolution'.

	* texi/brew.info, texi/brew.texi: More installation stuff.
	  Strengths of Forth for artificial code evolution:
	  Factorising and influence of stack flow.

2002-11-04  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs:
	  Fixed code length scan display range.

	* INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/sum/global-5-sum-elite-init.fs, INPUTS/experiments/sum/global-3-sum-elistic-init.fs, INPUTS/experiments/sum/global-3-sum-init.fs, INPUTS/experiments/sum/sum-init-elitistic.fs, INPUTS/experiments/sum/sum-init.fs:
	  Fixed code cost scan.

	* texi/brew.info, texi/brew.texi:
	  Use the term 'artificial code evolution'.

	* texi/brew.info, texi/brew.texi: More installation stuff.
	  Strengths of Forth for artificial code evolution:
	  Factorising and influence of stack flow.

2002-11-02  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: How to start a 80x25 console.

2002-11-01  Robert Epprecht  <epprecht@sunweb.ch>

	* TAGS: Updated.

	* texi/brew.info, texi/brew.texi:
	Different additions, edits and brew-0.1.0 adaptions.

	* VERSION-README, README-SECURITY, README: brew-0.1.0  adaptions.

	* NEXT: Updated.

	* benchmark-results.txt: brew-0.1.0  benchmark results.

	* DEVELOPMENT: Heading to release  brew-0.1.0

	* maybe-run-benchmark.fs: Updated.

2002-11-01  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi:
	Different additions, edits and brew-0.1.0 adaptions.

	* VERSION-README, README-SECURITY, README: brew-0.1.0  adaptions.

	* NEXT: Updated.

	* benchmark-results.txt: brew-0.1.0  benchmark results.

	* DEVELOPMENT: Heading to release  brew-0.1.0

	* maybe-run-benchmark.fs: Updated.

2002-10-31  Robert Epprecht  <epprecht@sunweb.ch>

	* NAMING: Edited.

2002-10-23  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-defaults.fs: Scan  code-cost  as second screen item.

2002-10-23  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-defaults.fs: Scan  code-cost  as second screen item.

2002-10-23  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-defaults.fs: Scan  code-cost  as second screen item.

2002-10-18  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/HOWTO: makeinfo --html --no-split
	  New version needs  --no-split .

2002-10-17  Robert Epprecht  <epprecht@sunweb.ch>

	* string-replace.fs, string-lists.fs:
	  Re-animated these two files (something went wrong last time...).

	* string-replace.fs: Re-adding file  string-replace.fs .

	* string-lists.fs: Re-added file  string-lists.fs .

	* string-replace.fs: Removed file  string-replace.fs .

	* string-lists.fs: Removed file  string-lists.fs .

	* brew.fs: Bugfix in  guess-scoring-function .
	  Obsolete:  string-lists.fs  and  string-replace.fs .
	  clone-cost  not defined any more (never used).

2002-10-17  Robert Epprecht  <epprecht@sunweb.ch>

	* string-replace.fs, string-lists.fs:
	  Re-animated these two files (something went wrong last time...).

	* string-replace.fs: Re-adding file  string-replace.fs .

	* string-lists.fs: Re-added file  string-lists.fs .

	* string-replace.fs: Removed file  string-replace.fs .

	* string-lists.fs: Removed file  string-lists.fs .

	* brew.fs: Bugfix in  guess-scoring-function .
	  Obsolete:  string-lists.fs  and  string-replace.fs .
	  clone-cost  not defined any more (never used).

2002-10-07  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: Eliminated  |>message| .

	* basics.fs: Added  (offset:)  using literal.
	  The old version seems to be slightly faster, though.

	* DEVELOPMENT, brew.fs, stringbuf-0.4.fs, statistics.fs, probability-lists.fs:
	  Use new OFFSET: taking bytes as parameters.

	* mutation-0.3.fs: Use new OFFSET: taking bytes as parameters.
	  Renamed  eb-entries#  to  eb-header-length .

	* menu.fs, lists.fs, genes-0.3.fs, gene-pool.fs, association-lists.fs, allocation-pointers.fs:
	  Use new OFFSET: taking bytes as parameters.

	* basics.fs: Offset taking au's (not cells) as parameters.
	  Factored out  (smart-offset:) .
	  Eliminated  -OFFSET:  N-OFFSET: .

	  Added:  bits/cell .

2002-10-06  Robert Epprecht  <epprecht@sunweb.ch>

	* genes.fs: removed genes.fs .

	* stringbuf-0.2.fs: Removed stringbuf-0.2.fs .

2002-10-02  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_39

	* TAGS: updated.

	* benchmark-results.txt: Results for brew-transit_39.
	  Please note that I use Debian woody, kernel 2.4.18 now.

	* DEVELOPMENT: Elitism integration in current version.
	  Extended possibilities for conditional compiling prepared.
	  Ekey mapping.

	* NEXT: Several new items added.

	* TODO: updated.

	* gforth.fs: Adapted ekey mapping to Debian woody.

	* keybuf.fs: ekey-outside  proposes to use  make-ekey-map.fs

	* make-ekey-map.fs: Better comments for the user
	  (when run and in the produced file).

2002-10-02  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_39

	* TAGS: updated.

	* benchmark-results.txt: Results for brew-transit_39.
	  Please note that I use Debian woody, kernel 2.4.18 now.

	* DEVELOPMENT: Elitism integration in current version.
	  Extended possibilities for conditional compiling prepared.
	  Ekey mapping.

	* NEXT: Several new items added.

	* TODO: updated.

	* gforth.fs: Adapted ekey mapping to Debian woody.

	* keybuf.fs: ekey-outside  proposes to use  make-ekey-map.fs

	* make-ekey-map.fs: Better comments for the user
	  (when run and in the produced file).

2002-09-21  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Give hints for elitisme:
	  .menu-population-elitistic
	  (if mutation-rate or trial-phase is not set to 1).

	* texi/brew.info, texi/brew.texi: .scoring and .score

	* brew-defaults.fs: Set fixed-population-size and elite.

	* INPUTS/experiments/sum/global-5-sum-elite-init.fs:
	Initialisation file for global-5-sum.fs.

	* INPUTS/experiments/sum/global-5-sum.fs:
	Add five global integer variables.

	* INPUTS/experiments/linear-equations/linear-1-float-elite-init.fs:
	linear-1-float  using elitisme.

	* INPUTS/experiments/linear-equations/linear-1-float.fs:
	score-linear-1-float

	* INPUTS/experiments/linear-equations/linear-1.fs: score-linear-1

2002-09-20  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/experiments/sum/global-3-sum-elistic-init.fs:
	Initialisation file for global-3-sum.fs
	  Using elitisme gives faster results.

	* INPUTS/experiments/sum/global-3-sum-init.fs:
	Initialisation file for global-3-sum.fs
	  Slow, but working.

	* INPUTS/experiments/sum/global-3-sum.fs:
	Sum experiment using three global variables:
	  The cells must add three global integer variables
	  and put the result in organ-A:
	  A = B + C + D

	* INPUTS/experiments/sum/sum-init.fs:
	Set fixed-population-size ,  elite .

	* brew.fs: Display slot scoring words:
	  .score  .scoring

	* INPUTS/experiments/sum/sum-init-elitistic.fs:
	Sum experiment using elitisme:
	  good, quick results.

	* INPUTS/experiments/sum/sum.fs: Added corresponding scoring function:
	  score-sum

	* brew.fs: Adaptions for elitisme (keeping compatibility):

	  Hack: guess scoring function when the user changes eat function:
	  guess-scoring-function .
	  List eat-actions: corresponding scoring functions as second data.
	  scoring-xt-UNDEFINED  as default for  scoring-xt .

	  New scoring functions for most old eat words:
	  all-score  score-A
	  score-basic-linear  score-simple-linear  score-linear
	  score-sum

	  New menu elite:
	  build-score-list  .elite-menu  score-list?  menu-elite
	  show-elite-genome

	* compile-switches.fs: Words for conditional compiling:
	  Words can be compiled, disregarded, or compiled in a way to be
	  switched on and off at run time.
	  An alternative else-part can be compiled depending on a compile
	  time or a run time condition.

	* code-chapters.txt: Moved:  Menu elite.

	* texi/TODO: Updated.

	* texi/brew.info, texi/brew.texi: Document elitism:
	  New nodes: 'Eat and consume'  'Elitisme'  'Menu elite'

	  Document new file 'compile-switches.fs'.

2002-09-14  Robert Epprecht  <epprecht@sunweb.ch>

	* gforth.fs: Use K1 to K5 for ekey mapping of function keys.
	  The others do not work here (Debian woody).

	* manual.fs: context-help  Clear screen after reading docu.
	  In some rare cases brew does not clear the whole screen,
	  so  context-help  does it.

2002-09-05  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Elitistic mode works, but is not too good integrated.

	* brew.fs: First implementation of elitisme.
	  Refactoring  nuc-do-all :
	  eat-and-pay  wake-nuc  ?show-nuc  nuc-do-&-live
	  scoring-xt  scoring  code-tax  score
	  score-and-list  |score-and-list|  nuc-do-&-list

	  ?init-score-list  fill-population
	  ?log-pop-control-elitism  ?elitism-pop-control

	  Adapted  menu-population
	  .menu-population  .menu-population-brew0  .menu-population-elitistic
	  toggle-elitism

	  Menu elite:  .elite-menu  score-list?  menu-elite
	  show-elite-genome

	* world-loop.fs: Slightly changed elitism implementation.
	  (But still very provisoric).

2002-09-01  Robert Epprecht  <epprecht@sunweb.ch>

	* code-chapters.txt: Menu elite.

	* worlds.fs: New world variables:
	  fixed-population-size  elite  score-list .

	* world-loop.fs: Renamed  ?elitism-prepare  to  ?init-score-list .

	* lists.fs: remove-node&following .

	* gene-edit.fs: |gene-edit-menu|  version taking nuc as argument.

2002-08-30  Robert Epprecht  <epprecht@sunweb.ch>

	* probability-lists.fs: Bugfix in  pick-one :
	  If random gives zero the first node was taken even if it's
	  probability was zero. Fixed.

2002-08-29  Robert Epprecht  <epprecht@sunweb.ch>

	* world-loop.fs: ?elitism-prepare  ?elitism-pop-control
	  (Both deferred, used in  world-loop ).

	* sorted-lists.fs: 2-insert-sorted .
	  (Used in elitism mode to build  population-list ).

	* iForth.fs: Adapted to current iForth version.

	* brew-basics.fs: Run mode mask  elitism .
	  elitism  (and  linear-mode ) should become world local soon.

	* DEVELOPMENT: Working on elitism.

2002-07-12  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi:
	  Updated node 'Menu global variables'.

	* brew.fs: menu-global-variables : set vars to a single value.
	  all-dfloat-integers-equal  all-dfloat-globals-equal

	  .globals-diversification-menu :
	  fixed overwriting of 'o' key binding.

	* brew.fs: globals-diversification-menu:
	  Switching whole diversification masks on and off.

2002-07-11  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/TODO: Updated.

	* texi/brew.info, texi/brew.texi:
	Global variables and their diversification.

	* brew.fs: Link from menu-global-variables to diversification.
	  |menu-diversify-global-vars| .

	* DEVELOPMENT: Introduced local integer and dfloat variables.

	* INPUTS/experiments/sum/sum-init.fs, benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, OUTPUT/rec-play/intro.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, old-demos.fs, brew-defaults.fs:
	  Renamed variables:
	  diversification-closeness  to  nuc-diversification-closeness .
	  (div-menu-nuc-or-spot)     to  (diversification-menu-type) ,
	  and do use named types for its value.

	* INPUTS/genes/global-integers.fs:
	  Gene primitives to read global integer variables.

	* INPUTS/genes/global-dfloats.fs:
	  Primitives to read global dfloat variables.

	* world-loop.fs: Do  ?diversify-globals .

	* compile-options.fs: Compile options for global variables:
	  global-integer-variables#  global-dfloat-variables# .

	* code-chapters.txt: 'Global variables'.

	* brew.fs: Introduced global variables.
	  global-int-variables  define-global-int-vars .
	  global-dfloat-variables  define-global-dfloat-vars .
	  menu-global-variables  .menu-global-variables
	  global-variables-men  (menu-global-vars-show-dfloats) .
	  include gene primitives:  global-integers.fs  global-dfloats.fs .

	  ?diversify-globals
	  ?diversify-global-integers  ?diversify-global-floats
	  global-i-diversification-rate  globals-diversification-range
	  globals-diversifctn-closeness  global-diversification-mask
	  global-df-div-mask  global-f-diversification-rate
	  global-f-diversification-range  global-f-diversification-factor .

	  Renamed:
	  diversification-closeness  to  nuc-diversification-closeness .

	  random-closeness-factor  takes closeness as argument.

	  Factored out  df-diversify-relative
	  use it in  nuc-df-diversify-relative  spot-df-diversify-relative

	  globals-diversification-menu  .globals-diversification-menu .

	  New:  locality-types  global%  spot-local%  nuc-local% .

	  Renamed  (div-menu-nuc-or-spot)  to  (diversification-menu-type)
	  cycle-div-menu-type .
	  Adapted  .diversification-menu .

	  New:  save-listed-int-variables  save-listed-dfloat-variables .

	  Bugfix in  .spot-diversification-menu  use right closeness.

	* benchmarks/mutations-1.fs, benchmarks/long-mutations.fs: removed.

	* benchmarks/displayed-bench.fs: removed from repository.

2002-06-24  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Fixed bug in  cvs"
	  (Thanks to Anton Ertl).

2002-06-23  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_38

	* DEVELOPMENT: Enable output redirection of benchmarks.

	* texi/brew.info, texi/brew.texi:
	Replaced all '@key{x}' by '@kbd{@key{x}}',
	  which gives better and more consistent results on 'pinfo'
	  (and possibly other info readers).

	* TAGS: Updated.

	* brew.fs: Enable output redirection in benchmarks.
	  (Do not use 'at?')  type./.  used by  .var-families .

2002-06-23  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_38

	* DEVELOPMENT: Enable output redirection of benchmarks.

	* texi/brew.info, texi/brew.texi:
	Replaced all '@key{x}' by '@kbd{@key{x}}',
	  which gives better and more consistent results on 'pinfo'
	  (and possibly other info readers).

	* TAGS: Updated.

	* brew.fs: Enable output redirection in benchmarks.
	  (Do not use 'at?')  type./.  used by  .var-families .

2002-06-23  Robert Epprecht  <epprecht@sunweb.ch>

	* TAGS: Updated.

	* brew.fs: Enable output redirection in benchmarks.
	  (Do not use 'at?')  type./.  used by  .var-families .

2002-06-18  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_37

	* TAGS: Updated.

	* NEXT: A few random items, more to come.

	* brew.fs: |big-bang|  record prior changes:
	  DEFERed  ?record-brew-changes  save-brew-before

	  nuc-error  (commented out).

2002-06-18  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_37

	* TAGS: Updated.

	* NEXT: A few random items, more to come.

	* brew.fs: |big-bang|  record prior changes:
	  DEFERed  ?record-brew-changes  save-brew-before

	  nuc-error  (commented out).

2002-06-01  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: |gene-edit-menu|  obsolete,
	  replaced by  gene-edit-menu .

	* gene-edit.fs: gene-edit-menu  implemented differently.
	  Shows changed genome after user changes.

	* gene-edit.fs: edit-genome : do nothing if genome not edited:
	  use  create-backup-file+  compare-to-backup .

	* brew-basics.fs: Backup file handling:
	  backup-file-name  create-backup-file+
	  compare-files  compare-to-backup .
	  Factored out  to-tmp-file-list  to-created-file-list .

2002-05-31  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: 'K' binding in  system-menu .

	* texi/brew.info, texi/brew.texi, iForth.fs, README:
	Mentioned suspected iForth incompatibility.

2002-05-30  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Updated key bindings.

	* brew.fs: Updated  .keybindings .
	  Number keys switch worlds in brew main screen now.
	  ?switch-world .

	* dynamic-key-bindings.fs: Key '1' remains free (for switching world).

2002-05-28  Robert Epprecht  <epprecht@sunweb.ch>

	* TODO, texi/TODO: Updated.

	* texi/brew.info, texi/brew.texi: Node 'Record after playback'.
	  Extended node 'Record and Playback'.
	  Renamed node 'Select world menu' to 'World list menu'.

	* brew.fs: Fixed default world name in  (clone-world) .
	  world-list-menu :  current world options have key bindings now.
	  Key binding 'O' in main screen to  world-list-menu .

	* brew-defaults.fs: world-list-menu on <F5>.

	* DEVELOPMENT: Continue recording after playback.
	  Cloning worlds.

	* worlds.fs: (remove-other-worlds) .

	* brew.fs:
	  Recording (restart from scratch) does  (remove-other-worlds) .
	  log-cat-step&spot  includes world# .

	* brew.fs: Continue recording after playback.
	  record-after-play  (just-played) .
	  Extended  .rec/play-menu  and added explanations for the user.
	  Switch playback off when done.

	* brew-basics.fs: OPEN-FILE+

	* brew.fs: menus-menu  include Worlds list.

	* brew.fs: select-world-menu  renamed to  world-list-menu
	  More selections for the user.
	  user-remove-world  |save-world-n|
	  clone-world-n  (clone-world)  replace-by-clone ?record-clone-world-n
	  Bugfix in  clone-geometry .
	  world-string  for:  |set-n'th-world|  save-world-parameters
	  and  (save-world)  |save-world|
	  Changed  .geometry

2002-05-27  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Recording and logging world name changes:
	  n'th-world-name-2!  input-n'th-world-name  ?record-world-name .

	  buffered" : Use string!! .
	  Added:  out-buffered .

	  Fixed logic in  |individuals-menu| .

2002-05-26  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: ?record-remove-all-wolds
	  Moved to  worlds.fs :
	  (set-n'th-world)  set-n'th-world  ?record-set-n'th-world

	* worlds.fs: remove-all-worlds  DEFER ?record-remove-all-wolds .
	  (remove-world)  not recording nor logging.

	  Moved here:  (set-n'th-world)  set-n'th-world
	  DEFER ?record-set-n'th-world .

	* brew.fs: record-as-outfile .

	* brew.fs: Recording and logging:
	  (free-field)  free-field  |free-field| .
	  Logging:  |big-bang|  big-bang-2out  ?log-big-bang .
	  ?record-set-n'th-world  gives world name in comment.
	  user-remove-world  give feedback.

	  Use  cat-and-out  everywhere.

	* worlds.fs: DEFER (free-field)  not recording.

	* brew.fs: Use  world-name2@ .
	  ?record-big-bang  world name in comment.

	* worlds.fs: world-name2@

	* brew.fs: Bugfix (typo) in  |set-n'th-world| .

	* brew.fs: Recording and logging of  set-n'th-world :
	  (set-n'th-world)  set-n'th-world  ?record-set-n'th-world
	  |set-n'th-world| .

	  .select-world-menu  uses non recording  (set-n'th-world)  now.

	* brew.fs: Logging user removing world:
	  Renamed  |remove-world|  to  user-remove-world .
	  New  |remove-world|  does log user.

	* worlds.fs:
	No, reverted. User interaction gets logged in  |remove-world|

	* worlds.fs: log-user  in  remove-world .

	* brew.fs: Bugfix:  recording  set-n'th-world .

2002-05-25  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Selecting other worlds, remove worlds.

	* brew.fs: Rearranged world menu.

	* texi/TODO: Updated.

	* texi/brew.info, texi/brew.texi: Node 'Select world menu'.
	  World and Big Bang menus updated.
	  File  NEXT .
	  Old files and references deleted.

	* brew.fs: Finished some display details around last check in.

	* brew.fs: Using worlds list:
	  set-n'th-world  ?record-set-n'th-world
	  select-world-menu  .select-world-menu  select-world-men  .geometry

	  big-bang-menu :  clone-geometry .  Give more feedback.

	  world-menu :  change worlds name, select world, remove world.
	  Simplified dealing with compile options.
	  ?create-a-world  |remove-world|  ?record-remove-world

	  More intelligent 'I' key binding in main screen:
	  individual-on-spot  |individuals-menu|
	  free-field  is deferred now.

	* world-spots-localized.fs, world-spots-arrayed.fs:
	(big-bang)  sets a default  world-name .

	* worlds.fs: world-name  containing string handle.
	  remove-world  DEFER ?record-remove-world  and  free-field .

	* world-spots-localized.fs, world-spots-arrayed.fs:
	(big-bang)  puts world into  worlds  list.

	* worlds.fs: List  worlds .
	  worlds#  world# .

	* brew-basics.fs: ./.  moved here.

2002-05-24  Robert Epprecht  <epprecht@sunweb.ch>

	* NEXT: Ideas, thoughts and todo items for next compatibility break.

	* DEVELOPMENT: Dropped support for old world implementation.

	* brew.fs: Dropped support for old world implementation.
	  Changed  .brew-version  and  .version .

	* compile-options.fs: Dropped support for old world implementation.
	  new-worlds  obsolete, removed.

	* maybe-do.fs: Dummy  init-df-expr-xts-spot  if no spot floats.

	* old-world-loop.fs, old-world.fs:
	Old world implementation no longer supported.

	* texi/brew.info, texi/brew.texi, brew.fs:
	System menu displays brew identity.

	* reporting.fs: Changed code file mask sequence.

	* maybe-run-benchmark.fs, README: Updated.

	* texi/brew.info, texi/brew.texi: Updated node 'Code file menu'.

	* brew.fs: .version  and  .brew-version  don't show  stringbuf-version
	  Allow writing only structure to code files on trial success also.

	* mutation-0.3.fs:
	  Allow writing only structure to code files also on trial success.

	* DEVELOPMENT: Dropped support for stringbuf-0.3.fs .
	  Deleted a lot of old stuff from TODO files, BUGS and the like.

2002-05-23  Robert Epprecht  <epprecht@sunweb.ch>

	* reporting.fs: Code file mask  file-start&stop-entries  obsolete.

	* compile-options.fs: Old stringbufs obsolete.
	  Removed compile option  new-stringbufs .

	* brew.fs: Old stringbufs obsolete.

	* stringbuf-0.3.fs: Dropped support for old stringbuf implementation.

	* texi/TODO, TODO, BUGS: Removed old items.

	* stacked-variables.fs: Removed as it was never used.

	* benchmarks/simple-bench.fs:
	Not compatible to decent brew versions, removed.

	* DEVELOPMENT:
	  Dropped support for old genes and mutation implementation.

	* brew.fs: Depreciated old genes/mutation implementation.

	* mutation-0.2.fs:
	Removed support for old genes/mutation implementation.

	* genes-0.2.fs: Removed support for old gene/mutation support.

	* brew-init.fs, benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1.fs, INPUTS/experiments/linear-equations/linear-1-float.fs, gene-pool.fs:
	Depreciated old genes/mutation implementation.

	* compile-options.fs: Depreciated old genes/mutation implementation.
	  new-genes  obsolete.

	* cvs-tags: brew-transit_36

	* TAGS: Updated.

	* brew.fs: Displaying text in pages while interpreting (README) files:
	  ?.(  Currently unused.

	* texi/brew.info, texi/brew.texi, brew.fs:
	mutation-menu :  reset-nuc-masks? .

	* texi/brew.info, texi/brew.texi: New files:
	  brew/INPUTS/individuals/  directory.
	  INPUTS/individuals/old-brew-individuals.fs

	  dynamic-key-bindings.fs  mixed-old-stuff.fs  old-demos.fs .

	* texi/TODO: Updated.

	* DEVELOPMENT:
	Factoring out individuals and old stuff to separate files.

	* INPUTS/individuals/old-brew-individuals.fs:
	Factored out old individual(s).
	  Yuppie .

	* old-demos.fs: Factored out old demos. REQUIREd from  demo-menu .

	* mixed-old-stuff.fs: Factored out old stuff from brew.fs
	  Well be obsolete soon, when the old benchmars, demos and benchmarks
	  will get dropped.

	* dynamic-key-bindings.fs:
	Hack:  Dynamically set some key bindings in  .brew
	  based on definedness of functions by interpreting this file.

	* brew.fs: Factoring out some stuff to separate files:
	  Individuals are in  individuals-dir .
	  Yuppie  is in  old-brew-individuals.fs .
	  Mixed old stuff in  mixed-old-stuff.fs .
	  Old demos in  old-demos.fs ,  demo-menu  REQUIREs it.

	  Not included in  save-brew-variables  any more:
	  (A-scale)  (B-scale)  (C-scale)  which are too seldom used.

	  Hack:  Dynamically set some key bindings in  .brew  based on
	  definedness of functions by interpreting  dynamic-key-bindings.fs .

	  (none)  as *first* individual in  individuals  list.

	* benchmarks/simple-bench.fs:
	Not setting  (A-scale)  (B-scale)  (C-scale) .
	  Defining  Yuppie  if it's not here.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, brew-defaults.fs:
	Not setting  (A-scale)  (B-scale)  (C-scale) .

	* gene-edit.fs: 'l' key binding in  gene-edit-menu  for convenience.

	* brew-basics.fs: individuals-dir .

2002-05-23  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_36

	* TAGS: Updated.

	* brew.fs: Displaying text in pages while interpreting (README) files:
	  ?.(  Currently unused.

	* texi/brew.info, texi/brew.texi, brew.fs:
	mutation-menu :  reset-nuc-masks? .

	* texi/brew.info, texi/brew.texi: New files:
	  brew/INPUTS/individuals/  directory.
	  INPUTS/individuals/old-brew-individuals.fs

	  dynamic-key-bindings.fs  mixed-old-stuff.fs  old-demos.fs .

	* texi/TODO: Updated.

	* DEVELOPMENT:
	Factoring out individuals and old stuff to separate files.

	* INPUTS/individuals/old-brew-individuals.fs:
	Factored out old individual(s).
	  Yuppie .

	* old-demos.fs: Factored out old demos. REQUIREd from  demo-menu .

	* mixed-old-stuff.fs: Factored out old stuff from brew.fs
	  Well be obsolete soon, when the old benchmars, demos and benchmarks
	  will get dropped.

	* dynamic-key-bindings.fs:
	Hack:  Dynamically set some key bindings in  .brew
	  based on definedness of functions by interpreting this file.

	* brew.fs: Factoring out some stuff to separate files:
	  Individuals are in  individuals-dir .
	  Yuppie  is in  old-brew-individuals.fs .
	  Mixed old stuff in  mixed-old-stuff.fs .
	  Old demos in  old-demos.fs ,  demo-menu  REQUIREs it.

	  Not included in  save-brew-variables  any more:
	  (A-scale)  (B-scale)  (C-scale)  which are too seldom used.

	  Hack:  Dynamically set some key bindings in  .brew  based on
	  definedness of functions by interpreting  dynamic-key-bindings.fs .

	  (none)  as *first* individual in  individuals  list.

	* benchmarks/simple-bench.fs:
	Not setting  (A-scale)  (B-scale)  (C-scale) .
	  Defining  Yuppie  if it's not here.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, brew-defaults.fs:
	Not setting  (A-scale)  (B-scale)  (C-scale) .

	* gene-edit.fs: 'l' key binding in  gene-edit-menu  for convenience.

	* brew-basics.fs: individuals-dir .

2002-05-23  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Displaying text in pages while interpreting (README) files:
	  ?.(  Currently unused.

	* texi/brew.info, texi/brew.texi, brew.fs:
	mutation-menu :  reset-nuc-masks? .

	* texi/brew.info, texi/brew.texi: New files:
	  brew/INPUTS/individuals/  directory.
	  INPUTS/individuals/old-brew-individuals.fs

	  dynamic-key-bindings.fs  mixed-old-stuff.fs  old-demos.fs .

	* texi/TODO: Updated.

	* DEVELOPMENT:
	Factoring out individuals and old stuff to separate files.

	* INPUTS/individuals/old-brew-individuals.fs:
	Factored out old individual(s).
	  Yuppie .

	* old-demos.fs: Factored out old demos. REQUIREd from  demo-menu .

	* mixed-old-stuff.fs: Factored out old stuff from brew.fs
	  Well be obsolete soon, when the old benchmars, demos and benchmarks
	  will get dropped.

	* dynamic-key-bindings.fs:
	Hack:  Dynamically set some key bindings in  .brew
	  based on definedness of functions by interpreting this file.

	* brew.fs: Factoring out some stuff to separate files:
	  Individuals are in  individuals-dir .
	  Yuppie  is in  old-brew-individuals.fs .
	  Mixed old stuff in  mixed-old-stuff.fs .
	  Old demos in  old-demos.fs ,  demo-menu  REQUIREs it.

	  Not included in  save-brew-variables  any more:
	  (A-scale)  (B-scale)  (C-scale)  which are too seldom used.

	  Hack:  Dynamically set some key bindings in  .brew  based on
	  definedness of functions by interpreting  dynamic-key-bindings.fs .

	  (none)  as *first* individual in  individuals  list.

	* benchmarks/simple-bench.fs:
	Not setting  (A-scale)  (B-scale)  (C-scale) .
	  Defining  Yuppie  if it's not here.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, brew-defaults.fs:
	Not setting  (A-scale)  (B-scale)  (C-scale) .

	* gene-edit.fs: 'l' key binding in  gene-edit-menu  for convenience.

	* brew-basics.fs: individuals-dir .

2002-05-23  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: New files:
	  brew/INPUTS/individuals/  directory.
	  INPUTS/individuals/old-brew-individuals.fs

	  dynamic-key-bindings.fs  mixed-old-stuff.fs  old-demos.fs .

	* texi/TODO: Updated.

	* DEVELOPMENT:
	Factoring out individuals and old stuff to separate files.

	* INPUTS/individuals/old-brew-individuals.fs:
	Factored out old individual(s).
	  Yuppie .

	* old-demos.fs: Factored out old demos. REQUIREd from  demo-menu .

	* mixed-old-stuff.fs: Factored out old stuff from brew.fs
	  Well be obsolete soon, when the old benchmars, demos and benchmarks
	  will get dropped.

	* dynamic-key-bindings.fs:
	Hack:  Dynamically set some key bindings in  .brew
	  based on definedness of functions by interpreting this file.

	* brew.fs: Factoring out some stuff to separate files:
	  Individuals are in  individuals-dir .
	  Yuppie  is in  old-brew-individuals.fs .
	  Mixed old stuff in  mixed-old-stuff.fs .
	  Old demos in  old-demos.fs ,  demo-menu  REQUIREs it.

	  Not included in  save-brew-variables  any more:
	  (A-scale)  (B-scale)  (C-scale)  which are too seldom used.

	  Hack:  Dynamically set some key bindings in  .brew  based on
	  definedness of functions by interpreting  dynamic-key-bindings.fs .

	  (none)  as *first* individual in  individuals  list.

	* benchmarks/simple-bench.fs:
	Not setting  (A-scale)  (B-scale)  (C-scale) .
	  Defining  Yuppie  if it's not here.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, brew-defaults.fs:
	Not setting  (A-scale)  (B-scale)  (C-scale) .

	* gene-edit.fs: 'l' key binding in  gene-edit-menu  for convenience.

	* brew-basics.fs: individuals-dir .

2002-05-22  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Changed nuc-var order.
	  goodbye  displays  (identity) .

	  ./.
	  .var-families  displays nuc *and* spot vars.
	  replaces  .i-families  and  .f-families .

	  ?|see-genome-or-spot|  deals with  (manually-selected-cell) .

	* OUTPUT/tmp/README-tmp: Comment about automatic cleanup of tmp files.

	* brew-basics.fs: Variable  (identity) .

	* genes-0.3.fs: .gene-info :  allow  nuc-bitmasks#  to be zero.

2002-05-22  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Changed nuc-var order.
	  goodbye  displays  (identity) .

	  ./.
	  .var-families  displays nuc *and* spot vars.
	  replaces  .i-families  and  .f-families .

	  ?|see-genome-or-spot|  deals with  (manually-selected-cell) .

	* OUTPUT/tmp/README-tmp: Comment about automatic cleanup of tmp files.

	* brew-basics.fs: Variable  (identity) .

	* genes-0.3.fs: .gene-info :  allow  nuc-bitmasks#  to be zero.

2002-05-21  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: New mechanism to set diversification bit masks.

	* gene-edit.fs: Link to  .gene-info  from  gene-edit-menu .
	  .gene-decompilation-list  deleted .

	* brew.fs: Adaptions to new diversification bit maps setting:
	  nuc-bitmasks# .  Save  reset-nuc-masks? .

	  Bugfix in  nuc-menu .
	  ?|see-genome-or-spot|  uses  |gene-edit-menu| .

	* INPUTS/genes/float-stack.fs:
	drop(float-pointer)  as alternative  drop .

	* INPUTS/genes/organs.fs, INPUTS/genes/nuc-parameters.fs, INPUTS/genes/float-parameters.fs, INPUTS/genes/float-organs.fs:
	Set internal diversification bit mask.

	* INPUTS/extensions/debugging/brew-crash-test.fs, benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, benchmarks/simple-bench.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, brew-defaults.fs:
	Set  reset-nuc-masks? .

	* mutation-0.3.fs: New mechanism to set diversification bit-maps:
	  xt-to-internals-buffer  sets internal bit masks.
	  reset-nuc-masks?  set nuc masks absolutely or  OR  them?
	  ?set-nuc-masks  sets nuc masks.  Called from  set-up-trial .

	  Eliminated:
	    organ-string  parameter-string  f-organ-string  f-parameter-string
	    log-my-div-bitmask  log-item-bitmask  set-diversification-bits .

	  Old wrong comments deleted.

	* genes-0.3.fs: New bit mask implementation (diversification masks):
	  >set-mask0  and nuc-bitmasks# 1- unnamed internal variables.
	  set-mask
	  factored out:  gene-flag!
	  gene-set-mask!  gene-set-mask!  use it.
	  set-mask?  gene-n'th-mask-or!
	  Extended  .gene-info
	  ?set-internal-masks  called from  xt-to-internals-buffer .
	  scratch-masks  clear-scratch-masks  scratch-masks?
	  Adapted  GENE:  to set masks.

2002-05-20  Robert Epprecht  <epprecht@sunweb.ch>

	* genes-0.2.fs: .gene-info  use  .bin .

	* basics.fs: or!

2002-05-18  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_35

	* TAGS: Updated.

	* benchmark-results.txt: brew-transit_35 results.
	  Removed prior measurements taken with an prior transit_35 version.

	* TODO: Updated.

	* DEVELOPMENT: Edit gene menu for trial genomes also.
	  Removing temporary files on exit and listing output files.
	  Save all nucs, save all spots.

	* brew.fs: Make bigforth happy:
	  Space after included file names.

	* brew.fs: Use  ?remove-tmp-files  (was:  remove-tmp-files ).

	* brew-basics.fs: Avoid  tmp-files-list  in benchmarks:
	  Do not create file until first use.
	  tmp-files  ?create-tmp-file-list
	  Changed  CREATE-tmp-FILE .
	  Changed  ?remove-tmp-files  (was:  remove-tmp-files ).

	* brew.fs: Skip file actions in goodbye after benchmarks.

	* brew-basics.fs: Avoid  created-files-list  in benchmarks.
	  do not create file until first use.

	* brew.fs: Better display managment in  goodbye .

	* brew-basics.fs: Better display managment on exit:
	  remove-tmp-files  ?list-created-files .

	* texi/brew.info, texi/brew.texi:
	Editing genomes by hand: node 'Gene edit menu'.
	  Quitting brew from system menu (and other).
	  New node 'Temporary files'.  Cleaning up temporary files.
	  Display and filing of output files.
	  'Save world' and 'Save all nucs'.
	  Files:  string-lists.fs  string-replace.fs
	  gene-edit.fs  gene-alternatives.fs
	  brew-identity  created-files_nnn  tmp-files_nnn

	* texi/TODO: Updated.

	* brew.fs: Quitting brew from system menu.  |goodbye| .

	* brew-basics.fs: Renamed file  brew.identity  to  brew-identity .
	  ?list-created-files  displays  brew-version  on exit.

	* brew.fs: Listing created output files in a file displayed on exit.
	  ?list-created-files  in  goodbye .

	  Use  CREATE-FILE+  in:
	  |open-new-outfile|  (types file name now),  assert-state-entry
	  record files.

	* reporting.fs: Use  CREATE-FILE+  on  log and code files.

	* profiling.fs: Use  CREATE-FILE+  on  brew-profile .

	* make-ekey-map.fs: Use  CREATE-FILE+  on  ekey-mapping.fs .

	* brew-basics.fs: Keeping trace of produced output files:
	  Listing output files in a file and displaying them on exit.
	  created-files-list  (created-files-list-ID)  ?list-created-files
	  created-files  CREATE-FILE+
	  create-named-file (uses CREATE-FILE+ now)  open-named-file  here now.

	* basics.fs:
	  create-named-file  open-named-file  moved to  brew-basics.fs .

2002-05-17  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Editing genomes by hand:
	  include gene-alternatives.fs
	  Link from  nuc-menu  to  |gene-edit-menu|  (instead of see-genome).

	  Factored out chapter 'File output' from 'Save brew'.
	  Added:  close-outfile  cat-and-out .  Use them.

	  save-nucs-genes-trial
	  Load multiline gene definitions:
	  accumulate  accumulate-end-mark

	  Factored out  |open-new-outfile|  from  |save-brew-variables| .

	  Saving all spot data or all nuc data:
	  save-spot  save-world  |save-world|
	  save-nuc&spot  save-all-nucs  |save-all-nucs|
	  Links from system menu to  |save-world|  and  |save-all-nucs| .

	* gene-edit.fs: Remove produced lists:
	  Use  remove-list-recursively .

	  Gene alternatives stuff factored out to  gene-alternatives.fs .
	  Better dealing with  follow-&-add  error messages.

	  gene-edit-menu  can deal with genomes on trial now.
	  |gene-edit-menu|  same.

	* gene-alternatives.fs:
	Tools to help brew finding the right type variant of user input genes.

2002-05-18  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_35

	* TAGS: Updated.

	* benchmark-results.txt: brew-transit_35 results.
	  Removed prior measurements taken with an prior transit_35 version.

	* TODO: Updated.

	* DEVELOPMENT: Edit gene menu for trial genomes also.
	  Removing temporary files on exit and listing output files.
	  Save all nucs, save all spots.

	* brew.fs: Make bigforth happy:
	  Space after included file names.

	* brew.fs: Use  ?remove-tmp-files  (was:  remove-tmp-files ).

	* brew-basics.fs: Avoid  tmp-files-list  in benchmarks:
	  Do not create file until first use.
	  tmp-files  ?create-tmp-file-list
	  Changed  CREATE-tmp-FILE .
	  Changed  ?remove-tmp-files  (was:  remove-tmp-files ).

	* brew.fs: Skip file actions in goodbye after benchmarks.

	* brew-basics.fs: Avoid  created-files-list  in benchmarks.
	  do not create file until first use.

	* brew.fs: Better display managment in  goodbye .

	* brew-basics.fs: Better display managment on exit:
	  remove-tmp-files  ?list-created-files .

	* texi/brew.info, texi/brew.texi:
	Editing genomes by hand: node 'Gene edit menu'.
	  Quitting brew from system menu (and other).
	  New node 'Temporary files'.  Cleaning up temporary files.
	  Display and filing of output files.
	  'Save world' and 'Save all nucs'.
	  Files:  string-lists.fs  string-replace.fs
	  gene-edit.fs  gene-alternatives.fs
	  brew-identity  created-files_nnn  tmp-files_nnn

	* texi/TODO: Updated.

	* brew.fs: Quitting brew from system menu.  |goodbye| .

	* brew-basics.fs: Renamed file  brew.identity  to  brew-identity .
	  ?list-created-files  displays  brew-version  on exit.

	* brew.fs: Listing created output files in a file displayed on exit.
	  ?list-created-files  in  goodbye .

	  Use  CREATE-FILE+  in:
	  |open-new-outfile|  (types file name now),  assert-state-entry
	  record files.

	* reporting.fs: Use  CREATE-FILE+  on  log and code files.

	* profiling.fs: Use  CREATE-FILE+  on  brew-profile .

	* make-ekey-map.fs: Use  CREATE-FILE+  on  ekey-mapping.fs .

	* brew-basics.fs: Keeping trace of produced output files:
	  Listing output files in a file and displaying them on exit.
	  created-files-list  (created-files-list-ID)  ?list-created-files
	  created-files  CREATE-FILE+
	  create-named-file (uses CREATE-FILE+ now)  open-named-file  here now.

	* basics.fs:
	  create-named-file  open-named-file  moved to  brew-basics.fs .

2002-05-17  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Editing genomes by hand:
	  include gene-alternatives.fs
	  Link from  nuc-menu  to  |gene-edit-menu|  (instead of see-genome).

	  Factored out chapter 'File output' from 'Save brew'.
	  Added:  close-outfile  cat-and-out .  Use them.

	  save-nucs-genes-trial
	  Load multiline gene definitions:
	  accumulate  accumulate-end-mark

	  Factored out  |open-new-outfile|  from  |save-brew-variables| .

	  Saving all spot data or all nuc data:
	  save-spot  save-world  |save-world|
	  save-nuc&spot  save-all-nucs  |save-all-nucs|
	  Links from system menu to  |save-world|  and  |save-all-nucs| .

	* gene-edit.fs: Remove produced lists:
	  Use  remove-list-recursively .

	  Gene alternatives stuff factored out to  gene-alternatives.fs .
	  Better dealing with  follow-&-add  error messages.

	  gene-edit-menu  can deal with genomes on trial now.
	  |gene-edit-menu|  same.

	* gene-alternatives.fs:
	Tools to help brew finding the right type variant of user input genes.

	* code-chapters.txt: Factored out 'File output'.

	* INPUTS/genes/basic-stack.fs: Use  as-alternative'' .
	  To allow user input I define all type variants as alternatives,
	  including those which are not visible to mutation.

	* lists.fs: remove-list-recursively .

2002-05-16  Robert Epprecht  <epprecht@sunweb.ch>

	* gene-edit.fs: Log user genome input.
	  remove-gene-delimiters  |compile-from-string|
	  out-trial-gene  write-trial-gene-tmp-file
	  compile-from-last-tmp-file  returns a flag now.
	  ?log-edit-genome .

	  Linked  edit-genome  from  gene-edit-menu .
	  |gene-edit-menu|  editing the genome of this nuc.

	* basics.fs: bl-skip_  counting sister of  bl-skip .

	* brew-basics.fs: Switchable individual or common tmp file list.
	  Defaults to separate lists for each individual brew.

	* brew-basics.fs: Version with only one tmp file list.
	  But one brew could remove the others tmp files...

2002-05-15  Robert Epprecht  <epprecht@sunweb.ch>

	* gene-edit.fs: Editing genes by hand.
	  Formatted display and saving of decompiled internals genes.
	  Editing and recompiling gene files, setting up trial phase.
	  gene-edit-menu

	  Work in progress...

	* TODO: Updated.

	* DEVELOPMENT: Editing genes by hand.
	  Float value types checks.
	  Unique tmp file names make running multiple brew possible.
	  Removing tmp files on exit.
	  First time users documentation.
	  Plans.

	* code-chapters.txt: gene-edit.fs

	* brew.fs: Adaptions for editing genes by hand:
	  include string-lists.fs
	  include string-replace.fs
	  include gene-edit.fs

	  remove-tmp-files  back in  goodbye  leaving  <goodbye-actions>
	  a noop.

	* compile-options.fs: editor .

	* mutation-0.3.fs: Adaptions for  gene-edit :
	  gene-follow  use  |stack-symbols-mismatch  to THROW.
	  frame-cost  is set in  set-up-trial .

2002-05-14  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: Changed  (none)  back to be a noop.

	  Added:  unique-string  unique-identity-string .
	  (unique#)  moved here.

	* basics.fs: bl?  bl-skip  skip-until-char  next-word

	* lists.fs: Added  last-node  to-last-nodes-sublist! .

	* maybe-do.fs: Fvariable (no-one)  used instead of  (none) .

	* string-replace.fs:
	Build tables of strings, use them for string replacements.

	* string-lists.fs: Lists of string buffer handles.

	* brew.fs: remove-tmp-files  in  <goodbye-actions> .
	  Use  at-x? .

	  Color menu: If the user chages a colour function it is automatically
	  activated:  select-fg-colour  select-bg-colour

	  Factored out  unique-string  and use it.

	  before/after-file-name  use unique file names.
	  save-before/after  use  CREATE-tmp-FILE .

	  nuc-changed?  use  unique-identity-string  CREATE-tmp-FILE .

	* brew-basics.fs: Use unique file names for tmp files:
	  CREATE-tmp-FILE  (last-tmp-file-id)  (last-tmp-file-name)
	  reopen-last-tmp-file

	  New throw code  |stack-symbols-mismatch

2002-05-11  Robert Epprecht  <epprecht@sunweb.ch>

	* basics.fs: Added  fifth.
	  My shame, I actually used it ;-)

	* genes-0.3.fs: .gene-info  edited.

	* stringbuf-0.3.fs, stringbuf-0.4.fs: Added  string!!

2002-05-10  Robert Epprecht  <epprecht@sunweb.ch>

	* menu.fs: Use  at-x? .

	* brew-basics.fs: Each running brew get's it's own identity:
	  define-brew-identity  indentity-string

	  Unique temporary files names and a list of them to clean up.
	  tmp-files-file  (tmp-file-list-id)  CREATE-tmp-FILE  remove-tmp-files

	  at-x?

2002-05-09  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/TODO: Updated.

	* texi/brew.info, texi/brew.texi: Edited beginners entry level nodes.
	  Manual top node links.

2002-05-08  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Top docu node link from menus-menu and system menu.
	  '?' in  .keybindings .

	* genes-0.3.fs: Comments about planed internal flags and data.

	* manual.fs: manual  calls top documentation node.

	* brew.fs: Scan menu links allow changing data, so we ?rescan
	  ?rescan-nucs  ?rescan-spots
	  Used in  .menu-nuc-scan  .menu-spot-scan  *display* words.

	* texi/brew.info, texi/brew.texi: Document scan to subsets menu links.
	  Float value type colouring words.

	* maybe-do.fs: Float value type checks as expressions:
	  df-var-real? df-var-inf? df-var-pos-inf? df-var-neg-inf? df-var-nan?
	  Adapted  maybe-string  maybe-FORTH-string

	  Interfaces to some subsets (used for subset menus):
	  do-in-simple-subset  do-in-int-value-subset
	  do-in-float-type-subset  do-in-dfloat-value-subset .

	* brew.fs: More menu links to subsets from scan results:
	  Changed  .menu-nuc-scan  .menu-spot-scan, use
	  simple-nuc-subset  dfloat-type-nuc-subset
	  dfloat-value-nuc-subset  int-value-nuc-subset
	  simple-spot-subset  dfloat-type-spot-subset
	  dfloat-value-spot-subset  int-value-spot-subset

	  Edited member/total display in  menu-nuc-scan  menu-spot-scan

	  Renamed  maybe-expr-is-float?  to  needs-float-condition?  adapted.
	  Simplified  maybe-fix-condition

	  Float type dependent colouring:
	  nuc-all-real>color  nuc-has-unreal>color
	  nuc-inf?>color  nuc-neg-inf?>color  nuc+inf?>color  nuc-nan?>color
	  spot-all-real>color  spot-has-unreal>color
	  spot-inf?>color  spot-neg-inf?>color  spot+inf?>color  spot-nan?>color

2002-05-06  Robert Epprecht  <epprecht@sunweb.ch>

	* maybe-do.fs: Dfloat exception checks as simple expressions:
	  nuc-all-real?  nuc-has-unreal?  nuc-with-nan?
	  nuc-with-inf?  nuc-with-neg-inf?  nuc-with-pos-inf?
	  spot-all-real?  spot-has-unreal?  spot-with-nan?
	  spot-with-inf?  spot-with-neg-inf?  spot-with-pos-inf?

	* brew.fs: Check all dfloat nuc or spot variables for exceptions:
	  nuc-all-real?  nuc-has-unreal?  nuc-with-nan?
	  nuc-with-inf?  nuc-with-neg-inf?  nuc-with-pos-inf?
	  spot-all-real?  spot-has-unreal?  spot-with-nan?
	  spot-with-inf?  spot-with-neg-inf?  spot-with-pos-inf?

	* menu.fs: nan  (if not defined).

	* basics.fs: nan

	* benchmark-results.txt:
	Results do not differ much with  brew.fs,v 1.333

	* brew.fs: Bugfix in detailed step-display-menu:
	  lines-and-v-range-entry  use  simple-menu-entry-value .
	  ?step-zoom-entries       use  change-scale-at-addr-entry
	  Added entry for zooming or fixed range.
	  ?step-color-entries      use  choose-xt-entry .

	* menu.fs: change-scale-at-addr-entry

	* brew.fs: Bugfix: scans with fixed zero range:
	   New scan flag mask  dfloat-scan .
	   set-scan-var-type
	   scan-horizontal-zoom?  disregards fixed range if range is zero.
	   Use it everywhere.

2002-05-05  Robert Epprecht  <epprecht@sunweb.ch>

	* benchmark-results.txt: brew-transit_35 results.

	* DEVELOPMENT:
	  Enter xt's by hand in  choose-xt-menu  by pressing key "'".
	  Continuous display for floats finished.

	* TODO: Updated.

	* texi/brew.info, texi/brew.texi: Detailed float scans.
	  Float type counts.

	  Entering xt's by hand.
	  Node  'Colours in menus'.
	  Many other adaptions, changes and corrections.

	* texi/TODO: Updated.

	* brew.fs: Compiling without dfloats:
	  Defined anyway (even if there are no floats):
	  list:  dfloat-nuc-vars  nuc-df-scan-limit
	  nuc-var-is-float?  |nuc-addr|

	  Extended use of conditional compiling on many places.

	* maybe-do.fs: f>$  make shorter strings.
	  MAYBE-DO-FIELD:  Use  (none)  as variable default,
	  not  noop .

	* menu.fs: Manually entering xt's in  .choose-xt-menu :
	  xt-user-input  got a bit smarter.

	* brew.fs: Fix dfloat ranges in continuous display:
	  cont-var-type!  resets limits if the type has changed.
	  cont-float-out
	  Adapted  save-continuous-display .

	  Saving dfloats: new factoring  buffered-dfloat-addr!
	  save-dfloat-variable  buffered-float!  out-dfloat-buffered

	  listed-enum>string  to save listed enums as text.

	* brew-basics.fs: Use  LISTED-ENUM:  variable-types .

	* basics.fs: LISTED-ENUM:  fixed comment.

2002-05-03  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Bugfix in  generic-range>bg-color .

	* brew-basics.fs: accept-evaluate  (accept-evaluate) .

	* menu.fs: choose-xt-menu  enter xt by hand on key "'":
	  looks-like-named-xt?  xt-user-input .

2002-05-02  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: (none)  defined as FVARIABLE as savety guard.

	* menu.fs: Minor edits.

	* brew.fs: Bugfixes:
	  generic-range>fg-color  coloured-on-range-possible?

	  Packed  maybe-fix-condition  into  maybe-fix .
	  Use it in all menus on all changed maybe do fields to avoid crashes.

	  '`' key binding for  toggle-highlite-active
	  ('`' is on the key next to '?' on my keyboard, take another one).

	* DEVELOPMENT: Continuous display for floats (and redisplay).

	* brew.fs: Continuous display for dfloats:
	  |nuc-addr|  generic word for ints and floats.
	  Continuous data aquisition words return integer or dfloat and a flag.
	  cont@  get-variable  nuc-min  nuc-max  nuc-range  nuc-average
	  spot-i-2-dfloat-min  spot-i-2-dfloat-max  spot-i-2-dfloat-avr
	  spot-min  spot-max  spot-range  spot-average .
	  >cont-lower  and  >cont-upper  are used for both, ints and dfloats.
	  New:  >cont-var-type  (type-integer%  or  type-dfloat%)
	  Adapted  check-continuous-display-sanity  continuous-display
	  .menu-continuous-display

	  Continuous display gathers data for redisplay now:
	  >cont-redisplay-data  (cont-drawn-at-step)  redisplay-cont-display

	  Changed  (step-redisplay)  use  redisplaying!
	  Bugfix:  2brew-redisplay  restores cursor more often.

	* menu.fs: menu-entry-df-value  simple-menu-entry-df-value .

	* brew-basics.fs: New run-mode mask  redisplaying .

2002-05-01  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Detailed dfloat scans for nuc and spots.

	* brew.fs: Detailed dfloat scans on nucs and spots:
	  nuc-dfloat-addr  nuc-var-is-float?
	  dfaligned-scan-n-ARRAY:  (dfloat-check-data) (last-dfloat-check-data)
	  nuc-type-counter
	  factored out  .range-zero?  from
	    nuc-detailed-scan  and  spot-detailed-scan
	  Adapted  nuc-detailed-scan  nuc-detail-extreems!
	  Renamed  (scan-nuc-detail)  to  (scan-nuc-int-detail),
	    new  (scan-nuc-dfloat-detail).
	  Renamed  (scan-spot-detail)  to  (scan-int-spot-detail)
	    new  (scan-df-spot-detail)
	  Split  nuc-detail-2-min-max
	    into  nuc-int-detail-2-min-max  and  nuc-df-detail-2-min-max.
	  Split  spot-detail-2-min-max
	    into  spot-int-detail-2-min-max  and  spot-df-detail-2-min-max.
	  nuc-scan-display  switches
	    nuc-int-scan-display  and  nuc-dfloat-scan-display
	  spot-scan-display  switches
	    spot-int-scan-display  and  spot-dfloat-scan-display

	  Renamed  spot-variable-name  to  spot-var-name  (simplified).

	  Split  ?zoom-scan-range
	    into  ?zoom-int-scan-range  ?zoom-dfloat-scan-range.
	  Split  slice-border  into  slice-border-int  slice-border-float
	  bar-ranged-subset  redefined, use:
	    (last-stat-type)  type-integer%  type-dfloat%  type-unknown%
	    bar-ranged-subset-int  bar-ranged-subset-dfloat
	  Split  change-scan-border  into
	    change-int-scan-border  and  change-float-scan-border
	  scan-status-line-reaction  use  (last-stat-type)  scan-x  v-range-x

	  Save dfloat check data:  Adapted  step-unique
	  df-inf-count  df-real-count  df+inf-count  df-nan-count
	  df-max  df-min
	  last-df-inf-count  last-df-real-count  last-df+inf-count
	  last-df-nan-count  last-df-max  last-df-min
	  dfloat-cat-unique

	  Removed  |nuc-detailed-df-scan-prescd|
	  Use  ?type  ?type-bright  ?type_  float>short-string
	  Bugfix in  maybe-fix-condition
	  Many minor adaptions.

2002-04-30  Robert Epprecht  <epprecht@sunweb.ch>

	* statistics.fs: Factored out scan display status line entries:
	  .scan-word  scan-x  .v-range  v-range-x

	* BUGS: Updated.

	* world-spots-arrayed.fs:   spot-float-start-index  spot-dfloat-addr

	* worlds.fs: spot-var-is-float?

	* statistics.fs: Float detailed scans:
	  Split  init-statistic-array  into
	  init-statistic-array-int  and  init-statistic-array-dfloat
	  Added variable  (last-stat-type).

	  Use  float>short-string.

	* menu.fs: float>short-string  change-df-value-at-addr

	* display.fs: ?type-bright

	* brew-basics.fs: Variable types:
	  type-unknown%  type-integer%  type-dfloat%

	  f*/  (word to use the old integer scales on floats).

	  Bugfix in  clear-line-to-end.
	  (lower-right-scrolls  version of  clear-line-to-end  also).

	  Changed and refactored  ?type  (don't append a space).
	  ?space  ?type_ (old  ?type  behaviour).

2002-04-22  Robert Epprecht  <epprecht@sunweb.ch>

	* statistics.fs: Renamed  statistic-display  to  statistic-display-int

	* basics.fs: dfloat-OFFSET:

	* statistics.fs: Prepared for dfloats:
	  Statistics descriptor: Offsets defined as dfloat-OFFSET:
	  (can be used for dfloats *and* integers).

	  Global variables defined as dfVARIABLE
	  (can be used for dfloats *and* integers).
	  (last-stat-min)  (last-stat-range)  (last-stat-slices)

	  init-statistic-array-dfloat  float-data2slice
	  >-inf-count  >real-count  >+inf-count  >nan-count
	  >dfloat-max  >dfloat-min  float-check-field-length#
	  float-min-max-init  float-data-check-in

	  statistic-display:
	  Factored out:  .zoom  statistics-status-line-int  (statistic-display)
	  statistics-status-line-float
	  Removed:  >vertical-boundaries  n'th-vertical-boundary.
	  statistic-display-float (separate version).

	  Test code.

2002-04-21  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Fixed sublists.

	* lists.fs: list>list
	  Removed:  node-is-n-list  new-node-as-n-list  new-node-as-list.
	  Adapted testing code.

	* DEVELOPMENT: Floats for  maybe-do  feature.

	* brew.fs: Floats in conditional colouring:
	  generic-range>fg-color  coloured-on-range-possible?
	  generic-range>bg-color

	  .conditional-colouring-menu  switch highlightning
	  conditional-colouring-menu   bugfix.
	  .color-menu  key binding.

	* brew.fs: Factored out  maybe-do.fs.

	* maybe-do.fs: Factored out maybe-do feature from brew.fs.
	  Quite hairy stuff intended to give a flexible user interface.
	  Brew does not use that too much for it's own goals.

	* brew.fs: maybe-do learned floats:
	  MAYBE-DO-df-TERM:
	  (expr-df-parameter)  (expr-df-parameter-2)
	  (do-it-df-parameter)  (do-it-df-parameter-2)
	  (xt-do-it-2)  removed,  (xt-do-it-1)  renamed to  (xt-do-it).
	  New:  (expr-df-xt-1)  (expr-df-xt-2)  (df-xt-do-it)
	  2-df-variables  df-variable-number  df-variable-within
	  evaluate-do  checks depth *and* fdepth and tries to fix errors.
	  Bug fixed.
	  evaluate-expr  tries to fix stack errors.
	  evaluate-df-expr  separate word for float expressions.
	  set-df-variable       add-to-df-variable
	  sub-from-df-variable  multiply-df-variable
	  f<  f>  f=  f<>
	  f>$  for  maybe-string (adapted)
	  Adapted:  maybe-FORTH-string  maybe-action-string
	  MAYBE-DO-FIELD:  dfaligns
	  Removed:  variable-number!  variable-number-?do!
	  Removed:  addr-n-?do-with-everybody
	  init-df-expr-xts-nuc   init-df-do-xts-nuc
	  init-df-expr-xts-spot  init-df-do-xts-spot
	  choose-df-nuc-var-xt-entry  choose-df-spot-var-xt-entry
	  choose-nuc&spot-df-var-xt-entry  choose-df-var-xt-entry

	  Sanity checking and some magic:
	  maybe-expr-is-float?  maybe-fix-condition
	  (Magic applied in  conditional-expression-entries,  adapted).

	  Adapted:  do-what-entry
	  Initialised all maybe-do-fields.
	  Renamed: float-nuc-vars  to  dfloat-nuc-vars.
	           choose-float-nuc-var-entry  to  choose-dfloat-nuc-var-entry.
	           save-float-variable  to  save-dfloat-variable.
	           save-float-nuc-vars  to  save-dfloat-nuc-vars
	           all-var-xts     to  all-int-var-xts.
	  New:     all-dfloat-var-xts
	  Lists:   integer-nuc-vars  integer-spot-vars
	           dfloat-nuc-vars   dfloat-spot-vars
	  n'th-df-nuc-var-xt

	  Minor changes in  .menu-nuc-scan  .menu-spot-scan

2002-04-20  Robert Epprecht  <epprecht@sunweb.ch>

	* worlds.fs: Define lists:  integer-spot-vars  dfloat-spot-vars.

	* world-spots-localized.fs: Use  integer-spot-vars  list.

	* world-spots-arrayed.fs: Define spot var lists in worlds.fs:
	  New  integer-spot-vars  list.
	  df-spot-vars  renamed to  dfloat-spot-vars.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, brew-defaults.fs:
	  (xt-do-it-2)  removed, renamed  (xt-do-it-1)  to  (xt-do-it).

2002-04-19  Robert Epprecht  <epprecht@sunweb.ch>

	* pfe.fs: f= is in common-words.fs now.

	* basics.fs: fwithin

2002-04-18  Robert Epprecht  <epprecht@sunweb.ch>

	* common-words.fs: f=  f<>

	* DEVELOPMENT: Dfloat nuc and spot scans.
	  Important menu switches highlited.

2002-04-17  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Highlighting of important menu switches,
	  key bindings.

	  Use deferred highlighting colours through
	  type-bright  type-alert  type-other-colour
	  <bright-colours>  <alert-colours>  <other-colour>  reset-colours
	  .ON-off-entry-coloured

	  Changed .rec/play-menu.

	* menu.fs, INPUTS/extensions/debugging/checksums.fs, world-loop.fs, statistics.fs, reporting.fs, manual.fs:
	Use deferred colour highlighting:
	  <bright-colours>  type-bright
	  <alert-colours>   type-alert
	  <other-colour>    type-other-colour.

	* display.fs: Deferred colour highlighting:
	  <bright-colours>  type-bright
	  <alert-colours>   type-alert         replaces  type-red
	  <other-colour>    type-other-colour  replaces  type-green.

	* statistics.fs, menu.fs, display.fs:
	Renamed  reset-default-colors  to  reset-colours.

	* menu.fs: .ON-off-entry-coloured

	* menu.fs: Menu unnesting words to be used inside menus:
	  unnest-menus  to-top-menu

	* texi/brew.info, texi/brew.texi: environmental.test.fs: more comments.

	* texi/brew.info, texi/brew.texi: Added:  environmental.test.fs

	* brew.fs: Check for some environmental dependencies:
	  'Brew' depends on allocated memory to be dfaligned.
	  'Brew' depends on a separate float stack.
	  include environmental.test.fs early in the load sequence.

	  Bugfix in .menu-spot-scan.

	* environmental.test.fs: Check for some environmental dependencies:
	  'Brew' depends on allocated memory to be dfaligned.
	  'Brew' depends on a separate float stack.

	* texi/brew.info, texi/brew.texi, genes/insight.fs, benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, benchmarks/simple-bench.fs, INPUTS/genes/insight.fs, INPUTS/extensions/debugging/brew-crash-test.fs, INPUTS/experiments/sum/sum.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, INPUTS/experiments/linear-equations/linear-1-float.fs, INPUTS/experiments/linear-equations/linear-1-float-init.fs, mutation-0.3.fs, mutation-0.2.fs, faked-genes.fs, brew-init.fs, brew.fs:
	Shortened nuc-var names for better display layout:
	  my-diversifctn-mask  (was  my-diversification-bitmask)
	  f-param-div-mask     (was  f-parameter-div-mask)
	  f-invisibl-div-mask  (was  f-invisible-div-mask)
	  reprodctn-threshold  (was  reproduction-threshold)

	* brew.fs: Dfloat nuc and spot scans:
	  Added:  nuc-df-scan-range
	  Adapted  init-nuc-scan  scan-nuc  nuc-scan-average
	  init-nuc-scan  does not take parameters any more.
	  Initialise max/min values (integer and dfloat) in init-nuc-scan.
	  Renamed  nuc-scan-range  to  nuc-i-scan-range.
	  Adapted  .menu-nuc-scan  can show floats and float type counts.
	  Added:  (show-float-type-counts), globally used.
	  Added:  (nuc-menus-show-dfloats) used by nuc-menu and .menu-nuc-scan
	  (nuc-menus-show-dfloats) replaces (nuc-menu-show-integer).
	  Adapted  .nuc-menu
	  Key binding for  (nuc-menu-visible-floats)  added.

	  Same adaptions regarding spot scans:
	  (scan-spots)  is a variable now, memory get's allocated.
	  init-spot-scan  scan-spot  spot-scan-average  .menu-spot-scan
	  spot-min  spot-max  spot-average  world-text-display  .menu-edit-spot
	  calibrate-bg-color-scales (only for integers, so far)
	  (spot-menus-show-dfloats) replaces (menu-edit-spot-integer).

	  Two new environmental depedencies:
	  * separated float and data stacks
	  * allocated memory must be dfaligned

	  new-nucleus-as-word  DFALIGN before ALLOT.
	  nuc-float-offset#  is *always* defined,
	  nuc-length# depends on it and is always dfaligned now.

	  Added:  n'th-dfloat-nuc-var

2002-04-16  Robert Epprecht  <epprecht@sunweb.ch>

	* basics.fs: Added  +1!  df+!
	  Added float type codes:  -inf%  real%  +inf%  nan%
	  float-type

	  infinity?  use  +inf%

	* INPUTS/genes/dfloat-store.fs: df+!  defined in basics.fs

	* INPUTS/experiments/linear-equations/linear-1-float-init.fs:
	  Renamed (nuc-menu-show-integer) to (nuc-menus-show-dfloats), inverted.

2002-04-15  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Fixed conditional compiling structure.

2002-04-14  Robert Epprecht  <epprecht@sunweb.ch>

	* common-words.fs: Added  under+  (commented out).

	* brew.fs: Introduced nuc-df-scan-limit (not used yet).
	  Some minor edits.

	* ChangeLog, TAGS, TODO: Updated.

	* brew.fs: Minor changes:
	  ?|see-genome-or-spot|  always restores cursor position.
	  spot-f-diversification-factor defaults to 1e0.
	  'c' key binding in nuc menu.

	* texi/brew.info, texi/brew.texi: Oops, checked in too early...
	  There where a lot more changes.

	* texi/brew.info, texi/brew.texi:   Documentation of float features:
	  New nodes: 'Float input' 'Floating point primitives'
	  'Float arithmetic genes' 'More float arithmetics'
	  'Logarithms and exponentials' 'Trigonometry' 'Mixed maths'
	  'Type casts' 'Read float values' 'Store float values'
	  'Float stack manipulation' 'Nuc and spot floats'
	  'Floating point comparison'

	  New node 'Show me functions' factored out.
	  Node 'Gene conditionals' moved.

	  Adapted nodes: 'Classes of variables' 'Variable names'
	  'Selecting functions' 'Configuring spot display' (<look-at>)

	  Added some more links.

	* texi/TODO: Updated.

2002-04-14  Robert Epprecht  <epprecht@sunweb.ch>

	* TAGS, TODO: Updated.

	* brew.fs: Minor changes:
	  ?|see-genome-or-spot|  always restores cursor position.
	  spot-f-diversification-factor defaults to 1e0.
	  'c' key binding in nuc menu.

	* texi/brew.info, texi/brew.texi: Oops, checked in too early...
	  There where a lot more changes.

	* texi/brew.info, texi/brew.texi:   Documentation of float features:
	  New nodes: 'Float input' 'Floating point primitives'
	  'Float arithmetic genes' 'More float arithmetics'
	  'Logarithms and exponentials' 'Trigonometry' 'Mixed maths'
	  'Type casts' 'Read float values' 'Store float values'
	  'Float stack manipulation' 'Nuc and spot floats'
	  'Floating point comparison'

	  New node 'Show me functions' factored out.
	  Node 'Gene conditionals' moved.

	  Adapted nodes: 'Classes of variables' 'Variable names'
	  'Selecting functions' 'Configuring spot display' (<look-at>)

	  Added some more links.

	* texi/TODO: Updated.

2002-04-13  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/experiments/linear-equations/linear-1-float-init.fs:
	  Initialisation and startup file for linear-1-float.fs.
	  Leads to a solution at step 442, but it's more luck than evolution...

	* INPUTS/experiments/linear-equations/linear-1-float.fs:
	Dfloat version of linear-1.fs.

	* my-compile-options.fs: Added CREATE brew-crash-test (commented out).

	* my-brew-options.fs:
	Added include INPUTS/extensions/debugging/checksums.fs
	  (commented out, of course).

	* compile-options.fs: Dfloat nuc and spot variables:
	  nuc-f-organs#  nuc-f-parameters#  nuc-f-invisibles#  nuc-f-secrets#
	  spot-f-qualities#  spot-f-properties#  spot-f-secrets#

	* DEVELOPMENT: More float capabilities, adaptions and bugfixes.
	  Spot floats and related gene primitives.
	  Experiment with float versions of simple linear equation systems.

	  Writing and checking of step and spot checksum files, to find the
	  exact spot where evolution starts to differ on two systems.
	  Detailed logging of the critical spot.

	* INPUTS/extensions/debugging/crash-test-README: Edited.

2002-04-11  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: More floating point adaptions:
	  log-spot-variables

	  Added step-do-before-xt  step-do-before-xt  step-do-actions

	  Extended logging capabilities  log-empty-spots.  Log menu adapted.

	  Bugfixes in  define-float-var-family  spot-df-vars@
	  assert@=  assert2@=  assert-do=  and others.
	  Make it possible to include a bench from a menu (for tests).

	* benchmarks/brew-crash-test.fs: Basically replaced by the file
	  INPUTS/extensions/debugging/brew-crash-test.fs
	  The new version gets included from here after resetting some xt's.

	* INPUTS/extensions/debugging/crash-test-README:
	Step by step brew crash test usage example.
	  Can be used as an example of checksums.fs usage as well.

	* INPUTS/extensions/debugging/crash-test-step.dat:
	Step checksum data for  brew-crash-test.fs.

	* INPUTS/extensions/debugging/brew-crash-test.fs:
	  Testing an evolution using many brew features for any deviations.
	  Version adapted to use  checksums.fs.

	  See  crash-test-README.
	  Step data are in  crash-test-step.dat.

	* INPUTS/extensions/debugging/checksums.fs:
	Tool to write binary checksum files
	  and to compare them to the checksums produced later
	  under changed circumstances.

	  Find step where something differs,
	  write spot checksum file for this step,
	  check it determining the critical spot and do write logs for it.

	  Works together with INPUTS/extensions/debugging/brew-crash-test.fs

2002-04-06  Robert Epprecht  <epprecht@sunweb.ch>

	* world-loop.fs, reporting.fs:
	log-empty-spots depending on log-mask compile option.

2002-04-05  Robert Epprecht  <epprecht@sunweb.ch>

	* world-loop.fs: Execute step-do-before-xt and step-do-after-xt.
	  log-empty-spots.

	* reporting.fs: New log mask log-empty-spots.

	* old-world-loop.fs: Execute step-do-before-xt and step-do-after-xt.

	* fileselect.fs: Starting each directory unscrolled.

	* basics.fs: create-named-file  open-named-file.

2002-03-31  Robert Epprecht  <epprecht@sunweb.ch>

	* benchmarks/transit-12-bench.fs:
	Set step-do-before-xt and step-do-after-xt.

	* BUGS: Updated.

	* benchmarks/transit-11-bench-A.fs, benchmarks/simple-bench.fs, INPUTS/experiments/sum/sum-init.fs, INPUTS/experiments/linear-equations/linear-1-init-B.fs, INPUTS/experiments/linear-equations/linear-1-init-A.fs, brew-defaults.fs:
	Set step-do-before-xt and step-do-after-xt.

2002-03-26  Robert Epprecht  <epprecht@sunweb.ch>

	* pfe.fs: brew-menu
	  hack to get the intended ORDER when calling BREW-MENU
	  (after quitting brew)

2002-03-20  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Bugfix in ?record-edit-spot?
	  Minor edits.

	* INPUTS/genes/float-comparison.fs: Fixed stack effect of f0< and f0=

2002-03-19  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/genes/float-more-arithmetics.fs: Comment fixed.

2002-03-13  Robert Epprecht  <epprecht@sunweb.ch>

	* pfe.fs: PFE 0.32.49 adaptions.

	* benchmarks/brew-crash-test.fs: Upwards compatibility restored.

	* brew.fs: Restored brew-crash-test compatibility.

2002-03-10  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: compile-listed-?-and-!  fixed displayed word name.

	* brew.fs: Check spot df diversification mask from caller for
	  spot-df-family-diversify as this word is used *very* often.

	* menu.fs: Bugfix fix-float-string tread infinities and nans.
	  +inf -inf aliases as used as short forms in float>string
	  nan does not work with bigFORTH, so I didn't define it yet.

	* pfe.fs: Adaptions for PFE 0.32.48

2002-03-01  Robert Epprecht  <epprecht@sunweb.ch>

	* world-spots-arrayed.fs: Bugfix in world-checksum.

	* world-spots-arrayed.fs: world-checksum includes dfloats.

2002-02-28  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Include dfloat compile options in:
	  world-menu  .version  save-world-compile-options.

	* brew.fs: Bugfix: compiling without spot floats.

	* world-spots-arrayed.fs: Added n'th-spot-f-var-xt.

	* brew.fs: Work on dfloats continued:
	  dfloat nuc structure description.

	  Spot dfloats:
	  spot-df-vars@  spot-df-vars!

	  (dfloat) Diversification:
	  Renamed <?diversify-planes> to ?diversify-spots
	  <?diversify-inhabited> to ?diversify-inhabited
	  spot-diversify to spot-integer-diversify

	  global-f-organ-div-mask  global-f-parameter-div-mask
	  global-f-invisible-div-mask
	  f-qualities-div-mask  f-properties-div-mask  f-secrets-div-mask
	  spot-f-diversification-range  spot-f-diversification-factor
	  spot-df-diversify-additive  spot-df-diversify-relative
	  spot-df-diversify
	  spot-df-family-diversify  f-qualities-diversify
	  f-properties-diversify  f-secrets-diversify
	  f-sporadic-value-rate  f-sporadic-value-range
	  Bugfix IN nuc-df-sporadic.

	  .spot-diversification-menu adapted:
	  integer-spot-item-flags-entry  spot-f-div-entries

	  edit-spot-menu adapted:
	  renamed ?record-edit-spot to ?record-edit-spot?
	  (now returning a change-flag)
	  spot-df-before  spot-df-after
	  (menu-edit-spot-integer)

	  float>buffer-string uses float>string now.

	  INDIVIDUAL: does nuc-does-nothing as default.

	  save-listed-mask uses diff blocks instead of placeholders.
	  Bugfix in block-begin?
	  reset-before&after  blocks-differ?  diff-block-as-unit
	  Removed out-hex-comment.

	  'r' key-binding in menu-this-genome.

2002-02-25  Robert Epprecht  <epprecht@sunweb.ch>

	* basics.fs: Words for integer eat-scored:
	  fabs-replace-NaN  f>s-limited

2002-02-23  Robert Epprecht  <epprecht@sunweb.ch>

	* fileselect.fs:
	  read-dir-next: set (start-char) to the first char of the *base* file
	  name.

	* code-chapters.txt: Added chapter 'nuc pointers'.

	* INPUTS/experiments/sum/sum.fs: INDIVIDUAL: includes nuc-does-nothing

2002-02-20  Robert Epprecht  <epprecht@sunweb.ch>

	* world-spots-arrayed.fs:
	  Bugfix: (float-offset) got set wrong in (big-bang).

	  LIST: df-spot-vars

2002-02-19  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi, reporting.fs: s/brew-log/brew.log/

	* old-world-loop.fs, world-loop.fs:
	  Renamed <?diversify-inhabited> to ?diversify-inhabited,
	  <?diversify-planes> to ?diversify-spots.

2002-02-16  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: nuc-floats# and spot-floats# compile options.

	* INPUTS/genes/spot-df-properties.fs:
	  Read/only dfloat spot variable gene primitives.

	* INPUTS/genes/spot-df-qualities.fs:
	  Read/write dfloat spot variable gene primitives.

	* brew.fs: Prepare for dfloat spot variables:
	  Rename field-planes# to field-i-planes#.
	  Include gene primitives spot-df-qualities.fs spot-df-properties.fs.

	* world-spots-arrayed.fs, world-spots-localized.fs, old-world.fs:
	Renamed field-planes# to field-i-planes#

	* worlds.fs: Support dfloat spot variables:
	  field-df-planes#  Renamed field-planes# to field-i-planes#
	  (f-array-length)  (plane-length) to (i-array-length).
	  (float-offset).

	* world-spots-arrayed.fs: dfloat spot variables.
	  Spot dfloat qualities, properties and secrets.

	  time-pointer  got a twin  f-time-pointer   Both set by time-pointer!

	  f-array-length  renamed plane-length to i-array-length.
	  set by enter-world from (f-array-length) (i-array-length).
	  float-offset  set by enter-world from (float-offset).
	  spot-f-offset   renamed spot-offset to spot-i-offset  set by >spot!

	  (i-array-length) (f-array-length) (float-offset) set by (big-bang).

	  compile-multiple-offsets  for  SPOT-VARIABLE: and df-SPOT-VARIABLE:

	  define-named-spot-vars is generic now (integer/dfloats).
	  define-named-i-spot-vars  define-named-f-spot-vars.

	  n'th-spot-variable does not check range any more.
	  n'th-spot-f-variable

	  Adapted  qualities>future  world-checksum  (big-bang)
	  Use field-df-planes#

2002-02-15  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_34

	* DEVELOPMENT: Benchmark compatability.

	* benchmark-results.txt: brew-transit_34 benchmark results.

	* pfe.fs: Defined  f=  (for  is-NaN?).

	* TAGS: updated.

	* compile-options.fs: Compile with some nuc float variables.

	* TODO: updated.

	* texi/TODO: (partly) updated.

	* brew-defaults.fs: Set nuc-f-diversification-rate to zero.
	  (Benchmark downwards compatibility issue).

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Next try...

	* world-loop.fs, manual.fs, brew.fs: Use  type-green  type-red.

	* menu.fs, brew.fs: Use this-line.

	* brew-basics.fs: Added this-line.

	* VERSION-README: Updated.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Upward compatability fix.

	* worlds.fs: ?cp! depreciated.

	* brew.fs: Benchmark compatability  and changed  cp!
	  Excluding float offset nuc entries from checksum, to allow timing
	  different nuc structures.
	  diversify?-df-items  checks for zero masks.
	  diversify?-some  checks nuc-f-diversification-rate for zero ratr.

	  .i-families .f-families  for  .brew-version
	  .version  prints float family member counts (other format).

	  Bugfix: using  ?cp!  in all critical words is too error prone.
	  cp deals with false pointers directly.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	  No, reverted.  Compatability fixed in brew.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	  Compatability to nuc float variables:  switching them off.

2002-02-15  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_34

	* DEVELOPMENT: Benchmark compatability.

	* benchmark-results.txt: brew-transit_34 benchmark results.

	* pfe.fs: Defined  f=  (for  is-NaN?).

	* TAGS: updated.

	* compile-options.fs: Compile with some nuc float variables.

	* TODO: updated.

	* texi/TODO: (partly) updated.

	* brew-defaults.fs: Set nuc-f-diversification-rate to zero.
	  (Benchmark downwards compatibility issue).

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Next try...

	* world-loop.fs, manual.fs, brew.fs: Use  type-green  type-red.

	* menu.fs, brew.fs: Use this-line.

	* brew-basics.fs: Added this-line.

	* VERSION-README: Updated.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Upward compatability fix.

	* worlds.fs: ?cp! depreciated.

	* brew.fs: Benchmark compatability  and changed  cp!
	  Excluding float offset nuc entries from checksum, to allow timing
	  different nuc structures.
	  diversify?-df-items  checks for zero masks.
	  diversify?-some  checks nuc-f-diversification-rate for zero ratr.

	  .i-families .f-families  for  .brew-version
	  .version  prints float family member counts (other format).

	  Bugfix: using  ?cp!  in all critical words is too error prone.
	  cp deals with false pointers directly.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	  No, reverted.  Compatability fixed in brew.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	  Compatability to nuc float variables:  switching them off.

2002-02-14  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Work on floating point nuc variables.

	  Float support in nucs, genes, mutation and diversification.
	  Consequent use of dfloats:  df@ and df!

	  Implementing nuc float variable families prepared for dynamic
	  nuc structures.

	* brew.fs: On the way to dfloat support (and dynamicly sized nucs).

	  Nuc, genes and mutation, and diversification do support dfloats:
	  nuc-f-organs#     named  f-organ-A f-organ-B f-organ-C ...
	  nuc-f-parameters# named  f-parameter-A ...
	  nuc-f-invisibles# named  f-invisible-A ...
	  nuc-f-secrets#    named  f-secret-A ...
	  nuc-floats#       nuc dfloat variables in total.
	  No scanning yet,  no spots,  no maybe do...

	  I consequently use dfloat memory words df@ and df!
	  for better compatability between different systems.

	  On the way to dynamic nuc structure:
	  Changed nuc var implementation on the new float variables.
	  Each family of named variables depends on his own pointer.
	  The pointers get set in cp! when a nuc gets the actual one.
	  New code chapter 'nuc pointers'.

	  nuc-f-organ-base      nuc-f-parameter-base
	  nuc-f-invisible-base  nuc-f-secret-base

	  As the new cp! cannot deal with a 'false' value I use ?cp! in
	  new-nucleus  new-nucleus-as-word  die  where it occurs.

	  New integer nuc vars for the float offsets:
	  f-organ-offset  f-parameter-offset
	  f-invisible-offset  f-secret-offset
	  Word to set offsets up when the nuc is created:  set-nuc-offsets

	  Individual diversification masks for each family:
	  f-organ-div-mask  f-parameter-div-mask  f-invisible-div-mask

	  New separate list integer-nuc-vars and float-nuc-vars.
	  Constants:   nuc-float-start-index  nuc-float-offset#
	  nuc-f-organs-i  nuc-f-parameters-i
	  nuc-f-invisibles-i  nuc-f-secrets-i

	  NUC-f-VAR:
	  define-float-var-family  define-nuc-f-organs  define-nuc-f-parameters
	  define-nuc-f-invisibles  define-nuc-f-secrets

	  Slow, but universal words (i.e. for display, logging):
	  nuc-var-xt  nuc-var-name
	  f-var-xt?
	  f-organ-xt?  f-parameter-xt?  f-invisible-xt?  f-secret-xt?

	  .ascii-num  .scaled-ascii
	  f-2-ascii-scale  .float-scaled-ascii

	  Words to show a nuc vars value coded as ASCII:
	  Variables:  show-int-nuc-var-xt  show-sign-tolerance
	  Float:  show-float-nuc-var-xt  float-show-sign-tolerance
	  Look at functions:  show-integer-nuc-var  show-integer-var-sign
	  show-float-nuc-var  show-float-var-sign

	  Logging array values:  log-nuc-i-values  log-df-values
	  Adapted log-nuc-variables

	  Include new floating point gene primitives from
	  float-organs.fs  float-parameters.fs
	  dfloat-fetch.fs  dfloat-store.fs  float-stack.fs
	  float-basic-arithmetics.fs  float-more-arithmetics.fs
	  float-exp.fs  float-trigonometry.fs
	  mixed-maths.fs  transform.fs  float-comparison.fs

	  more-r-consumer-genes  (untested).

	  common-menu-entries does redisplay on function keys. experimental...

	  Some initialisation changes.

	  item-masks |A |B |C ... used for members of all families.

	  Diversification:
	  Variables:  global-f-organ-div-mask global-f-parameter-div-mask
	  global-f-invisible-div-mask
	  nuc-f-diversification-rate nuc-f-diversification-range
	  f-sporadic-value-rate f-sporadic-value-range
	  nuc-f-diversification-factor  for new relative diversification.

	  nuc-df-diversify-additive nuc-df-diversify-relative nuc-df-diversify
	  random-closeness-factor nuc-df-sporadic nuc-df-diversify?
	  diversify?-df-items (checks items separately). experimental...
	  diversify?-f-organs diversify?-f-parameters diversify?-f-invisibles
	  Adapted diversify?-some

	  Changes in nuc-diversification-menu:
	  items-bitmask-entry nuc-global-f-div-entries integer-item-flags-entry
	  nuc-global-i-div-entries

	  Changes in nuc-menu:
	  Switch between integer and float variables.
	  When displaying floats switch between visible and hidden ones.

	  nuc-local-f-div-entries nuc-local-i-div-entries
	  Variables: (nuc-menu-show-integer) (nuc-menu-visible-floats)

	  Changes in display-menu, support new <look-at> functions:
	  show-integer-nuc-var  show-integer-var-sign  Support parameters.
	  show-float-nuc-var    show-float-var-sign
	  choose-integer-nuc-var-entry  choose-float-nuc-var-entry
	  sign-tolerance-entry  2-ascii-scale-entry

	  Saving and logging: always use dfloat df@ and df!.
	  log-item-bitmask  save-float-nuc-vars
	  Adapted save-nuc-compile-options.

	* mutation-0.3.fs:
	Set diversification flags for float organs and parameters.
	  Adapt 'selected-gene-picking'and 'follow-&-add':

	  'set-diversification-bits' factored out from 'follow-&-add'.

	  Upper/lowercase search strings:
	  'organ-string' 'parameter-string'
	  'f-organ-string' 'f-parameter-string'

	  Use 'log-item-bitmask'.

	* genes-0.3.fs: Deal with addresses of dfloats:
	  'in-df-address' 'out-df-address'
	  'string-tos-is-df-address?'

	  Adapted: 'string>stack-in' 'string>stack-out'.

	* INPUTS/genes/float-parameters.fs:
	Define dfloat parameter read gene primitives.

	* INPUTS/genes/float-organs.fs:
	Define named dfloat organ gene primitives.

	* INPUTS/genes/float-comparison.fs: Float comparison gene primitives.

	* INPUTS/genes/transform.fs:
	  Transform float to single integer (and vice versa) gene primitives.

	* INPUTS/genes/mixed-maths.fs:
	  Some mixed integer/float basic arithmetic operator gene primitives.
	  (it would be better to check for separate float stack first...).

	* INPUTS/genes/float-trigonometry.fs: Trigonometric gene primitives.

	* INPUTS/genes/float-stack.fs: Use 'as-gene'.

	* INPUTS/genes/float-exp.fs:
	Exponential, root and logarithm gene primitives.

	* INPUTS/genes/dfloat-fetch.fs, INPUTS/genes/float-more-arithmetics.fs, INPUTS/genes/float-basic-arithmetics.fs, INPUTS/genes/dfloat-store.fs:
	Comments added.

	* INPUTS/genes/float-more-arithmetics.fs:
	More floating point operator primitives.
	  negate, abs, max, min, 2+, 2/, 1/f.

	* INPUTS/genes/float-basic-arithmetics.fs:
	Basic arithmetic floating point operator gene primitives.

	* INPUTS/genes/dfloat-store.fs: Dfloat store gene primitives.

	* INPUTS/genes/dfloat-fetch.fs: Define into 'genes' vocabulary.

	* INPUTS/genes/dfloat-fetch.fs: Use 'as-gene'.

	* INPUTS/genes/dfloat-fetch.fs: Use 'GENE-ALIAS:'.

	* INPUTS/genes/dfloat-fetch.fs: Fetch dfloat gene primitives.

	* worlds.fs: Use ?cp! ('erase-field').

	* reporting.fs: Factored out 'log-out-line' from 'log-it'.
	  Added 'log-bitmask' (with binary number base output).

	* menu.fs: Float extensions:
	  Words to allow user input of a float value in everydays syntax,
	  without blocking use of the Forth text interpreter for calculations.
	  'fix-float-string' '(maybe-float?)' 'maybe-float?' '(float-string)'
	  'last-word' 'maybe-replace-last-as-float' '(float-in)' 'float-in'
	  'dfloat-in-to-addr'

	  Words to build an ASCII representation from a floating point value:
	  'float-scratch-represent' 'float-scratch/zeroes'
	  'real>string' 'float-just-fits?' 'build-as-mantissa' 'float-fits?'
	  'float>string'
	  'float-display-width' 'max-dfloat-display-width' '.float' '.float-wide'
	  'change-named-dfloat-var' '.float-on-same-line'
	  'menu-entry-dfloat-variable' 'simple-dfloat-variable-entry'

	  Adaptions in 'show-key-bindings'.

	* random.fs: 'f-rated-flag'.

	* display.fs: 'type-red'.

	* common-words.fs: '1/f' 'f2*' 'f2/' 'pi' 'f>' 'f0>'.

	* brew-basics.fs: Define reusable item masks named |A |B |C ...
	  'item-masks' 'define-item-masks'.

	* basics.fs: Bugfix: max bit's in 'MASK:'.
	  Added 's>f'.

2002-02-12  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/genes/float-stack.fs: Gene primitives with float stack basics.

2002-02-11  Robert Epprecht  <epprecht@sunweb.ch>

	* display.fs: 'type-green'.

	* basics.fs: Float related words:
	  'dFVARIABLE' 'f>s' 'is-NaN?' '+infinity' '-infinity' 'infinity?'
	  'real?'.
	  'BASE+dFLOAT-OFFSET:' (not used, commented out).
	  Helper words: '-trailing-char' 'dec-num?' 'count-char'.

2002-02-06  Robert Epprecht  <epprecht@sunweb.ch>

	* common-words.fs: Added 'fnip'.

2002-01-27  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Added file 'common-words.fs'.

2002-01-25  Robert Epprecht  <epprecht@sunweb.ch>

	* bigFORTH.fs: include float.fb.

	* DEVELOPMENT: Working towards floating point.

	* random.fs: 'FRANDOM' (based on integer random generator).

2002-01-22  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_33

	* TAGS: updated.

	* DEVELOPMENT: Keybindings, experiments 'sum' and 'linear-1'.

2002-01-21  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/experiments/linear-equations/linear-1-init-B.fs:
	Simple linear equation system initialisation file version B.
	  Nice 'bad' example.  Takes awfully long, but finds good solutions
	  at least.
	  Using integer math is not very adequate here...

	* INPUTS/experiments/linear-equations/linear-1-init-A.fs:
	Simple linear equation system initialisation file version A.
	  Nice 'bad' example.  Finds solutions better than my cheat.
	  Using integer math is not very adequate here...

2002-01-22  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_33

	* TAGS: updated.

	* DEVELOPMENT: Keybindings, experiments 'sum' and 'linear-1'.

2002-01-21  Robert Epprecht  <epprecht@sunweb.ch>

	* INPUTS/experiments/linear-equations/linear-1-init-B.fs:
	Simple linear equation system initialisation file version B.
	  Nice 'bad' example.  Takes awfully long, but finds good solutions
	  at least.
	  Using integer math is not very adequate here...

	* INPUTS/experiments/linear-equations/linear-1-init-A.fs:
	Simple linear equation system initialisation file version A.
	  Nice 'bad' example.  Finds solutions better than my cheat.
	  Using integer math is not very adequate here...

	* INPUTS/experiments/linear-equations/linear-1.fs:
	Simple linear equation system source file.
	  Nice 'bad' example.  Using integer math is not very adequate here...

	* INPUTS/experiments/sum/sum-init.fs:
	Initialisation file for simple sum experiment.

	* INPUTS/experiments/sum/sum.fs: Code for simple sum experiment.

	* texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: Added node 'Experiments'.
	  Directory 'INPUTS/experiments/'.

	* brew.fs: Minor change in system menu.

	* TODO: updated.

2002-01-11  Robert Epprecht  <epprecht@sunweb.ch>

	* menu.fs: User interface to leave menus: 'menu-leave':
	  unnest n menu levels, all for -1.

2002-01-10  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Use 'xt>stack' (for 'show-key-bindings').

	* menu.fs: Simpler access to xt's for 'show-key-bindings':
	  'xt>stack' 'xt>stack-2' 'xt>stack-3'
	  '|stack-1-is-xt' '|stack-2-is-xt' '|stack-3-is-xt'
	  'stack-1-is-xt' 'stack-2-is-xt' 'stack-3-is-xt'.

2002-01-05  Robert Epprecht  <epprecht@sunweb.ch>

	* TODO, BUGS: updated.

	* brew.fs: Some more adaptions to snapshot display:
	  in 'save-step-display-settings' 'react-on-mouse'
	  Factored out 'spots-visible?' from '.brew'.

	  Use 'inputs-dir' in '|include-file|'.

	  Bugfix in '(step-redisplay)':
	  Always display status line of continuous display, if used.

	  Bugfix in 'scan-status-line-reaction':
	  Allow status line interaction when range is zero.

	* system-dependent.fs: 'include required.fs' if required ;-)

	* required.fs: FORTH-WORDLIST was not found in bigFORTH.
	  As I check for REQUIRED before including the file I comment it out.

	* required.fs: This file is from the Gforth distribution.
	  With many thanks to the Authors.

2002-01-03  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: Corrected spelling error.

2002-01-02  Robert Epprecht  <epprecht@sunweb.ch>

	* fileselect.fs: Bugfix: 'read-dir-next' close stringbuf.

2001-12-31  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Minor adaption.

	* statistics.fs: Minor edit.

	* mutation-0.3.fs, mutation-0.2.fs: Minor edit in code file.

	* brew-basics.fs: Added 'experiments-dir'.

2001-12-29  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: Fixed range scan display.
	  Scan status line interaction.

	  Playback interruption.

2001-12-28  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Fixed range scan display.

	* brew.fs: Fixed display range in scans possible:
	  'fixed-horizontal-range' 'scan-horizontal-zoom?'.
	  Factored out '?zoom-scan-range' from 'nuc-scan-display'
	  and 'spot-scan-display'.
	  Adaptions in 'bar-ranged-subset' for border slices on fixed range.
	  Use listed masks for '(scan-flags)'.
	  Bugfix in 'save-listed-mask': 2 lines at least.

	  Adapted 'step-display-reaction':
	  'scan-status-line-reaction' and factored out 'change-scan-border'
	  let's you configure scan display range from scan status line.

	* statistics.fs: Fixed display range in scans possible:
	  'scan-horizontal-zoom?'  Changes in 'statistic-display'.
	  Bugfix in 'data2slice' when data is above range.

2001-12-27  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Deleted obsolete 'show-fg-coloured-hit-diff'.

	* TODO: updated.

	* brew.fs: '?record|include-file|'.

	* texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: New node 'Conditional colouring'.

	* brew.fs: Link to info node 'Conditional colouring'.

	* TODO: updated.

	* DEVELOPMENT: Conditional fg/bg colouring rewrite.

	* brew.fs: Conditional fg/bg colouring rewritten:
	  'fg-colour-field' 'bg-colour-field'
	  'condition>fg-colour' 'condition>bg-colour'.

	  Set fg/bg conditional colouring from world maps:
	  'colour-condition' '?set-as-colour-condition'
	  '?set-as-fg-colour-condition' '?set-as-bg-colour-condition'.

	  Edit colour conditions: 'conditional-colouring-menu'
	  'cond-fg-colour-functions' 'cond-bg-colour-functions'.

	  'generic-range>fg-color' 'generic-range>bg-color' do '2-variables'.
	  'coloured-on-range-possible?'

	  Renamed 'generic-maybe>fg-color' 'generic-maybe-range>fg-color'
	  to 'generic-hit>fg-color' 'generic-range>fg-color'.

	  Deleted (obsolete): 'condition>bg-color' 'condition-diff>bg-color'
	  '(cond-color-map)'
	  'world-condition-color-map' 'world-condition-color-diff'.

	* brew-defaults.fs: 'fg-colour-field' 'bg-colour-field'.

2001-12-23  Robert Epprecht  <epprecht@sunweb.ch>

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, benchmarks/brew-crash-test.fs, brew-defaults.fs:
	  'maybe-do-on-selected-field' does also the functions of the obsolete
	  'maybe-do-selected-field', which has been deleted.

	* brew.fs: Eliminated 'maybe-do-selected-field':
	  Replaced by 'maybe-do-on-selected-field'.

	  Rewrote 'do-with-selected-nucs'.
	  Renamed 'show-bg-coloured-generic' to 'show-bg-coloured-on-hit',
	  '|show-bg-coloured-generic|' to '|show-bg-coloured-on-hit|'.

	  'generic-maybe-range>bg-color' does 'variable-number' now.

2001-12-22  Robert Epprecht  <epprecht@sunweb.ch>

	* TODO: updated.

	* brew.fs: Corrected rounding errors in 'bar-ranged-subset'.
	  'slice-border'

2001-12-16  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: User interaction during playback.
	  Various nice little things...

	* texi/brew.info, texi/brew.texi: 'Include file' from system menu.

	* brew.fs: Better error handling during playback.
	  Changes in 'playback-on/off'.
	  Splitted '(playback-file-name)' '(playback-file-short-name)'.

	  Include files from system menu: '|include-file|'.

2001-12-15  Robert Epprecht  <epprecht@sunweb.ch>

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, benchmarks/brew-crash-test.fs, brew-defaults.fs:
	Use 'fg-colour-field'.

	* brew.fs: Interactive nuc maps everywhere.
	  Some places still had older implementations.
	  ('.menu-this-genome' '.genome-list-node'

	  'generic-maybe-range>fg-color' can also do 'variable-number' now.

	  'show-fg-coloured-hit-diff'
	  Renamed 'show-fg-coloured-generic' to 'show-fg-coloured-on-hit'.
	  '|show-fg-coloured-on-hit|' (was: '|show-fg-coloured-generic|').
	  '|show-fg-coloured-hit-diff|'
	  'fg-colour-field' (*not* reset, for display re-use).

	  Rewritten:
	  'show-coloured-on-nuc-var-eq' 'show-coloured-on-nuc-var-diff'

	  Obolete, deleted:
	  '(nuc-var-for-color)' '(nuc-value-for-color)' '(color-condition-xt)'
	  'nuc-var-condition>fg-color'
	  'show-coloured-on-nuc-var'
	  'show-coloured-on-nuc-var-less' 'show-coloured-on-nuc-var-more'
	  'NAND'
	  'show-coloured-on-nuc-flags-AND' 'show-coloured-on-nuc-flags-NAND'
	  'nuc-var-diff>fg-color' 'show-coloured-on-nuc-var-diff'
	  '(color-range-variable-xt)' '(color-range)' 'range>bg-color'
	  'show-range-map'
	  'display-range-map' '|show-range-map|' 'bar-ranged-map'

	  New behaviour of '.quit-brew?', the old one hit my nerves...

2001-12-14  Robert Epprecht  <epprecht@sunweb.ch>

	* menu.fs: Use throw code '|menu-input-error'.

	* mutation-0.2.fs, mutation-0.3.fs:
	  Use throw code '|genome-too-long'.

	* brew-basics.fs: Define throw codes:
	'|menu-input-error' '|genome-too-long' '|playback-quit'.

	* brew.fs: 'playback-interaction' for brew interactions on playback.
	  '|brew|' to 'brew' in playback files.

	* debuging.fs: Extended 'dada' functionality.
	  '.dada' obsolete, deleted.

2001-12-11  Robert Epprecht  <epprecht@sunweb.ch>

	* TODO: updated.

	* DEVELOPMENT: Not using xt's as flags any more.

	* brew.fs: Not using xt's as flag any more:
	  'block-begin?' 'block-end?'
	  'read-line-&-test' 'read-before-&-test' 'read-after-&-test'.

	  Note that diff blocks are only tested for current brew capabilities,
	  *not* for differing block sizes, premature EOFs and such...

	* DEVELOPMENT: Test implementation of diff blocks (for genome pools).

	* brew.fs: Implemented diff blocks for record file generation.
	  This is a test implementation for genome pools.
	  Work in progress...

	  'save-genome-pool' '(save-genome-pool)' 'save-current-genome-pool'
	  They should be able to deal with nested pools, not tested yet.
	  '?diff-block-begin' '?diff-block-end'
	  'begin-string' 'end-string'

	  '?diff-item-begin' '?diff-item-end' pepared, not used yet.

	  'diff-genome-pool'
	  'read-line-after' 'read-line-before'
	  'block-begin?' 'block-end?' giving xt as flag, (will be changed).
	  'read-line-&-test' 'read-before-&-test' 'read-after-&-test' same.
	  '(skip-block)' 'skip-block' 'copy-block-until-end'
	  'diff-block-until-end'

	  'record-changes' adapted.

2001-12-08  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_32

	* TAGS: updated.

	* DEVELOPMENT: Fixed re-playing recorded sessions.

	* BUGS: updated.

	* texi/TODO, texi/brew.info, texi/brew.texi:
	't' and 'o' key bindings to toggle display types.

	* worlds.fs: Fixing re-playing recorded sessions:
	  'erase-field' clears 'living'.

2001-12-08  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_32

	* TAGS: updated.

	* DEVELOPMENT: Fixed re-playing recorded sessions.

	* BUGS: updated.

	* texi/TODO, texi/brew.info, texi/brew.texi:
	't' and 'o' key bindings to toggle display types.

	* worlds.fs: Fixing re-playing recorded sessions:
	  'erase-field' clears 'living'.

2001-12-07  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Recording bugs with 'genomes-used' fixed.

	* TODO, BUGS: updated.

	* brew.fs: Bugfix: recording with 'genomes-used'.
	  Use 'internal+'' in 'save-actual-gene-pool'.
	  Fix 'save-current-genome-pool' (not really finished, must rethink).

	  'playback-on/off': catching 'play' can be switched off in the source
	  to debug playback problems...

	* probability-lists.fs: 're-init-probability-list' (currently unused).

	* gene-pool.fs: 'init-genome-pool' defined as word.

	* genes-0.2.fs, genes-0.3.fs: internal+'
	  Tick, searching 'gene-internals' first, then through search order,
	  used to find gene internals, but also sublists.

2001-12-06  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Force base decimal in save and record files.
	  High and medium level save functions switch temporally to decimal.
	  Record menu forces decimal when switching recording on.

	* brew.fs: 'display-menu': 't' and 'o' keybindings as in main screen.
	  Factored out '(switch-display-type)' from 'switch-display-type'.
	  '|switch-display-type|'.

	  'save-brew-variables' save '(prior-display-type)'.

	* texi/TODO: updated.

	* texi/brew.info, texi/brew.texi:
	Adapted 'Display menu' node: display snapshots.
	  'Menu current genomes': stepping through list.

	* brew.fs: Bugfix in 'menu-current-genomes':
	  'check-genome-index' from '.menu-current-genomes' not in
	  'next-genome-node'.

2001-12-05  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: 'show-next-gene-info' in 'menu-current-genomes'.
	  'l' key binding giving 'show-next-genome' for consistency.

	* DEVELOPMENT: Changed snapshot display: step snapshots.
	  Keybindings: removed obsolete upper case ones.

	* brew.fs: Removed most obsolete uppercase key bindings.
	  uppercase used for:
	  * menus
	  * if menu entry starts with a capital
	  * dangerous actions (like 'DO IT')
	  * a few cases where the lowercase is already taken

	* compile-options.fs: 'spot-display-prefered' obsolete, deleted.

	* brew.fs: Adapted 'toggle-display-type':
	  use '(prior-display-type)'.
	  ('spot-display-prefered' is obsolete, deleted).

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, benchmarks/simple-bench.fs, benchmarks/brew-crash-test.fs:
	'no-snapshots' obsolete, deleted.

	* brew.fs: Step display snapshots, frequency configurable.
	  'snapshot-frequency'
	  'no-snapshots' splitted, inverted: 'spot-snapshots' 'step-snapshots'.
	  Adaptions in 'display-menu'.
	  'step-snapshot-on' 'spot-snapshot-on' 'display-off'
	  'cycle-snapshot-type' 'switch-display-type' (former 'display-on-off')

	  Factored out '(step-redisplay)' from '(brew-redisplay)'.

	* display.fs: 'snapshot-frequency' moved to 'brew.fs'.

	* display.fs: Step snapshot implementation:
	  Separate masks 'step-snapshots' and 'spot-snapshots'.
	  'snapshot-frequency'.

	  'display-on-off' moved to 'brew.fs', as 'switch-display-type'.

	* brew-defaults.fs: Set 'snapshot-frequency'.

2001-12-04  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-init.fs: Changed random seed avoids monstruous mutation
	  at startup.

	* brew-defaults.fs: Tenfold diversification ranges: faster results.

	* brew.fs: Bugfix: restore maybe-do settings in
	  'maybe-do-with-everybody' 'simple-maybe-do-with-everybody'
	  'maybe-do-everywhere' 'simple-maybe-do-everywhere'
	  'do-with-selected-nucs' 'maybe-do-this-everywhere'.

	  No need any more to do it in 'scan-nuc-subset' 'scan-spot-subset'
	  and 'count-fitting-nucs' 'count-fitting-spots'.

	  Mark 'active' node in 'menu-current-genomes' with 'mark-next-index'
	  and clear '(next-genome-index)' on re-entering the menu.

	  Commented unused 'var-value-eq-scan-only' out.

2001-12-03  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_31

	* TAGS: updated.

	* DEVELOPMENT: 'rebirth' mutation type for old gene implementation.

	* texi/brew.info, texi/brew.texi: Added node 'Cloning nucs to a spot'.

	* brew.fs: Docu context set:
	  'Mutation types menu' 'Cloning nucs to a spot'.

	* texi/TODO, TODO: updated.

	* mutation-0.2.fs: Mutation type 'rebirth' for old genes.
	  Adaptions in 'mutate' and 'mutate?'.
	  '?end-definition-code-entry' '?code-compiled-comment'.

	  Renamed 'code-entry' to '?code-entry', same with:
	  '?start-definition-code-entry' '?mutation-start-code-entry'.

2001-12-03  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_31

	* TAGS: updated.

	* DEVELOPMENT: 'rebirth' mutation type for old gene implementation.

	* texi/brew.info, texi/brew.texi: Added node 'Cloning nucs to a spot'.

	* brew.fs: Docu context set:
	  'Mutation types menu' 'Cloning nucs to a spot'.

	* texi/TODO, TODO: updated.

	* mutation-0.2.fs: Mutation type 'rebirth' for old genes.
	  Adaptions in 'mutate' and 'mutate?'.
	  '?end-definition-code-entry' '?code-compiled-comment'.

	  Renamed 'code-entry' to '?code-entry', same with:
	  '?start-definition-code-entry' '?mutation-start-code-entry'.

2001-12-02  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: 'rebirth' mutation type reincarnating old genomes.

	* texi/brew.info, texi/brew.texi: Added node 'Genome pool'.
	  Mutation type 'rebirth'.

	  Mention menu nesting.
	  Adaptions to new development version.
	  Edits, bugfixes and some links.

	* mutation-0.3.fs: Mutation type 'rebirth' reincarnating old genomes.
	  It is quite an exception, because genome is already compiled.
	  Use new 'run-mode' mask 'compiled'.
	  Adaptions in '(mutate)' 'mutate' and 'mutate-nuc'.

	  '?end-definition-code-entry' '?code-compiled-comment'.

	  Renamed 'mutation-start-code-entry' to '?mutation-start-code-entry',
	  '?start-definition-code-entry' same.

	* brew.fs: Adaption for 'rebirth' mutation type:
	  'setup-wake-me' defined earlier.

	* brew-basics.fs: New 'run-mode' mask 'compiled'.

	* brew.fs: Link context 'Genome pool'.

	* brew.fs: 'edit-probabilities-menu': '(see)' switches '<page-see>'.
	  (Could also distinguish genes and other words).

	* DEVELOPMENT: Genomes as genes.

	* brew.fs: Redesigned 'edit-probabilities-menu'.
	  Takes the *xt* giving the pools pointer address now.
	  Builds menu title on it's own including member count.
	  Included documentation context magic.
	  Renamed '|edit-probabilities-menu|' to 'nest-probabilities-menu'.

	  'actual-pool-menu' uses 'edit-probabilities-menu' now.

	* DEVELOPMENT: Thoughts about genome pools.

	* texi/TODO, texi/brew.info, texi/brew.texi:
	  'Include produced genomes as genes' switch.

	* gene-pool.fs:   'GENOME-POOL:'
	  'genomes-used' 'current-genome-pool-xt'
	  '>genome-usage' unused. Do I need it?

	  Bugfix in 'GENE-POOL:'.
	  Good programming did let the bug have no consequences ;-)

	* probability-lists.fs: New version of 'is-in?' searching backwards.
	  Efficiency reasons: searching for used genomes starts at the more
	  decent genomes.  Old code left in for testing speed.

	* brew-basics.fs: New 'run-mode' mask 'store-genomes'.

	* brew.fs: Including genomes in 'genomes-used' if 'store-genomes?'.
	  '?increase-genome-probability', 'save-current-genome-pool'
	  Changed 'setup-wake-me'.
	  Switch 'store-genomes' in 'mutation-menu'.

	  '.actual-pool-menu' show members.

2001-12-01  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: 'Show on range' and some minor edits.

	* brew.fs: 'Individual:' does 'new-genome-id'.
	  ( Unless 'transit-12-bench' or 'brew-crash-test' defined).
	  'nuc-menu' does 'new-genome-id' if genome was changed.

	  Bugfix in 'step-display-reaction': set '(scan-type)'.

	  Subset menus show member count.
	  'count-fitting-nucs' 'count-fitting-spots'.
	  Range map is on 'r' key binding, 's' don't get overriden.

	* benchmarks/brew-crash-test.fs: Compatibility: CREATE brew-crash-test

	* TODO, BUGS: updated.

2001-11-29  Robert Epprecht  <epprecht@sunweb.ch>

	* TODO, BUGS, texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: Added node 'Menu spot subsets'.
	  Adapt 'Menus menu'.
	  'Step display interaction': use subsets for spot insted of maps.
	  'ASCII bar grafics' adapted.
	  'Menu nuc subsets' bar ranges don't mess up maybe-do settings.

	* DEVELOPMENT: Bar grafics subset: restore maybe-do settings.

	* brew.fs: 'bar-ranged-subset' does not change subset field.
	  'preserve-maybe-do-field' 'restore-maybe-do-field'.

	  '.scan-display-menu' link to context help.

	  Disable unused 'display-range-map' and '|show-range-map|'.

2001-11-28  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Use 'bar-ranged-subset' for spots too.
	  Bugfix: 'bar-ranged-subset'.
	  'scan-display-reaction' simplified.

	  Bugfix: 'nuc-detailed-scan' 'spot-detailed-scan':
	  do '(last-stat-range) off' when range is zero, so that
	  'bar-ranged-subset' does the right thing.

	  Disabled 'bar-ranged-map'.

	  Save 'maybe-do-spot-subset-field'.

2001-11-27  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: menu-spot-subsets.

	* code-chapters.txt: Added: 'menu-spot-subsets'.

	* brew.fs: 'menu-spot-subsets'
	  'scan-spot-subset'
	  'simple-maybe-do-everywhere' 'maybe-do-everywhere' (2 versions each).
	  Renamed 'scan-this-subset' to 'scan-nuc-subset'.

	  Bugfix: 'bar-ranged-subset' and 'bar-ranged-map' with all data equal.

	* cvs-tags: brew-transit_30

	* BUGS, TAGS: updated.

	* DEVELOPMENT: Interaction in scan displays and world maps.
	  Tell user when he can clone to spots.

	* TODO, texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: Additions and editions:
	  'World map interaction' 'Colouring on difference' 'Big Bang menu'.

2001-11-26  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Signaling when the user can clone a nuc into the world.
	  '(manually-selected-cell)' usage adapted.

	  Bugfix in 's' (single-step) keybinding: 'make-one-step'.

	  Bugfix in '.actual-pool-menu'.

	* keybuf.fs: 'push-key' clears buffer now on overflow.
	  (Second, disabled version leaves very last key).

2001-11-27  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_30

	* BUGS, TAGS: updated.

	* DEVELOPMENT: Interaction in scan displays and world maps.
	  Tell user when he can clone to spots.

	* TODO, texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: Additions and editions:
	  'World map interaction' 'Colouring on difference' 'Big Bang menu'.

2001-11-26  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Signaling when the user can clone a nuc into the world.
	  '(manually-selected-cell)' usage adapted.

	  Bugfix in 's' (single-step) keybinding: 'make-one-step'.

	  Bugfix in '.actual-pool-menu'.

	* keybuf.fs: 'push-key' clears buffer now on overflow.
	  (Second, disabled version leaves very last key).

2001-11-25  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: User interaction in world maps and scans.
	  'display-map-menu' '.display-map-menu' 'map-display-reaction'.
	  'display-range-map' '|show-range-map|'.
	  Use '(scan-type)' 'type-nuc' 'type-spot'.

	  'display-map' '(2map)'
	  '|show-fg-coloured-generic|' '|show-fg-coloured-on-range|'
	  '(show-selected)' 'show-selected' (rewritten).

	  User interaction in scans continued:
	  Works on both, nucs *and* spots now.
	  Fixed cursor positioning and key wait bugs. Default cursor position.

	  '(common-menu-entries)' puts 'context-help' on 'F1%'
	  and uses 'quit-menu' for 'q' to show up in key bindings.

	* brew-basics.fs: '(scan-type)' 'type-spot' 'type-nuc'.

	* menu.fs: 'show-key-bindings' linked with 'context-help'.
	  'keybinding-reaction'.
	  'wait' stores key in 'wait-key-was'.
	  'quit-menu' name to show up in keybindings.

	* code-chapters.txt: Added: display-map-menu

	* brew.fs: 'scan-display-menu' interaction in scan display:
	  '|nuc-detailed-scan-prescanned|' 'display-scan' '(display-scan-xt)'.
	  '|spot-scan-display|' using '|(spot-scan-display)|'.
	  'scan-display-reaction' 'bar-ranged-subset' 'bar-ranged-map',
	  '(last-scanned-xt)'.

	  'common-menu-entries': factored out '(common-menu-entries)' with
	  very basic functionality like cursor movement.

	  Renamed 'show-coloured-on-range' to 'show-fg-coloured-on-range'.
	  'spot-var-xt'
	  Bugfix in 'show-coloured-on-nuc-var-diff': clear-line-to-end.

	* brew-basics.fs: Added 'last-right'.

2001-11-24  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Step display user interaction and
	  rework on conditionally coloured world maps.

	* texi/brew.info, texi/brew.texi:
	Configuration of conditionally coloured maps:
	  'color-selected-fg-xt' 'color-miss-fg-xt'
	  'color-below-fg-xt' 'color-above-fg-xt'
	  'color-selected-bg-xt' 'color-miss-bg-xt'
	  'color-below-bg-xt' 'color-above-bg-xt'

	* brew.fs: Work on conditionally coloured maps:
	  'show-fg-bg-coloured' factored out general case.
	  'show-fg-coloured' 'show-bg-coloured'
	  Factored out '.last-line'.
	  '(cond-color-map)' 'world-condition-color-map',
	  'world-condition-color-diff'.
	  'generic-maybe-range>fg-color' 'show-fg-coloured-generic'
	  'show-coloured-on-range'

	  These colours get used when showing nucs or spots coloured to show
	  a certain quality like lying below, inside or above a given range:
	  'color-selected-fg-xt' 'color-miss-fg-xt'
	  'color-below-fg-xt' 'color-above-fg-xt'
	  'color-selected-bg-xt' 'color-miss-bg-xt'
	  'color-below-bg-xt' 'color-above-bg-xt'

	  Removed 'show-as-bg-color' as obsolete.

	  Factored out '(brew-redisplay)' redisplay without info line
	  and without cursor positioning.
	  '?set-cursor-after-redisplay' changed cursor setting. OK?

	* my-brew-options.fs: Example entries for some color xt's:
	  'color-selected-fg-xt' 'color-miss-fg-xt'
	  'color-below-fg-xt' 'color-above-fg-xt'
	  'color-selected-bg-xt' 'color-miss-bg-xt'
	  'color-below-bg-xt' 'color-above-bg-xt'

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, benchmarks/brew-crash-test.fs:
	Renamed 'color-of-selected' to 'color-selected-fg-xt'.

	* brew-defaults.fs:
	Renamed 'color-of-selected' to 'color-selected-fg-xt'
	  defaults to 'default-color'.

	* brew-defaults.fs: 'color-of-selected' defaults to 'cyan' now.

	* statistics.fs: Bugfix: 'init-statistic-array':
	  Default if range is smaller than screen width was one off.

2001-11-23  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: New subnodes in 'Brew main screen':
	  'World map interaction' 'Step display interaction'.
	  Links from display example nodes.

	* texi/brew.info, texi/brew.texi: Added 'variable-within'.

	* brew.fs: Working on step display interaction:
	  'step-display-reaction' adapted. Selecting a column in bar grafics
	  let's you examine the range in question.

	  'variable-within' as new maybe-do-expression. Adaptions where needed.
	  'step-display-line'

	  '(color-range-variable-xt)' '(color-range)' 'range>color'
	  'color-range!' 'show-range-map'

	* statistics.fs: 'init-statistic-array' hacked:
	  For reaction on selecting statistical data display as a menu item
	  we must be able to get some data at a time the array is already gone.
	  The following variables are a hack to be able to do that:
	  '(last-stat-min)' '(last-stat-range)' '(last-stat-slices)'

2001-11-21  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_29

	* DEVELOPMENT: Work on user interaction in step display.

	* texi/brew.info, texi/brew.texi:
	Work on rewrite of main display node and subnodes.

	* texi/TODO: updated.

	* brew.fs: '.step-display-presets' link context node.

	* TAGS, BUGS: updated.

	* my-brew-options.fs:
	  Select default type of the documentation reader here.

	* my-compile-options.fs: Change external documentation reader here.

	* brew-options.fs: 'log-mask' moved to 'my-brew-options.fs'.
	  Comment added.

	* brew.fs: '.docu-reader' edited, give more hints.
	  Include 'manual.fs' *after* 'display.fs'.
	  Main screen keybinding 'l' disabled if 'step-display-on?'.

	* manual.fs: 'context-help' give more hints in case of errors.
	  '<.docu-reader>'.

	* brew.fs: 'step-display-reaction' work in progress:
	  On continuous display go to setup, else select displayed item.

	  '.menu-this-genome' set documentation context.
	  '.step-display-presets' work in progress...

	* menu.fs: Bugfix: base was hex in '.choose-xt-menu'.

2001-11-21  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_29

	* DEVELOPMENT: Work on user interaction in step display.

	* texi/brew.info, texi/brew.texi:
	Work on rewrite of main display node and subnodes.

	* texi/TODO: updated.

	* brew.fs: '.step-display-presets' link context node.

	* TAGS, BUGS: updated.

	* my-brew-options.fs:
	  Select default type of the documentation reader here.

	* my-compile-options.fs: Change external documentation reader here.

	* brew-options.fs: 'log-mask' moved to 'my-brew-options.fs'.
	  Comment added.

	* brew.fs: '.docu-reader' edited, give more hints.
	  Include 'manual.fs' *after* 'display.fs'.
	  Main screen keybinding 'l' disabled if 'step-display-on?'.

	* manual.fs: 'context-help' give more hints in case of errors.
	  '<.docu-reader>'.

	* brew.fs: 'step-display-reaction' work in progress:
	  On continuous display go to setup, else select displayed item.

	  '.menu-this-genome' set documentation context.
	  '.step-display-presets' work in progress...

	* menu.fs: Bugfix: base was hex in '.choose-xt-menu'.

2001-11-19  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: Added node 'Context documentation'.
	  Many other additions, corrections and edits.
	  Replaced all '@dfn{}' by '@samp{}'.

	* brew.fs: '.info-line' was still buggy, fixed.

	* DEVELOPMENT: Working on context documentation interface.

	* brew.fs: '.docu-reader' debug calling documentation.
	  Bugfix: '.info-line' calls 'clear-line-to-end'.

	* TODO: updated.

	* manual.fs: Factored out 'cat-info-node-string'.

	* BUGS: updated.

2001-11-18  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Added node 'Menu Demos'.
	  Some other editing.

	* brew.fs: Use 'menu-title-entry' and 'start-title-entry'.
	  Fixed missing help-node's.

	  Swapped keys 't' and 'o' in main screen.

	* menu.fs: Menu title and menu help calling context documentation.
	  Start fresh menu screen with the active title.
	  'menu-title-entry' and 'start-title-entry'.

	  Menu usage documentation on hints line.
	  Call scroll documentation on scroll notice.

	* system-dependent.fs, pfe.fs, iForth.fs, bigFORTH.fs, gforth.fs:
	'<system>' returns error flag.

	* manual.fs: Use handled string buffers, not s-bufs.
	  Compile only if not yet defined:
	  'info-node-string-prefix' and 'info-node-string-ending'.

	* brew-basics.fs: '.centered' added:
	  Print a string centered on current line.

	* manual.fs: 'context-help' says if something went wrong.
	  'see-info-node' 'html-browse-node' return error flag.

2001-11-17  Robert Epprecht  <epprecht@sunweb.ch>

	* pfe.fs: Added '<system>' as alias to pfe 'system'.

	* cvs-tags: brew-transit_28

	* DEVELOPMENT: Function keys in all menus.

	* TAGS, TODO, texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: Added node 'Run evolution'.
	  Edited node 'Brew main screen'.

	* brew.fs: 'default-function-keys' in '<common-menu-entries>'
	  (experimental).
	  'menu-id's for 'brew' and 'nuc-menu'
	  Changed 'toggle-display-&-go' and 'rec/play-menu' to make function
	  key actions saver.

	* brew-defaults.fs: Use '|context-help|'.

	* menu.fs: 'default-function-keys' in '<common-menu-entries>'.
	  Experimental.
	  'menu-id'm for functions that want to check where they got called
	  from (like function key actions).
	  '|context-help|' forcing menu redisplay.

	* brew-basics.fs: Defining 'menu-id's: 'main-sceen-id' 'nuc-menu-id'.

2001-11-17  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_28

	* DEVELOPMENT: Function keys in all menus.

	* TAGS, TODO, texi/TODO: updated.

	* texi/brew.info, texi/brew.texi: Added node 'Run evolution'.
	  Edited node 'Brew main screen'.

	* brew.fs: 'default-function-keys' in '<common-menu-entries>'
	  (experimental).
	  'menu-id's for 'brew' and 'nuc-menu'
	  Changed 'toggle-display-&-go' and 'rec/play-menu' to make function
	  key actions saver.

	* brew-defaults.fs: Use '|context-help|'.

	* menu.fs: 'default-function-keys' in '<common-menu-entries>'.
	  Experimental.
	  'menu-id'm for functions that want to check where they got called
	  from (like function key actions).
	  '|context-help|' forcing menu redisplay.

	* brew-basics.fs: Defining 'menu-id's: 'main-sceen-id' 'nuc-menu-id'.

2001-11-14  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Use 'set-from-list'
	  to set 'manual-type' in 'system-menu'.

	* manual.fs: Use 'listed-ENUM:' for 'manual-type' identifiers.
	  'docu-types'.

	* menu.fs: 'set-from-list'
	  to be used with listed masks, listed enum's and such.

	* basics.fs: Added 'LISTED-ENUM:'.

	* cvs-tags: brew-transit_27

	* DEVELOPMENT: New brew initialisation factoring:
	  'brew-defaults.fs' and 'brew-init.fs'.

	* TAGS: Updated.

	* texi/brew.info, texi/brew.texi: Context sensitive documentation.
	  Splitting 'brew-defaults.fs' from 'brew-init.fs'.

	* TODO, texi/TODO: Updated.

	* VERSION-README: Compatibility break ahead!

	* brew-init.fs: Factored out common defaults at startup:
	  'brew-defaults.fs' sets startup defaults (except living cells).
	  'brew-init.fs' defines individuals and sets them into the world.

	* brew-defaults.fs: Defaults snipped from previous 'brew-init.fs'.

	* brew.fs: Split 'brew-defaults' (new) and 'brew-init.fs'.
	  Call 'free-field' from brew, not from 'brew-init.fs'.
	  Adapt 'read-init-file'.
	  'toggle-documentation-type' from 'system-menu'.
	  'menus-menu' on 'shift-F1-xt' (context documentation on 'F1-xt').

	* system-dependent.fs: Added '<system>' for OS shell calls.
	  '<system>' gets used to call the docu reader (only).

	* brew-defaults.fs: Start up initialization file.
	  Included after compiling brew.
	  Contains all brew defaults, but does *not* populate
	  the current world yet. (This is done by 'brew-init.fs').

	* menu.fs: Interface to context sensitive documentation.
	  'pop-menu' clears help context.
	  'context-help' to 'function-key-actions' and on 'F1-xt'.

	* gforth.fs: Added '<system>'.

2001-11-14  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_27

	* DEVELOPMENT: New brew initialisation factoring:
	  'brew-defaults.fs' and 'brew-init.fs'.

	* TAGS: Updated.

	* texi/brew.info, texi/brew.texi: Context sensitive documentation.
	  Splitting 'brew-defaults.fs' from 'brew-init.fs'.

	* TODO, texi/TODO: Updated.

	* VERSION-README: Compatibility break ahead!

	* brew-init.fs: Factored out common defaults at startup:
	  'brew-defaults.fs' sets startup defaults (except living cells).
	  'brew-init.fs' defines individuals and sets them into the world.

	* brew-defaults.fs: Defaults snipped from previous 'brew-init.fs'.

	* brew.fs: Split 'brew-defaults' (new) and 'brew-init.fs'.
	  Call 'free-field' from brew, not from 'brew-init.fs'.
	  Adapt 'read-init-file'.
	  'toggle-documentation-type' from 'system-menu'.
	  'menus-menu' on 'shift-F1-xt' (context documentation on 'F1-xt').

	* system-dependent.fs: Added '<system>' for OS shell calls.
	  '<system>' gets used to call the docu reader (only).

	* brew-defaults.fs: Start up initialization file.
	  Included after compiling brew.
	  Contains all brew defaults, but does *not* populate
	  the current world yet. (This is done by 'brew-init.fs').

	* menu.fs: Interface to context sensitive documentation.
	  'pop-menu' clears help context.
	  'context-help' to 'function-key-actions' and on 'F1-xt'.

	* gforth.fs: Added '<system>'.

2001-11-13  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Context sensitive online documentation.
	  Interface and setting context nodes.

	* DEVELOPMENT: Context sensitive online documentation.

	* manual.fs: Context sensitive online documentation.
	  Calling extern documentation reader on context help node.
	  Uses info or html browser (default: Lynx) depending 'manual-type'.

2001-11-11  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: GPL and files section in the docu.

	* TODO, texi/TODO: Updated.

	* texi/brew.info, texi/brew.texi:
	Files section in the programmers manual.

	* texi/HOWTO: Personal notes from texinfo build cycle.

2001-11-10  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.texi: Added node 'Goals'.
	  Toggling 'use-ekey' in System menu.

	* compile-options.fs, README-SECURITY, README:
	New email address: <epprecht@cybercity.ch>.

	* brew.fs: Toggle 'use-ekey' in 'system-menu'.

	* brew.fs: include common-words.fs

	* basics.fs: Factoring out words commonly found in many Forth systems
	  to 'common-words.fs'.

	  Added copyright notice.

	* common-words.fs:
	Define some words commonly found in many Forth systems
	  if they are not defined yet.

	* TODO, texi/TODO: Updated.

	* texi/brew.info, texi/brew.texi: Added GPL.

	* brew.fs: Added copyright notice.

2001-11-09  Robert Epprecht  <epprecht@sunweb.ch>

	* word-usage.fs: Reactivated older 'CREATE' version.
	  Buggy, but let's brew start at least.

2001-11-08  Robert Epprecht  <epprecht@sunweb.ch>

	* COPYING: GPL

2001-11-07  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Changes in world menu documented.

	* brew.fs: Bugfix: working on nucs from world menu.
	  Added 'do-everywhere-maybe-nuc' like 'do-everywhere' but
	  sets cp on inhabited spots.
	  'show-on-trial' (new) and 'show-selected' from world menu.

	* texi/TODO, TODO, BUGS: Updated.

	* VERSION-README: Older contents snipped.
	  This file will become obsolete soon.

	* worlds.fs, world-spots-localized.fs, world-spots-arrayed.fs, world-loop.fs, old-world.fs, brew.fs:
	Renamed 'actual-world' to 'this-world'.

2001-11-06  Robert Epprecht  <epprecht@sunweb.ch>

	* tests/test-nuc-structure.fs, benchmarks/block-var-speed-test.fs, word-usage.fs, system-dependent.fs, reporting.fs, profiling.fs, probability-lists.fs, pfe.fs, mutation-0.3.fs, mutation-0.2.fs, menu.fs, iForth.fs, gforth.fs, genes-0.3.fs, genes-0.2.fs, brew.fs, brew-basics.fs, bigFORTH.fs, TODO, TAGS, BUGS:
	Renamed 'xt>name' to 'xt>string'
	  (after a discussion in comp.lang.forth).

2001-11-05  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_26

	* DEVELOPMENT: Documentation is growing.

	* texi/brew.info, texi/brew.texi: Edits, additions, fixes, links.

	* texi/TODO: Trace separate documentation TODO list.

	* BUGS: two bugs less...

	* TODO: updated.

	* README: Updated.  Mention (new) info file.

	* menu.fs: Scale specific input implementation fix.

2001-11-02  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Scan *all* nucs in menu this genome.
	  '2-ascii-scale' moved from system to display menu.

	* BUGS, TODO: updated.

	* texi/brew.info, texi/brew.texi: Enable top node for html output.
	  Some syntax errors corrected.
	  Some editing.

2001-10-19  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.texi, texi/brew.info: Structuring user manual menu.

	* texi/brew.info, texi/brew.texi: Second pass editing started.

2001-10-18  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Nodes 'Menus menu'
	  'Example step display' 'Scale input' 'Scrolling menus'
	  and many smaller changes.

	* texi/brew.info, texi/brew.texi: Node 'Menu function keys'.

2001-10-17  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Node 'Record and Playback'
	  'Recording from scratch'  'Record benchmark' 'Playback'.

	* texi/brew.info, texi/brew.texi: Nodes 'Code file menu' 'System menu'.

2001-10-16  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Node 'Log files menu'.

	* texi/brew.info, texi/brew.texi: Node 'Big Bang menu'
	  'World size and visability' 'Big Bang'.

	* texi/brew.info, texi/brew.texi: Node 'World menu'.

2001-10-15  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi:
	Nodes 'Menu nuc subsets' 'Menu select nucs'.

	* texi/brew.info, texi/brew.texi:
	Nodes: 'Scanning nucs', 'Scanning spots'
	  'Menu current genomes' with subnodes:
	  'Menu current genomes'
	  'Colouring on equality' 'Colouring on difference'.

2001-10-14  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Nodes: 'Configurable actions'
	  'Simple nuc conditions' 'Simple spot conditions'
	  'Extended conditions'
	  'Generic nuc/spot actions' 'Nuc specific actions'.

	* texi/brew.info, texi/brew.texi:
	Nodes: 'Gene pools menu', 'Actual pool menu',
	  'Stack type symbols', 'Gene primitives'.
	  'Integer arithmetics genes', 'Stack juggling genes',
	  'Gene conditionals', 'Genes reading from memory',
	  'Genes writing to memory', 'Dealing with overflow',
	  'Nuc and spot variables', 'Insight genes'.

2001-10-12  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Changed node order.

	* texi/brew.info, texi/brew.texi:
	'Mutation menu' 'Probability lists' 'Mutation types menu'.

	* texi/brew.info, texi/brew.texi: Node 'Population control'.

	* texi/brew.info, texi/brew.texi: Node 'Food menu'.

2001-10-11  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Diversification stuff.

	* texi/brew.info, texi/brew.texi: Node 'Trial phase'.

	* texi/brew.info, texi/brew.texi: Node 'Edit spot menu'.

	* texi/brew.info, texi/brew.texi: Node 'Nuc menu'.

2001-10-10  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Node 'Individuals menu'.

	* texi/brew.info: See brew.texi

	* texi/brew.texi: Node structure so far:
	  Introduction
	      What do I mean by 'evolutionary programming'?
	  	  Simple example.
	  	  Changing code
	  	      Variable diversification
	  	      Code mutation
	      Biolocical analogy.
	  	  Artificial life
	  	  Biolocical terms
	      Brew feature overview
	      Getting started
	  	  Gforth
	  	  Portable Forth Environment
	  	  bigForth
	  	  iForth
	      Why FORTH
	  	  Note to Forth programmers
	  Brew user manual
	  	  Some brew basics
	  	      Genes
	  	      Diversification/Mutation
	  	      Classes of variables
	  		  Variable names
	  	      Run modes
	  	      Display modes
	  		  Example world mode display
	  	  Using menus
	  	      Menu example
	  		  Example key bindings
	  		  Configuring F5
	  	      Moving and selecting in menus
	  	      Key bindings in menus
	  	      Numeric input in menus
	  	      Selecting functions from a list
	  	      Using Forth in menus
	  	  Brew main screen
	  	      Time
	  	  Display menu
	  	      Configuring spot display
	  	      Step display menu
	  		  ASCII graphs
	  		  ASCII bar grafics
	  		  Text display
	  		  Menu step display
	  		  Menu continuous display
	  	      Info line
	  	  Color menu

2001-10-08  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.texi, texi/brew.info: work in progress.

2001-10-04  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Started to write documentation :-)

	* cvs-tags: brew-transit_25

	* word-usage.fs: Testing another CREATE DOES> version.
	  Still buggy...

	* memory-speed-align.fs: Changed defaults:
	  32 memory-alignement !	\ unchanged
	  32 memory-pre-pad !		\ was 0
	  32 memory-after-pad !		\ was 0

	* gforth.fs: Started fixing ekey mapping, not finished yet.

	* TODO: updated.

2001-10-01  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info, texi/brew.texi: Documentation is growing...

2001-09-30  Robert Epprecht  <epprecht@sunweb.ch>

	* texi/brew.info: Start of documentation ;-)

	* texi/brew.texi: Learning texinfo.
	  This is intended to become the documantation later on ;-)

2001-09-23  Robert Epprecht  <epprecht@sunweb.ch>

	* basics.fs: Added 'POINTER+OFFSET:'

2001-09-17  Robert Epprecht  <epprecht@sunweb.ch>

	* word-usage.fs: Next try ;-)
	  Works better, but makes troubles with 'INDIVIDUAL:'

2001-09-16  Robert Epprecht  <epprecht@sunweb.ch>

	* word-usage.fs: CREATE DOES> words almost working.
	  Interfears with fancy CREATE uses as in 'GENE:' though.

2001-09-14  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_24

	* TAGS: updated.

	* benchmark-results.txt:
	brew-transit_24 results as reference to speed experiments.

	* compile-options.fs, blockVARIABLEs-brew.fs:
	Not using block variables.

	* brew.fs: Not using block variables.
	  Changed back \VARIABLEs and \2VARIABLEs.

	* benchmark-results.txt: PRE brew-transit_24 results.
	  *Before* changing back \VARIABLES and such back to VARIABLES.

	* brew.fs: New word 'found?' (to check profiling).
	  Interpreted 'WORD' did not do what I thought it would...
	  (at least not in bigForth and pfe).

	* memory-speed-align.fs: Alignement and padding defaults changed.
	  It's tricky and inconsistent, slightly better default...

	* brew.fs: New '<goodbye-actions>'.
	  To hook in 'write-usage-profile'.

	* profiling.fs: ' write-usage-profile IS <goodbye-actions>

	* word-usage.fs: Show what it's doing (for big lists)
	  '.variable-usage' '.colon-usage' '.all-usage'.

	* DEVELOPMENT:
	Possibility to write word count profiling info to a file.

	* word-usage.fs: Bugfix '.usage-counts' stack effect.

	* brew.fs: Define 'COUNTING-WORDS' from command line.
	  This gives a brew system with self counting words.
	  You can display word usage counts or write it to a file.
	  System menu entry to do so.

	* memory-speed-align.fs: Alignement and padding set to 64 bytes.
	  (Values not tested).

	* profiling.fs: Writing word usage statistics to a file.

2001-09-13  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Nifty tools to count word usage: 'word-usage.fs'.

	* word-usage.fs: Tool profiling usage count of words.
	  Redefines some defining words to produce self counting words:
	  'VARIABLE' '2VARIABLE'
	  'VALUE' 'TO'
	  'CONSTANT' '2CONSTANT'
	  ':' ';'
	  ':NONAME'
	  'DEFER' 'IS'
	  Note that a word produced by 'MARKER' will be a noop when used.
	  Note that it does *not* do CREATE DOES> yet.

	* INPUTS/genes/conditionals.fs:
	  Compatibility to profiling with 'word-usage.fs':
	  Defining stubs without profiling.

	* world-spots-localized.fs, world-spots-arrayed.fs:
	  Compatibility to profiling with 'word-usage.fs':
	  '(dim-spots)' as colon definition.

	* brew-basics.fs: edited.

2001-09-11  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_23

	* TAGS: updated.

	* benchmark-results.txt:
	  'brew-transit_23' results replacing wrong 'brew-transit_22' results.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Removing a line break.

	* DEVELOPMENT: 'brew-transit_23' replaces 'brew-transit_22'
	  There was an error in 22, defining some vars as world-vars.
	  Benchmark results redone...

	* brew.fs: Clear screen after loading.
	  For setups that take some time for the initial screen to show up.

	* worlds.fs: There was an error in the last version:
	  '(mutated-max)' 'compiled-genes' 'nuc-do-cost' 'code-price'
	  where defined twice. *Now* they are defined back to VARIABLEs.
	  'brew-transit_22' was wrong and replaced by 'brew-transit_23'.

	* benchmark-results.txt: Some errors corrected and data added.

2001-09-10  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_22

	* benchmark-results.txt: Many, many 'brew-transit_22' results...

	* compile-options.fs: Use VARIABLEs defined in a row, no blocks.

	* TODO: updated.

	* TAGS: updated. 'dummy-block-variables' is 1.

	* DEVELOPMENT: Experimenting with block variables.

	* brew.fs: Use block variables for about all variables in this file.
	  State as in 'brew-transit_22'.  This will be redone.
	  'brew-transit_22' is only to do get benchmark results.

	  tristate compile option 'dummy-block-variables':
	  FALSE:       use block-VARIABLEs
	  1: (default) use Forth VARIABLEs defined when registered for a block
	  2:           use Forth VARIABLEs defined when commented out in source
	  	       (see '\VARIABLE' '\2VARIABLE').

	* blockVARIABLEs-brew.fs:
	Experimental use of block variables for 'brew.fs'.
	  State as in 'brew-transit_22'.  This will be redone.
	  'brew-transit_22' is only to do get benchmark results.

	  Redefining just about all variables from 'brew.fs' depending on
	  tristate compile option 'dummy-block-variables':
	  FALSE: use block variables
	  1:     use Forth variables defined when registered for a block
	  2:     use Forth variables defined when commented out in source
	  	 as '\VARIABLE' or '\2VARIABLE'

	* worlds.fs: Temporary defined back to ordinary varables:
	  '(mutated-max)' 'compiled-genes' 'nuc-do-cost' 'code-price'.

	* old-world.fs: Some variables moved here from 'brew.fs':
	  '(mutated-max)' 'compiled-genes' 'nuc-do-cost' 'code-price'.

2001-09-09  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Include 'memory-speed-align.fs'.
	  Comments edited.

	* basics.fs: Comment about alignement in 'BASE+FLOAT-OFFSET:'.

	* compile-options.fs: Tristate 'dummy-block-variables' compile option.
	  ('dummy-block-variables' replaces 'use-block-variables').

	* block-variables.fs: Compile time tristate switch:
	  'dummy-block-variables' (replaces 'use-block-variables').
	  Use block variables or use ordinary variables either when registered
	  for the block or when commented out in the source with the special
	  comment words '\VARIABLE' '\2VARIABLE' '\FVARIABLE'.

	  Added 'block-2VARIABLE:' '\VARIABLE' '\2VARIABLE' '\FVARIABLE'.

	* symbols-stack.fs: Edited and updated a bit.

	* block-variables.fs: Use 'allocate-for-speed' to get blocks.
	  So we have them aligned and padded for speed requirements.

	  You can switch at compile time with 'use-block-variables' if
	  block variables are used at all.
	  If switched off it just compiles ordinary variables.

	  Comments inserted and edited.

	* dp-speed-align.fs: Aligning and padding FORTH data space.

	* memory-speed-align.fs: 'allocate-for-speed' memory allocation
	  takes care of aligning and pre/after padding requirements.

	* dp-speed-align.fs: Renamed 'speed-align' to 'dp-speed-align.fs'.

	* cvs-tags: brew-transit_21

	* BUGS: updated.

	* DEVELOPMENT: Multidimensional worlds.
	  Brewing and displaying starts to work.

	  Preparing to use block variables.

	* TAGS: updated.

	* benchmark-results.txt: Added 'brew-transit_21' results.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Removed final line break.

	* TODO: updated again.

	* TODO: updated.

	* old-world.fs: 'cloned' 'died' arrived here a bit late...

	* brew.fs: Preparing to use block variables.
	  'block-variables.fs' factored out from 'brew-basics.fs'.

	  Fixed 'transit-11-bench-A' 'transit-12-bench' compatibility:
	  'bcompat-11-12.fs'.

	  Factored out some left over words to 'old-world.fs'.

	  '?record-big-bang' 'save-for-each-dimension' 'save-world-parameters'

	  Added: 'num2out'

	* old-world.fs: '.world' 'someone-here?' 'world-free-neighbor-spot?'
	  moved here from 'brew.fs'.

	* bcompat-11-12.fs: 'transit-11-bench-A' and 'transit-12-bench'
	  downwards compatibility.

2001-09-08  Robert Epprecht  <epprecht@sunweb.ch>

	* benchmarks/block-var-speed-test.fs:
	Added value test and benchmark results.

	* benchmarks/block-var-speed-test.fs:
	Speed test for the new block-variables.

	* worlds.fs: Double world variables deleted.

	* lists.fs: '2>list'.

	* block-variables.fs: Dummy 'open-memory-block-xt' for benchmarking.

	* compile-options.fs: 'use-block-variables' compile option.

	* brew-basics.fs: Factored out 'block-variables.fs'.
	  Speed alignement stuff deleted.

	* block-variables.fs: Fast, named variables.
	  Stored in cache friendly blocks, far away from code and such...

	* brew.fs: Fixed 'copy-qualities2future':
	  for any number of qualities.  No longer deferred.

	* world-spots-localized.fs, world-spots-arrayed.fs:
	  Dependency of 'copy-qualities2future' from spot var order marked.

	* TODO: updated.

	* brew.fs: In huge worlds you had to wait too long to see a reaction
	  on your input.  So I inserted a couple of PAGEs.

	* world-spots-localized.fs, world-spots-arrayed.fs:
	'(big-bang)' sets default visability ranges.

	* worlds.fs: Things start working...

	  New world variables 'backgound-off' 'neighbour-vectors' 'directions'
	  'dim-step'
	  Scratch world variables: 'shuffling-offsets' 'coordinates'

	  Words to work on coordinates:
	  'coordinates!' 'coordinates@' 'spot>coordinates' 'coordinates>spot'
	  'coordinates+'

	  First try to find a random free neighbour spot by shuffling
	  direction vectors.  I'm not happy with it's results yet.

	  '3^n' 'init-neighbour-vectors' 'allocate-neighbour-vectors'
	  'neighbour-vectors-pointers' 'setup-neighbour-vectors'
	  'neighbour-vectors-address'
	  'prepare-shuffling' 'shuffle-vector' (unused) 'shuffled@'

	  'someone-here?' 'world-free-neighbor-spot?'

	  'initialise-dim-steps'

	* world-loop.fs:
	'layer-delay' to display 2D planes one after the other.

	* menu.fs: '.menu-short-help' gives 'k' hint for key bindings.

	* brew.fs: Big Bang menu. 'big-bang-menu' '|big-bang|'

	  Warning about broken compatibility of benchmarks with 'new-worlds'.
	  'dimensions-visability-entry' adapted.

	* world-loop.fs: Starts to be partly usable.
	  Looping over new style worlds either brewing or displaying.

	  '(background-off)' skipping background display after a plane.
	  'this-dimension-loop' don't need the coordinate.

	  Display related words: '.world'
	  'spot-show' '?next-spot-show' 'next-spot-show'
	  'display-row-maybe-visible' 'display-row-visible' 'field-display-row'
	  'layer-delay' delaying after displaying a plane.

	* brew.fs: Adaptions to new worlds display:
	  '.world' 'world-free-neighbor-spot?' defined depending 'new-worlds'.
	  Use '(background-off)' and '(background-skipped)' 'layer-delay'.

2001-09-06  Robert Epprecht  <epprecht@sunweb.ch>

	* world-spots-localized.fs, world-spots-arrayed.fs:
	'(big-bang)' sets directions and neighbour vectors.
	  Use 'neighbour-vectors-address' to possibly initialise table.
	  Store base address at 'neighbour-vectors'.
	  Set 'directions'.

	* brew.fs: New worlds display related work.
	  'dimensions-visability-entry'

	  World menu displays dimension and size info.
	  Clear screen in 'brew' when the screen is smaller than brew screen.
	  'someone-here?' defined 'new-world' dependent.

2001-09-05  Robert Epprecht  <epprecht@sunweb.ch>

	* world-spots-localized.fs, world-spots-arrayed.fs:
	Use 'initialise-dim-steps'.

2001-09-03  Robert Epprecht  <epprecht@sunweb.ch>

	* world-loop.fs: Use 'brew-depth-adjust' 'brew-depth-reset'.
	  '(brew-depth-offset)'

	* brew.fs: Changed 'brew-depth':
	  'brew-depth' 'brew-depth-adjust' 'brew-depth-reset'
	  '(brew-depth)' '(brew-depth-offset)'

	* worlds.fs: Visability ranges for new world loop.
	  'visability-on' 'visability-off'

	* world-loop.fs: Looping over all spots of new worlds.
	  Doing spots and nucs actions and do world display.

	  Work in progress...
	  (OK for sceen sized planes).

	* speed-align.fs: Code and data block padding and aligning.
	  Work in progress, not usefull yet.

	* compile-options.fs: Code and data alignement section.
	  Not used yet.

	* brew.fs: Use new 'world-loop.fs'.
	  Old 'world-do' factored out to 'old-world-loop.fs'.

	  'include speed-align.fs' ... but commented out, not really tested yet

	* brew-basics.fs: Alignement and padding for speed related:
	  Work in progress...
	  'speed-alignement' is a VALUE now.
	  'speed-pad' alternative definitions for testing.

	  names changed from 'blocked' to 'block':
	  'block-VARIABLE:' 'define-block-variables'

	* old-world-loop.fs: Old 'world-do' factored out.

2001-09-01  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_20

	* TAGS: updated.

	* benchmark-results.txt: Added brew-transit_20 benchmark results.
	  ('alternative-nuc-vars' switched off as variant).

	* DEVELOPMENT: '.menu-short-help'

	  Temporary added compile switch 'alternative-nuc-vars'.

	* TODO: updated.

	* brew.fs: 'alternative-nuc-vars' switches 'nuc-var:' definition.
	  Use 'BASE+OFFSET:' not 'CREATE DOES>'.

	* menu.fs: 'show-key-bindings' edited.

	* compile-options.fs:
	Temporally added compile switch 'alternative-nuc-vars'
	  Switches using 'BASE+OFFSET:' instead of 'CREATE DOES>'.
	  This compile option will probably disappear again.

	* brew.fs: Adapted all scrolling ranges.
	  Scrolling in '.spot-diversification-menu' implemented.
	  Bugfix in '.menu-select-spot-var'.
	  Minor changes in color menu.

	* menu.fs: Changed '.menu-short-help' acting more intelligent.
	  (Some of the menu hints are menu entries too).

	* TODO: updated.

	* DEVELOPMENT: Highlighting menu entries.
	  Reset brew.
	  Nuc vars using 'BASE+OFFSET:'

	* brew.fs: Nuc vars using 'BASE+OFFSET:' a bit faster.

	  Making menus more user friendly, adaptions to field highlighting,
	  'show-key-bindings' and jumping to next field with <TAB>:

	  Use '.menu-expansion' '.ON-off-entry' and '.YES-NO-entry'
	      '(highlite-active)'
	  Adapted '.code-file-ON-off'

	  '<common-menu-entries>' Adaptions to 'show-key-bindings' 'q'
	  'highlite-active-fields' and 'goto-next-menu-item'

	  Words to give better 'show-key-bindings' output:
	  'sow-some-clones' 'sow-some-diversified'.

	  Possibility to reset brew from system menu:  'read-init-file'

	* menu.fs: Making menus more user friendly:
	  Jump to next active field, highlighting active menu fields.

	  Highlighting active menu entries:

	  'menu-colors-xt' '(highlite-active)' 'highlite-active-fields'
	  'menu-highlite-on' 'menu-highlite-off' '.menu-expansion'
	  '.YES-NO-entry' '.ON-off-entry'

	  Adaptions in: 'from-here' 'up-to-here' 'same-menu-entry'
	  'noop-entry' 'menu-entry-value' 'menu-entry-variable'
	  'push-menu' 'pop-menu' 'menu-entry-scale'

	  'goto-next-menu-item' on <TAB>:  use title colours.

	  '<common-menu-entries>' default adapted.
	  '.menu-short-help' small bugfix, but still not perfect.
	  Bugfix: Leaving 'choose-xt-menu' with 'q'.

	* DEVELOPMENT: Making menus more user friendly:
	  'goto-next-menu-item' on <tab>.
	  Highlighting active menu entries.

2001-08-30  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_19

	* TAGS: updated.

	* DEVELOPMENT: 'show-key-bindings'.

	* benchmark-results.txt: transit_19 benchmark results.

	* brew.fs: 'cell-division' code better structured.

	* TODO: updated.

	* brew-basics.fs: '.screen-column-min'

	* brew.fs: Use names '<common-menu-entries>' 'page-see'

	* menu.fs: 'show-key-bindings' showing active key bindings.
	  A lot of related words.

	  'choose-xt-menu' related source moved here and others:
	  '.menu-short-help'
	  'title-colors' 'end-title' '.menu-title' 'menu-title!'

	  Predefined <common-menu-entries> (deferred).
	  Predefined <page-see> (deferred).

	* brew.fs: Use 'change-named-variable' (renamed).

	* brew.fs: 'show-key-bindings' and related changes.
	  ('k' now showing active keybindings in menus).

	  A *lot* of adaptions of menu stuff...

	  Factored out menu related code to 'menu.fs':
	  All 'choose-xt-menu' related source moved to 'menu.fs'.

	  Some other menu words moved to 'menu.fs' too:
	  '.menu-short-help'
	  'title-colors' 'end-title' '.menu-title' 'menu-title!'

	  common-menu-entries' is deferred from 'menu.fs' now.
	  Redefined here.

	  'page-see' is deferred from 'menu.fs' now.
	  Redefined here to possibly include genes.

	  Color menu edited.

	  Other changes and bugfixes here and there ;-)

	* code-chapters.txt: 'choose-xt-menu' went to 'menu.fs'.

	* basics.fs: Reintroduced '.bin' '.hex'.

2001-08-28  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-init.fs: 'food' not '<food>' in '(xt-do-it-1)'.

	* old-world.fs: 'food' not '<food>' in 'spot-var-xts'.

	* fileselect.fs:
	  '.fileselect-menu' key entry for filename start char.
	  '(start-char)' 'read-dir-next' '.fileselect-menu'.

2001-08-27  Robert Epprecht  <epprecht@sunweb.ch>

	* world-spots-arrayed.fs:
	Moved definition of VALUE spots for cache efficiency.

	Use cvs" to preserve cvs versionheaders from expanding.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs, worlds.fs, world-spots-localized.fs, stringbuf-0.4.fs, stringbuf-0.3.fs, old-world.fs, mutation-0.3.fs, mutation-0.2.fs, genes-0.3.fs, genes-0.2.fs:
	Use cvs" to preserve cvs versionheaders from expanding.

	* benchmark-results.txt:
	  CVS had overritten all version information expanding IDs...

	* brew.fs: cvs" Id: ..." avoids cvs id expansion.
	  'out-cvs-ID-not-expanding' obsolete.  'out-tab-comment'

	  Experiment: basic linear equation system.

	* DEVELOPMENT: Avoid expansion of cvs ID's included in other files.

2001-08-26  Robert Epprecht  <epprecht@sunweb.ch>

	* TODO: updated.

	* old-world.fs: 'spot-offset' changed from VARIABLE to VALUE.

	* benchmark-results.txt:
	Testing old-worlds 'spot-offset' as VARIABLE and (new) as VALUE.

	* brew.fs: Don't use 'buffer-pointer'.

	* fileselect.fs: Use 'string@' and 'string-size!'
	  Don't use 'buffer-pointer'.

	* genes-0.3.fs: Use 'string-size!' not 'buffer-pointer'.

	* stringbuf-0.3.fs: 'string-size!' added.
	  'buffer-pointer' not needed from outside any more.

	* stringbuf-0.4.fs: 'string-size!' added (eliminate 'buffer-pointer').

	* benchmark-results.txt: Included 'displayed-bench' ;-)

	* benchmark-results.txt: Benchmark results.

	* genes/spot-properties.fs, genes/nuc-parameters.fs, genes/genes-qualities.fs, genes/genes-organs.fs, INPUTS/genes/spot-properties.fs, INPUTS/genes/qualities.fs, INPUTS/genes/organs.fs, INPUTS/genes/nuc-parameters.fs, reporting.fs, fileselect.fs, world-spots-localized.fs, world-spots-arrayed.fs, old-world.fs, mutation-0.2.fs, mutation-0.3.fs, genes-0.2.fs, genes-0.3.fs, brew-basics.fs, brew.fs, stringbuf-0.3.fs, stringbuf-0.4.fs:
	  Renamed 'buffer-as-string' to 'string@' :-)

	* brew.fs: 'stringbuf-0.4.fs' uses 'STRINGBUF-HANDLE:' as name.

	* stringbuf-0.4.fs: Renamed 'STRINGBUF-POINTER:' to 'STRINGBUF-HANDLE:'

	* cvs-tags: brew-transit_18

	* TAGS: updated.

	* DEVELOPMENT: Allocation pointers and new string buffer version.

	* compile-options.fs: 'new-stringbufs' comment updated.

	* brew.fs: '.version' shows 'new-stringbufs'.

	* brew.fs: Use 'new-stringbufs' compile option.
	  '.version' and '.brew-version' show 'stringbuf-version'.

	  Factored out 'log-cat-step&spot'.

	* allocation-pointers.fs: Tested and fixed.
	  '>ptrs-end' 'close?-new-bufs-this-array' 'close-not-listed-buffers'

2001-08-25  Robert Epprecht  <epprecht@sunweb.ch>

	* mutation-0.3.fs: Use 'double-stringbuf' and 'buffer-data-addr'.
	  Upwards compatibility with new stringbuffer package.

	  'log-cat-step&spot' moved out of here.

	* mutation-0.2.fs: Use 'double-stringbuf' and 'buffer-data-addr'.
	  Upwards compatibility with new stringbuffer package.

	* stringbuf-0.3.fs, stringbuf-0.4.fs:
	Added 'stringbuf-version' for tests.

	* compile-options.fs: Added 'new-stringbufs' compile option.

	* stringbuf-0.4.fs: Seems to work now.
	  Compiling 'show' earlier to help checking functionality
	.

	* stringbuf-0.4.fs: Working through it.

	* allocation-pointers.fs: Different changes.

	* allocation-pointers.fs: edited and modified.

	* simple-stringbuf.fs: S-buffs factored out from 'stringbuf-0.3.fs'.

	* allocation-pointers.fs: Work continued...
	  'resize-allocated'
	  'allocate-to-pointer' 'open-allocate'

	  Added list of open buffers for error recovery:
	  'opened-buffers-to-list' 'close-not-listed-buffers'.

	* stringbuf-0.3.fs: Factored out s-bufs to 'simple-stringbuf.fs'.
	  Hide more internals: 'stringbuf-descriptor' 'buffer-data-addr'.

	  Upwards compatibility: 'double-stringbuf'.

	* fileselect.fs: Use 'buffer-pointer'.

	* brew-basics.fs: 'compile-listed-?-and-!'
	  increased default buffer size.

2001-08-24  Robert Epprecht  <epprecht@sunweb.ch>

	* allocation-pointers.fs: Mechanism to allocate memory and to get an
	  initialized pointer handled out of a list of linked pointer arrays.

	  Comments added.  Ready for testing.

	* allocation-pointers.fs, stringbuf-0.4.fs: Work just started...

	* mutation-0.3.fs: Changed logging of mutations.
	  It's easier to track now (with only 'log-mutation' on).
	  'log-cat-step&spot'.

	* tests/test-for_at-x-y.fs:
	renamed test-for-at_x_y.fs to test-for_at-x-y.fs

2001-08-23  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Spot data as arrays for new worlds.
	  Faster than hot-spots.

	* compile-options.fs: 'localise-spot-data'
	  Switches between hot-spots and arrays.
	  ('localise-spot-data' FALSE is much quicker here).

	* TODO: updated.

	* brew.fs: '.brew-version' for benchmarks.
	  '.version' a bit expanded.

	  Added '.quit-brew?' and edited text after leaving brew.

	  +sum' experiment: Comments edited, included some results.
	  'goodbye' does cr.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Use '.brew-version'.

	* worlds.fs: Factored out spot related stuff:
	  Depending on 'localize-spot-data' include either
	  'world-spots-arrayed.fs' or 'world-spots-localized.fs'.

	* world-spots-arrayed.fs:
	Arrayed spot stuff factored out from 'worlds.fs'.
	  Included if 'localize-spot-data' is FALSE.

	* world-spots-localized.fs:
	Localized spot stuff factored out from 'worlds.fs'.
	  Included if 'localize-spot-data' is TRUE.

2001-08-22  Robert Epprecht  <epprecht@sunweb.ch>

	* compile-options.fs: New option 'spot-alignement#'.
	  Does *not* help for speed here.

	* DEVELOPMENT: Spot alignement.

	* TODO: Some more ideas added...

	* worlds.fs: Bugfix:
	  use 'world-header-length#' not 'world-descriptor-length#'.
	  ('world-descriptor-length#' is not used any more).

	  Added: 'free-world-memory' and 'used-spot-data-size#'.
	  Stack comments im '(big-bang)'.

	* basics.fs: Added 'n-align' for address alignement.

	* cvs-tags: brew-transit_17

	* TAGS: updated.

	* DEVELOPMENT: New worlds rewritten.  Work in progress...
	  Multiple, multi dimensional worlds should be possible.
	  Display engine not written yet (using old one, screen sized).
	  Direction words not written yet (using old ones, 2D only).

	  Transit benchmarks run OK, but slow.

	  Work on AT? and bigFORTH problems.

	* worlds.fs: 'faligned' not used yet.
	  Some Forth might not have it,
	  or it's not in the default search order.

	* basics.fs: ': BASE+FLOAT-OFFSET:' only if 'floats' is defined.

	* brew.fs: Corrected 'insert-record-file-header'
	  CVS did expand the version headers of the previous version...
	  'out-cvs-ID-not-expanding'.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Deleted wrong creation version ID's.
	  (CVS had expanded them ;-)

	* benchmarks/transit-11-bench-A.fs: Displaying state of 'new-worlds'.

	* code-chapters.txt: New arrangement for new worlds.

	* brew.fs: Adaptions to 'new-worlds':
	  Factored out all world/time related stuff into
	  'old-world.fs'.
	  First new-worlds version in 'worlds.fs'.

	  Many variables are now world local, some more to come,
	  like population control settings.

	  Rearranged some code chapters.

	* TODO: updated.

	* worlds.fs: First working new world version.
	  Multi dimensional, multiple worlds should be possible now.

	  Only direction words for two dimensions yet and no display engine
	  yet, so can only be used for screen sized (two dimensional) worlds.

	  Runs 'transit' benchmarks OK, but slow...

	* tests/test-for-at_x_y.fs: Regarding bigFORTH 'at?' problem.
	  Test for 'at?', not working yet...

	* system-dependent.fs, bigFORTH.fs: bigFORTH 'at?' problem:
	  Note about alternative 'screen-column' in 'brew-basics.fs'.
	  Temporary fix only.

	* brew-basics.fs: World dependent stuff moved out here:
	  'spot' 'step' 'spot>at'.

	  defer <food> declared here now.
	  'child-spot' moved to 'brew.fs'.

	  bigFORTH 'at?' problem leads to a alternative 'screen-column'.
	  This is only a temporary fix.

	* basics.fs: Compile named offsets to a given base (as xt):
	  'BASE+OFFSET:' and 'BASE+FLOAT-OFFSET:'.

	* benchmarks/transit-12-bench.fs: Adaption to new worlds:
	  Display 'world/time-version' and 'bench-version'.

	* benchmarks/transit-11-bench-A.fs: Displaying 'bench-version'.
	  Renamed 'world-version' to 'world/time-version',
	  as name was taken.

	* old-world.fs: 'world-version' was taken.
	  Renamed to 'world/time-version'.

	* mutation-0.2.fs, mutation-0.3.fs: Adaptions to new worlds:
	  'compiled-genes' and '(mutated-max)' moved to 'brew.fs'.

	* compile-options.fs: New compile option 'new-worlds'.
	  (Deactivated because it's slow).

	* benchmarks/transit-11-bench-A.fs: Show 'world-version'.

	* old-world.fs: Factored out world/time related stuff.
	  Version used by 'brew 1.211' from 2001/08/19
	  with minor adaptions for upwards compatibility.

2001-08-21  Robert Epprecht  <epprecht@sunweb.ch>

	* debuging.fs: 'watch-spot' stuff switched off.

2001-08-19  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Key code consistency:
	  'l' to see next genome in 'menu-current-genomes'.

2001-08-10  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Debugging: stack to file.
	  '.o' write the stack to outfile in the form Gforth .s does.

2001-08-06  Robert Epprecht  <epprecht@sunweb.ch>

	* BUGS: updated.

	* bigFORTH.fs: 'use-fileselect' bigForth 2.0.3 has 'open-dir'.

	* cvs-tags: brew-transit_16

	* TAGS: updated.

	* DEVELOPMENT: Give some quick&dirty initialisation
	 'sum' experiment.

	  Simple linear equation system (does not give good results yet).
	  Experiment setup for linear equation systems seems flawed...

	* brew.fs: Added 'eat-scored-logged'.
	  This should help analyzing bad experiment setups...

	* brew-init.fs:
	Provide some quick&dirty initialisation for sum experiment.
	  Gene pool severely out of balance.
	  See  file DEVELOPMENT, comment from 4.8.2001.

	* brew.fs: Added two experiments:
	  'sum' and 'simple linear equation system'.
	  (Both linear equation experiments are not ready for use yet).

	  Renamed 'cheat-linear-B' to 'cheat-linear'.

	  Bugfix: '?record-?do-everywhere-generic'
	          must do 'present-initializes-future'.

	  Added some new keybindings.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Reactivated 'nucs-checksum'.
	  Found a bigForth 2.0.2 bug in 'search'.  Workaround installed.

	  'spot-diversification-mask' off to run on new 'brew' version.

	* code-chapters.txt: updated.

	* bigFORTH.fs: Check for 'search' bug in bigFORTH rev. 2.0.2

2001-08-04  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Heavy debugging sessions caused by a bigForth bug.

	* TODO: updated.

	* benchmarks/transit-12-bench.fs:
	  Deactivated 'nucs-checksum' until a bigForth bug gets fixed.
	  Result *is* valid anyway.

2001-08-02  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Debugging related small extensions:
	  (Why does 'transit-11-bench-A' with bigForth give a wrong
	   nucs-checksum?)

	  'log-my-div-bitmask'
	  'save-all-nucs' unfinished, but usuble for my current tests.
	  (It does not even save genes yet, because 'save-nucs-genes-trial'
	   is not written).

2001-07-27  Robert Epprecht  <epprecht@sunweb.ch>

	* mutation-0.3.fs, mutation-0.2.fs:
	'follow-&-add' can do 'log-my-div-bitmask'.

2001-07-14  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_15

	* DEVELOPMENT: Bugfix when 'new-genes' was FALSE.

	* TAGS, TODO: updated.

	* brew.fs: Some corrections in '.keybindings'.

	* benchmarks/transit-11-bench-A.fs:
	Deactivated 'nucs-checksum' temporally,
	  because of problems in bigForth witn 'new-gens' on.

	* brew-basics.fs: 'speed-align' simpler definition.
	  Comments added.

	* brew-basics.fs:
	  Words related to aligning chunks of variables for speed reasons:
	  'speed-alignement' 'speed-align' 'speed-pad'
	  'init-var-block' 'blocked-VARIABLE:' 'define-blocked-variables'.

	* fileselect.fs: Use '[UNDEFINED]' '[DEFINED]'.

	* pfe.fs: 'use-fileselect'.

	* TODO: updated.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	Showing state of 'new-genes'.

2001-07-12  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Bugfix for old genes:
	  Linear equation system code had a bug when 'new-genes' was FALSE.

	* fileselect.fs: Changed menu return flag implementation:
	  'n'th-file-name' does no longer return a (meaningless) true flag,
	  but 'fileselect-menu' uses the do-after mechanism.

2001-07-11  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_14

	* TODO, TAGS: updated.

	* brew.fs: 'will-die?' is better coded.

	* basics.fs: 'char-search-backwards' on nul strings.

	* DEVELOPMENT: Changed nuc variable order.
	  Assertions with changed nuc variable count.
	  Fileselect.

	* fileselect.fs: Seems to work now.
	  You can not leave brew directory with this version.

	* stringbuf-0.3.fs: Added 's-string!'.

	* fileselect.fs: Still buggy...
	  'n'th-file-name' gives directory name when 'read-dir-next' fails.

	* BUGS: 'fileselect' bugs.  Others removed.

	* brew.fs: Make benchmarks run with changed nuc structure:
	  '+nuc-checksum' does not sum up 'id' 'genome-id' and 'length'.

	  Note that all variables are included anyway, even if 'length' is
	  not itself added.  As variables that are zero have no effect, an
	  assertion made on a certain nuc structure should run OK on a
	  longer nuc if all the new variables are not changed from zero.

	  Changed order of nuc variables to make '+nuc-checksum' and 'save-nuc'
	  simpler.

	  '+nuc-checksum' disregards 'length' as value.  Note that despite of
	  this the nucs variables are summed up over the whole nuc length.

	  'save-nuc' does not save '(id)' any more (it did when 'making-bench?').
	  It uses 'nuc-length#' instead of the real numeric value now to make it
	  run on different nuc configurations.  The numeric value is saved (before
	  resetting it to 'nuc-length#') for informative reasons.

	  Bugfix 'assert@=' and 'assert2@=': show values in right order.

	  'playback-on/off' shows 'step' in case of playback failures.

	* benchmarks/transit-12-bench.fs, benchmarks/transit-11-bench-A.fs:
	  Make it run indifferent from starting point and nuc structure.

	* benchmarks/brew-crash-test.fs: Test file for coming brew changes:
	  This is 'transit-12-bench.fs' with all the assertions left in.

2001-07-10  Robert Epprecht  <epprecht@sunweb.ch>

	* TODO: updated.

2001-07-09  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Work on scrolling fileselect menu.

	* fileselect.fs: First scrolling version:  '.fileselect-menu'
	  'files-in-current-dir' to get count for scrolling range.
	  'close-current-dir' does silently ignore failure now.
	  '?open-directory' (could maybe get incorporated in 'open-directory').

	  Spelling corrected:
	  'normalize-current-dir-name' to 'normalise-current-dir-name'.

	* brew.fs: Use new scrolling fileselect version.
	  Change in 'playback-on/off'.
	  You can playback now any Forth code from anywhere.
	  On error show filename again.

	  Better assertion display with random generators:
	  'assert2@=' 'assert-2variable-entry' used for 'random-generalized'.

	  'record-changes' does not use '(scratch-buf)' any more.

	* benchmarks/transit-12-bench.fs:
	Use text coding of diversification masks.

	* BUGS: Two fixed :-)

2001-07-08  Robert Epprecht  <epprecht@sunweb.ch>

	* compile-options.fs: Try new nuc and spot var numbers.

	* DEVELOPMENT: Completed different things, bugfixes.

	* BUGS: three more pending...

	* TODO: updated.

	* brew.fs: 'save-color-scales'.

	* brew.fs: Bugfix editing recursive probability lists:
	  '.edit-probabilities-menu' does 'update' now.

	  You actually *can* select a wake-me action in the nuc menu now.

	  Bugfix with 'spot-div-masks': define 'food-div'.

	  Redone 'field-variable-text' and renamed to 'spot-variable-name'.

	  Redone spot variable to bg color stuff:  'color-scale'
	  'define-bg>color-words' does all the work for all the spot vars.
	  Many separate definitions got obsolete.

	  'show-genome-b' is new look-at default.

	  Experiment with linear eqution systems rewritten.  Not ready.

	  More things, cosmetics.

	* probability-lists.fs: Debugging help: '.xt-pool'
	  (switched off).

	* genes-0.3.fs: '.gene-info' shows a zero flag only once.

	* benchmarks/transit-11-bench-A.fs, benchmarks/transit-12-bench.fs:
	cosmetic editing.

2001-07-07  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Bugfix changing probabilities:
	  'actual-pool-menu' and 'edit-probabilities-menu' didn't set
	  dirty bit.  I do 'update' now.

	  BTW: 'actual-pool-menu' seems redundant.

	* BUGS: The bug was in normal brewing, *not* in record/playback.
	  fixed.

	* lists.fs: '.all-node-data' '.all-list-data' switchable now.
	  (They are switched off by default).

	* mutation-0.3.fs, mutation-0.2.fs:
	Ringing when exceeding genome size is switchable now.

	* brew.fs: Added '(exceeding-size-ring)'.

	* probability-lists.fs: Debugging help: '.xt-pool'

	* BUGS: You can not change probability lists when recording!

	* mutation-0.3.fs: Bugfix in 'mutate' when 'playing-bench?'.

	* brew.fs: Changed default of spot diversification range.
	  Cosmetics in diversification menu.

	* brew.fs: Keybindings in diversification menu.

	* brew.fs: Fixed diversification masks in 'linear' individuals.

	  Feedback in food menu when feeding manually.
	  Cosmetics in diversification menu.

	* TODO: updated.

	* mutation-0.3.fs, mutation-0.2.fs:
	  Don't ring on excessive genome size when running a benchmark.

	* brew.fs: In case of errors playback can be repeated for debugging.

	* TODO: More todo items done ;-)

	* brew.fs: Better 'define-properties' definition.

	  Bugfix: Less than three organs are possible now.

	* mutation-0.2.fs: Size limitation for old genes version too:
	  It's a bit a kludge, but seems to work.  (I'll probably drop
	  support for this genes/mutations version anyway soon).

	  'mutation-max-ollowed-items' '(gene-items)' '(mutation-items)'
	  '(head-items)' '(segment-items)' '(tail-items)'
	  Changed 'xt>cutten-strings' and mutation procedures.

	* mutation-0.3.fs:
	Log and code file entries, when mutation gets aborted
	  because of excessive length.

	  Don't show special length exceeded messages in benchmarks.

	* brew.fs: Support genome length limit for old genes version.

2001-07-06  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Limit for genome length introduced.

	* mutation-0.3.fs: Added a size limit for produced genomes.
	  When a the actual genepool is unbalanced there's the danger
	  of endless mutations.  It's easy to overcome by balancing
	  probabilities, but might be difficult for a beginner.
	  This avoids this problem, but adds a time penalty.

	  'mutation-max-ollowed-items' '(mutation-items)'
	  '|xt-to-internals-buffer|'

	  As (mutate) trows when the size is exceeded we have to close
	  open stringbuffers:
	  'opened-buffers-to-list' 'close-not-listed-buffers' '(open-buffers)'.

	* brew.fs: 'mutation-max-ollowed-items' in mutation menu.

	* basics.fs: '(scratch)' variable moved here.

	* stringbuf-0.3.fs: Added two more words for error recovery:
	  'opened-buffers-to-list' and 'close-not-listed-buffers'.

	* tests/trash: trash for testing cvs version numbers.

2001-07-05  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_13

	* TODO: Some items done.

	* TAGS: updated.

	* brew.fs: Moved benchmark info to 'maybe-run-benchmark.fs'.

	* maybe-run-benchmark.fs:
	Moved all benchmark info here, including old stuff.

	* brew-options.fs: Moved benchmark info to 'maybe-run-benchmark.fs'.

	* README: Included a note that it's outdated... ;-)
	  and where to find up do date benchmark information.

	* DEVELOPMENT: Stepping through 'menu-current-genomes'.
	  Load normal store genes anyway.
	  Line wrap protection.
	  Listed masks for diversification masks.

	* brew.fs: Store genes are loaded anyway.

	  Continued experimenting with linear equation systems.  Not ready.

	* TODO: updated.

2001-07-04  Robert Epprecht  <epprecht@sunweb.ch>

	* bigFORTH.fs: Tried floats, but must have a second look...

	* maybe-run-benchmark.fs:
	  Appended spaces to the file names to keep bigforth happy.

	* brew.fs: Switched float stuff off,
	  because of bigforth having another fcell size.
	  'finish-benchmark' appends a space to the included filename,
	  to keep bigforth happy.

	* basics.fs: Switched float stuff off, because of bigforth.

	* brew.fs: Bugfix: Structure in 'check-ok-for-spot-do?'.
	  Gforth did not see this, PFE did.

	  Replaced some 'c/l' (Gforth) by 'c-l'.

	* brew.fs: Step through menu current genomes:
	  'n' shows the next genome in the current display order,
	  <space> goes to the next menu this genome.
	  Very handy...
	  '(next-genome-index)' 'check-genome-index' 'next-genome-node'
	  'goto-next-genome' 'show-next-genome'
	  'change-genome-sorting' resets '(next-genome-index)'.

	  LIST: nuc-div-masks
	  Use 'LISTED-MASKS-append-char' to produce them.
	  Use 'save-listed-mask' to save 'diversification-mask' and
	  'my-diversification-bitmask'.

	  Bugfix in 'population-control' which sometimes left garbage on
	  stack when not reporting.  How mean!

	  Cosmetics in 'see-this-nodes-genome' and 'menu-this-genome'

	  Continued with linear equation systems.  Work in progress.

	* menu.fs: 'wait' releases CPU.

	* BUGS: Last bug fixed ;-)

	* brew-basics.fs: Added: 'LISTED-MASKS-append-char'.

	* BUGS: updated.

	* brew.fs: Introduced 'score-rate'.  'eat-scored'.

	  Use line wrap protection on critical places:
	  '.menu-nuc-scan' '.menu-spot-scan' use '.num-on-same-line'.

	* menu.fs: Line wrap protection in some input words:
	  'menu-entry-value' uses '.num-on-same-line',
	  'change-value-at-addr' 'change-2value-at-addr'.

	* brew-basics.fs: Added: 'type-on-same-line', '.num-on-same-line'.

	* DEVELOPMENT: Finished work on spot diversification.

	* brew.fs: Finished work on spot diversification:
	  '.diversification-menu' splits depending '(div-menu-nuc-or-spot)'
	  into '.nuc-diversification-menu' and '.spot-diversification-menu'.
	  'spot-diversify'.
	  Define listed spot diversification masks with 'listed-masks-pre-char'
	  '<?diversify-planes>' '<?diversify-inhabited>'.
	  Save all the new data.

	  Changed 'qualities>future' to work with the new spot variables.

	  Moved 'listed-masks-pre-char' to 'brew-basics.fs'.

	* brew-basics.fs: Added: 'LISTED-MASKS-pre-char'.

2001-07-02  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: Added: 'listed-mask-string'.

	* code-chapters.txt: Added 'linear equation system' (work in progress).

	* genes-0.3.fs: Listed-maks for 'gene-flags'.
	  Show genes flags as number *and* string in '.gene-info'.

	* brew.fs: Choose 'spot-do-xt' actions from world menu.
	  Same for 'cell-do-before-xt' and 'cell-do-after-xt'.

	  Lists: 'spot-do-actions' 'cell-do-actions'
	  'choose-xt-entry-ext'

	  'init-diversification-mask' obsolete, use new 'set-n-low-bits'.

	  Show '(mutated-max)' in world menu.

	  Started work on spot diversification:
	  '<?diversify-planes>' '<?diversify-inhabited>'
	  'listed-masks-pre-char'
	  'spot-diversification-mask' 'spot-div-masks'
	  'inhabited-only-div'

	  Some pre tests with linear equation systems.

	* basics.fs: Added 'set-n-low-bits'.

2001-07-01  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_12

	* TAGS: updated

	* DEVELOPMENT:
	  Bugfixes, assertions, bechmark creation, record menu and a new bench:
	  'transit-12-bench.fs'.

	* maybe-run-benchmark.fs: With 'transit-12-bench'.

	* benchmarks/transit-12-bench.fs:   This is also a brew crash test,
	  good to test compatibility of different brew versions.

	* brew.fs: Displaying recorded messages during *recording* too.

	* brew.fs: 'message-input' from record menu.

	* brew.fs: Changed 'rec/play-menu'.
	  Only displaying what is relevant in the given situation.
	  New choices:
	  'record-comment' to put comments in playback files.
	  'save state' to save all variables (once).
	  Fixed '(playback-file-name)' after fileselect.

	  'assert-state-entry' accepts a comment line, that will be displayed
	  when running the code.

	  'assert-state-entry' does 'record-brew-changes' when called
	  while recording.  So you can change parameters and assert without
	  brewing first.

	  '.ok-done' so the user knows that something *did* happen...

	  Brew does no more step after editing a spot.

	  Cosmetics in log files, playback files, menus, benchmark headers,
	  assertions,...

2001-06-30  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Logging maybe-do things:
	  'maybe-FORTH-string' 'maybe-action-string' 'all-maybe-string'
	  Logging in '|maybe-do-on-everybody-generic|', 'do-change-selections',
	  'do-on-selected-nucs'.

	* TODO: updated.

	* brew.fs: 'finish-benchmark' does much more now:
	  Create entry to start from command line,
	  copy file to 'benchmarks/'.

	  'record-changes' checks for buffer size in file line input in.
	  Renamed 'record-line-max#' to 'file-line-max#'.

	* brew-basics.fs: 'wait-until' clears spurious keypresses now.

	* compile-options.fs: New compile time constant: 'file-line-max#'.
	  (Was named 'record-line-max#' before).

	* basics.fs: 'append-to-file' and 'clone-file'.

	* menu.fs: 'what' pauses if there's no key.
	  Be kind to other users...

	* reporting.fs: Doing 'compile-listed-?-and-!' on 'log-masks'.

	* genes-0.3.fs, mutation-0.3.fs, mutation-0.2.fs, brew.fs:
	  Had forgotten to use some log mask testing words.

	* brew.fs:   Using the new run-mode and display-switch testing words.

	* mutation-0.2.fs: Use new run mode test words.

	* mutation-0.3.fs: Use new run-mode test words.

	* display.fs: Doing 'compile-listed-?-and-!' on 'display-switch-masks'.
	  Using the produced words.

	* brew-basics.fs:
	  'compile-listed-?-and-!' telling more about what it's doing.

	* brew.fs: Changed 'save-listed-mask':
	  Gforth had a problem with too long input lines in included files.
	  Splitting them was not trivial because lines have to be balanced
	  when writing diffs and all the parts had to be included then.

	  'out-line' counts in '(out-lines)' now.
	  'out-hex-comment'

	  'record-changes' does not output obsolete empty lines any more.
	  '?out-line' like 'out-line' but not doing empty ones.

2001-06-29  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Upward compatibility of old genes with new ones:
	  old 'g-noop' is 'noop' now.
	  Use '[gene]' and '[gene']'.

	  Use 'default-foreground' 'default-background''reset-default-colors'.

	  Factored out '.+/-info-indicators' from 'population-control'.

	  '.version' shows if new-genes is true or not.

	* benchmarks/transit-11-bench-A.fs: Compatibility to old genes fixed.

	  Title inserted.

	* mutation-0.2.fs: 'g-noop' is 'noop' now.

	* genes-0.2.fs: Renamed 'g-noop' to 'noop' for upward compatibility.

	* reporting.fs: Use 'default-foreground'.

	* display.fs: 'default-foreground' 'default-background'.

	* cvs-tags:   brew-transit_11 including 'transit-11-bench-A'.

	* DEVELOPMENT: Bugfix with parameter genes.
	  Changing log and code files on the fly.
	  Log and code files with absolute path.
	  Logging population control.

	* TAGS: updated.

	* TODO: Updated.

	* brew-init.fs: Deleted all defaults, defaulting to brew defaults.

	* brew.fs: Resetting '(id)' and '(genome-id)' in record menu.

	  Starting benchmarks from 'maybe-run-benchmark.fs'.

	* maybe-run-benchmark.fs: As starting point for benchmarks.

	* benchmarks/transit-11-bench-A.fs:
	Simple benchmark for 'brew-transit_11' snapshot.

	* genes/genes-basic-stack.fs:
	Deactivated 'swap(aa-aa)' for upwards compatibility.

	* genes/spot-properties.fs: was buggy..., fixed.

	* mutation-0.2.fs: Added 'mutation-version' for upward compatibility.

	* genes-0.2.fs: Added 'genes-version' for upward compatibility.

	* genes/spot-properties.fs: Changed names: 'X-property@'.

	* genes/nuc-parameters.fs: New names: 'parameter-X@'.

	* brew.fs: Logging population control:
	  New log mask 'log-pop-control'.
	  Adapted 'population-control'.
	  '?log-after-pop-control'

	  Save 'sos-reproduction-push'.

	  Nuc checksum without id and genome-id.

	  Changed gene load order.

	* reporting.fs: New log-mask 'log-pop-control'.
	  Added: 'log-variable' 'log-scale'.

	* stringbuf-0.3.fs: Added: 'which-buffers-opened'.

	* INPUTS/genes/spot-properties.fs:
	  Changed definition and name: 'X-property@'.

	* INPUTS/genes/nuc-parameters.fs:
	  Bugfix and changed name: 'parameter-X@'.

2001-06-28  Robert Epprecht  <epprecht@sunweb.ch>

	* reporting.fs: Absolute paths for code files, too.

	* brew.fs: Change log and code files on the fly.
	  Uses the new 'change-handled-file'.

	* brew-basics.fs: 'change-handled-file':
	  User can change a filename, and if he does the old file get's closed
	  and the variable holding the file id get's cleared.

	* reporting.fs: Accepts absolute log file path now.
	  Renamed 'code-file-id' to '(code-file-id)' for consistency.

	* brew.fs: Some small improvements and bugfixes:

	  Define 'organ?' 'nuc-parameter?' 'nuc-invisible?' 'secret?' anyway,
	  even if there are no organs, parameters...

	  Bugfix in 'log-spot-variables'.

	  Deleted: 'maybe-do-scratch-field', not used.

	  Hint in 'individuals-menu' when no individual is selected.

	  Changed text diaplayed in 'assert-state-entry'.

	  Don't need to store file id's in 'save-before/after':
	  '(brew-before)' '(brew-after)' '(nuc-before)' '(nuc-after)'
	  '(actual-pool-before)' '(actual-pool-after)' are obsolete.

	  'save-brew-before' 'save-brew-after' and
	  'save-nuc-before' 'save-nuc-after' are trivial now.
	  ('save-actual-pool-before' 'save-actual-pool-after' same, unused).

	  Assert state keybinding.

	  'insert-benchmark-header' saves '(id)' and '(genome-id)' now.

	  Keybinding bug in 'log-menu' fixed.

	* TODO: updated.

	* reporting.fs: Minor editing.

	* tests/test-nuc-structure.fs: Just a little test for debugging.

2001-06-27  Robert Epprecht  <epprecht@sunweb.ch>

	* BUGS: Difficult problem with 'save-listed-mask'.
	  Some other bugs got fixed.

	* TODO: Updated.

	* brew.fs: Problems with recorded sessions.  Cause not found yet.

	  New run mode masks 'making-bench' and 'playing-bench' made
	  '(make-benchmark)' obsolete.
	  I use 'making-bench?' produced by 'compile-listed-?-and-!' now.

	  'NOT-recording?' moved to 'brew-basics.fs'.

	  'assert-state-entry' includes 'step' now, you newer know...
	  It waits in case of faults when not benchmarking.

	  'insert-benchmark-header' applies 'playing-bench!'.

	  'playback-on/off' tries to default to 'brew-recorded.fs' if
	  no selection is made.

	  Renamed:  'log-qualities' to 'log-spot-vars' and
	  'log-spot-qualities' to 'log-spot-variables'.
	  It reports also properties and secrets now.

	  World scan shows which subset get's scanned.
	  '.title-scanned-where' '.title-scanned-which' '.title-scanned-some'

	  Bugfix: 'check-continuous-display-sanity' scanning last variable.

	  Chapter log-menu has changed place.

	  Difficult problem with 'save-listed-mask':
	  Gforth has problems with interpreting a very long line in a file.
	  So I splitted lines and run into problems with line count when
	  doing diffs.  I have no easy solution for this right now...

	  'log-menu' can do the new 'log-state-entry'.

	  Renamed 'log-file-id' to '(log-file-id)'.

	* reporting.fs: Renamed 'log-qualities' to 'log-spot-vars'.

	* reporting.fs: Renamed 'log-file-id' to '(log-file-id)'.

	* brew-basics.fs: 'NOT-recording?' moved here.

	* code-chapters.txt: Sequence of topics in 'brew.fs'.

	* brew-basics.fs: New 'run-mode' masks: 'making-bench' 'playing-bench'.

	  Nifty word 'compile-listed-?-and-!':
	  Compiles two words 'xxx!' and 'xxx?' for each listed mask
	  'xxx!' setting the flag, 'xxx?' testing it.

2001-06-26  Robert Epprecht  <epprecht@sunweb.ch>

	* TODO: updated.

	* DEVELOPMENT: New 'save-before/after' and bugfixes.

	* brew.fs: Redo save-before/save-after mechanism:

	  A generic 'save-before/after' is now used to implement
	  'save-brew-before' 'save-brew-after' 'save-nuc-before' and
	  'save-nuc-after'.  'before/after-file-name' makes the filenames.

	  I wrote also 'save-actual-pool-before' 'save-actual-pool-after',
	  but I don't think I need them.

	  I'm not sure if I really need the variables to keep the filehandles.
	  Must check that.

	  New generic 'record-changes' ( file-id save-xt -- ).
	  can be used with different save functions:
	  'record-brew-changes' 'record-nuc-changes' are trivial now.
	  The latter now also takes a file-id to write to.

	  'nuc-changed?' uses a completely different approach now.

	  Renamed '(food)' to 'food'.  This is the cell in the world field
	  that '<food>' currently is set to.

	  Bugfix: 'conditional-expression-entries' must pass the actual field
	  address to 'write-evaluate-buffer-expr' because the field can be
	  a different one, when the menu entry will get selected.
	  'write-evaluate-buffer-do' 'write-evaluate-buffer-expr' do need
	  the maybe-do field as parameter so that the input will always be
	  written to the right field.  Same for 'toggle-do-type'.

	  Better structure and comments in 'save-brew-variables' and related
	  words.

	  Bugfix: 'stack-turning-point' was not saved...

	  '?record-edit-spot' records the *name* of variables instead of the
	  index now.

	  '.menu-title'

	* fileselect.fs: Use '.menu-title' and normal '(title)' 2variable.

2001-06-25  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Bugfix fixed, I hope...

	* DEVELOPMENT: Bugfixes.

	* brew.fs: Bugfixes:
	  'diversification-menu' left garbage as did 'nuc-menu' before.
	  Cursor position corrected in both.

	  '?record-?do-everybody-generic' and '?record-?do-everywhere-generic'
	  did not pass the xt of the field to the maybe function in the code
	  they produced.

	* brew.fs: Bugfix: 'nuc-menu' left garbage on stack...

	* cvs-tags: brew-transit_10

	* brew.fs: Compiled genes in 'world-menu'.

	* brew-init.fs: Changed defaults, not very mature yet.

	* reporting.fs: 'gene-code.fs' as default code file name.

	* probability-lists.fs:
	  'change-one' don't accept negative probabilities.

	* mutation-0.3.fs:
	  Adapted 'follow-&-add' 'my-diversification-bitmask' setting.

	* brew.fs: New nuc and spot variable types:
	  nuc-invisibles#  invisible, diversified.
	  nuc-secrets#     invisible, not diversified.
	  spot-secrets#    invisible spot variables.

	  'define-nuc-invisibles' 'n'th-nuc-invisible' 'nuc-invisible?'
	  'define-nuc-secrets' 'n'th-nuc-secret' 'secret?'
	  'organ?'

	  Changes: 'log-nuc-organs' changed and renamed to 'log-nuc-variables'.
	  'init-diversification-mask' 'diversification-menu'
	  'nuc-menu'
	  Because of display space shortage in the 'nuc-menu' I renamed
	  'nuc-parameter-X' to 'parameter-X'.

	* compile-options.fs, DEVELOPMENT: New nuc and spot variable types.
	  nuc-invisibles#  invisible, diversified.
	  nuc-secrets#     invisible, not diversified.
	  spot-secrets#    invisible spot variables.

	  Changed defaults.

	* TODO: updated.

	* INPUTS/genes/nuc-parameters.fs:
	Renamed 'nuc-parameter-X' to 'parameter-X'.
	  This is because of display space shortage in 'nuc-menu'.

	* TODO: updated.

	* brew.fs: Bugfix in nuc selection and work on selected.
	  'do-what-entry': *Do* offer nuc related selections after doing
	  'nuc&spot-related-selections'.
	  'in/exclude/toggle-selection' does 'maybe-select-field' now.

	* DEVELOPMENT: Version infos and some compile option infos.

	* brew.fs: Version and compile option infos added.
	  World menu, system menu and record files give more infos now.
	  Extended '.version'  Also keybinding in '.brew'.

	  Words related to put compile values in record files:
	  'save-nuc-compile-options' 'save-world-compile-options'
	  'save-commented-value' 'insert-record-file-header'

	  Use 'wait-until' in '.message'.

	* TODO: updated.

	* brew.fs: Version info now including genes and mutation:
	  '.version' 'genes-version' 'mutation-version'.

	  Renamed 'write-benchmark-header' to 'insert-benchmark-header'.

	  More help in benchmark comments to find the places to accommodate.

	* mutation-0.3.fs: Added: 'mutation-version'.

	* genes-0.3.fs: Added: 'genes-version'.

	* brew.fs: Added: 'brew-version' 'insert-record-file-header'.
	  Use 'brew-version' in 'write-benchmark-header' and
	  'insert-record-file-header'.

	* DEVELOPMENT: Easy benchmark creation and result assertion.

	* brew.fs: Facitities for easy benchmark creation:
	  'make-a-benchmark' 'finish-benchmark'.

	  A checksum over all nucs gets now included in the validation of
	  results: ('assert-state-entry') 'nucs-checksum' '+nuc-checksum'.
	  'assert-function-entry'.  This is only used for benchmark assertion
	  because it relies on reset of '(id)' and '(genome-id)' to get
	  identic nuc  and genome id's.  This would have undesirable side-
	  effects when used in the usual content.

	  Comments in benchmark files: 'write-benchmark-header' '?uncomment'
	  '(make-benchmark)'

	  Use 'wait-until'.

2001-06-24  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: Added: 'wait-until'.

	* brew.fs:
	  Bugfix: Assert state entry can now be called from system menu.
	  '?record-cloned' in 'sow' and 'save-nuc'.

	* brew.fs: Bugfix: 'world-checksum'
	  'erase-field' resets 'compiled-genes' and '(mutated-max)' now.

	* TODO: updated.

	* DEVELOPMENT: Conditional background coloring.
	  Spot secrets implemented.

	* BUGS: updated.

	* brew.fs:
	  Benchmark result validation gives more details when it fails.
	  Tried to do 'world-checksum', but it does not work yet...

	* TODO: updated.

	* brew.fs: Conditional background coloring.
	  'show-as-bg-color' 'condition>bg-color' 'condition-diff>bg-color'.
	  Spot secrets. 'n-secret'
	  'offset-propertiies' gets defined anyway now. New: 'offset-secrets'.

	  Old quality code snipped.

	  Give error location in *all* aborts.

	  Brew menu keybinding to 'menu-current-genomes'.

	* worlds.fs, stringbuf-0.3.fs, stacked-variables.fs, lists.fs, basics.fs:
	Give error location in *all* aborts.

	* stringbuf-0.3.fs:
	  Abort in 'handle>stringbuf-descriptor' gives error location.

2001-06-23  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: 'world-menu' getting info about the world,
	  scanning subsets of spots and changing them.

	  'spot-qualities#' as compile time value.

	  Work on linear mode.

	* TODO: updated.

	* brew.fs: Conditional spot scan:
	  'scan-some-spots'
	  '(do-where-xt)' 'scan-where-xt!' 'reset-scan-where'
	  'maybe-do-this-everywhere'

	  Deactivated unused 'NAND' 'show-coloured-on-nuc-flags-AND'
	  and 'show-coloured-on-nuc-flags-NAND'.

	  Changed code chapter sequence.

	  Defaults of 'do-on-world-field'.

	* brew.fs: 'spot-qualities#' as compile time value.
	  'define-spot-qualities' 'log-spot-qualities'.
	  'offset-A-quality' and sisters removed (compiled as literals).

	  Catching depth errors in 'evaluate-do' and 'evaluate-expr'.

	  'menu-spot-scan' fixed scrolling.

	  '.message' factored out of '.sorry'.
	  '.sorry-compile-option'.

	  Keybinding to 'world-menu' in 'brew-menu'.

	* brew.fs: 'world-menu': Working on spots and get infos:
	  'do-on-world-field'

	  Savety belt not to invocate nuc related words on empty spots:
	  (where it can not work (evaluation) it gives a warning at least...).
	  '(no-nuc-variable?)' 'check-ok-for-spot-do?'
	  'check-ok-for-spot-maybe?'

	  Savety belt needed a lot of changes and new words:
	  LIST: spot-var-xts
	  Rewritten: 'define-properties' makes entries in 'spot-var-xts'.
	  LIST: simple-do-expressions
	  LIST: simple-expressions-nuc
	  LIST: simple-expressions-spot   'everywhere' 'inhabited?' 'empty?'
	  '(selection-mask)' 'select-nuc-related' 'select-spot-related'
	  'nuc-related-selections' 'spot-related-selections' and
	  'nuc&spot-related-selection'
	  LIST: all-var-xts  (has all 'nuc-var-xts' and 'spot-var-xts').
	  'choose-spot-var-xt-entry' 'choose-var-xt-entry'
	  LIST: simple-expressions-all  ( simple-expressions-nuc and ~spot)
	  'choose-nuc&spot-var-xt-entry'
	  'choose-simple-condition-entry'
	  'conditional-expression-entries'
	  'do-what-entry'
	  LIST: do-on-nuc-xts
	  'maybe-do-everywhere-generic' '|maybe-do-everywhere-generic|'
	  '?record-?do-everywhere-generic'

	  Bugfix: In 'erase-field': reset 'trial' ans 'selected'.
	  Bugfix: Some ABORT" had no parameter.

	* lists.fs: Added: 'listed?'.

	* INPUTS/genes/spot-properties.fs: Bugfix.

	* basics.fs: Added 'fourth', '?'.

	* debuging.fs: Added: '.dada'.  Dada restores base.

	* brew.fs: More sensitive 'D' keybinding in brew-menu.

2001-06-22  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Work on linear-mode.
	  'toggle-linear-mode'
	  Toggling world/linear mode and adaptions in brew system menu.

	  'free-neighbor-spot?' looks into present *and* future now.
	  Splits into 'world-free-neighbor-spot?' and 'linear-free-spot?'.

	  Logging cause of death.

	  Bugfix: unset '(manually-selected-cell)' when removing a cell.
	  Bugfix: no steps after invoking spot/nuc scans from brew menu.

	* brew-basics.fs: Run mode mask 'linear-mode'.
	  'world-mode?'

	* cvs-tags: brew-transit_9

	* DEVELOPMENT: Finished work in 'menu-this-genome'.
	  Extended capabilities of '?scale-adaptions'.

	* TAGS, TODO: updated.

	* menu.fs: Extended '?scale-adaptions':
	  recognises inputs like '3/4' '/ 6' '/6' '* 4' '*4' now.
	  Factored out 'operator-to-end'.

	* basics.fs: Reactivated '+trailing'.

	* brew.fs: 'menu-this-genome' work continued.
	  Changed place of it in the code sequence.

2001-06-21  Robert Epprecht  <epprecht@sunweb.ch>

	* TAGS: updated

	* cvs-tags:
	brew-transit_8 (for benchmarks before changing BIOS and processor).

	* DEVELOPMENT: 'brew-transit_8' for benchmarking.

	* TODO: further updated.

	* brew.fs: Incomplete work in 'menu-this-genome'.
	  (Saved for benchmarking before changing processor and BIOS).

2001-06-20  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Cleanup in maybe-do, save evaluated strings.
	  Words to save floats.

	* brew.fs: Save stringbuffers. 'string!-x' 'save-stringbuf'
	  Save expression and maybe-do evaluation strings.

	* TODO: updated.

	* brew.fs: Words related to saving floats.
	  The representation of floats is in dual form: as human readable
	  string and as hex byte dump.
	  The human readable string could be used on systems with other
	  internal float representation, but this is not implemented yet.

	  'buffered"' 'buffered>float!' 'max-float-string-length#'
	  'float>buffer-string' 'cat-float-bytes' 'buffered-float!'
	  'save-float-variable'

	  Changed default record file name to 'brew-recorded.fs' as it
	  is a normal Forth file. (So the editor will switch to Forth mode).

	* basics.fs: added. 'fcell'.

2001-06-19  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Catching errors in 'evaluate-expr', continued.
	  'menu-nuc-subsets' checks, if there is someone.

2001-06-18  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Catching errors in evaluated expression strings.
	  This was quite a job...  See 'evaluate-expr'.

	* basics.fs: Added: 'bell'.  (PFE didn't have it.)

	* brew.fs: Use stringbuffers for maybe-do evaluations now.
	  Field terms: '(expression-handle)' '(maybe-do-handle)'.

	  Removed '(evaluate-buffer-do)' '(evaluate-count-do)'
	  '(evaluate-buffer-expr)'

	  Renamed 'maybe-do-automatic' to 'maybe-do-generic'.
	  Renamed some other 'maybe-do' words too.

	  As I didn't use the setup words for 'maybe-do' things, I removed:
	  'maybe!' 'maybe-do!' 'maybe-do-simple!'
	  '2-variables-?do!' 'evaluate-do!' 'set-variable!'
	  'add-to-variable!' 'sub-from-variable!' 'scale-variable!'

	  Removed other unused 'maybe-do' words, as they didn't get used:
	  '2-variables-?do!' 'addr-addr-?do-with-everybody'

	  Remaining defining words (like 'VARIABLE' '2VARIABLE'
	  'VALUE' 'CONSTANT') capitalised.  Increases readability.
	  'DEFER' is an exception, as both cases can make sense.

	  Added 'eat-lila' just a test, will be removed later, probably.

	* benchmarks/simple-bench.fs:
	Use 'no-info-line' (fixes cursor positioning bug).

	* brew.fs: Fixed cursor positioning bug in benchmarks:
	  'no-info-line' (was 'no-messages').

2001-06-17  Robert Epprecht  <epprecht@sunweb.ch>

	* TAGS: updated.

	* cvs-tags: brew-transit_7

	* DEVELOPMENT:
	Evaluating strings in *conditional* maybe-do expressions.
	  Scanning subsets, colored world views based on conditions.
	  Fields for xt's and parameters of maybe-do words.
	  Exiting increase of functionality.

	* brew.fs: Showing and scanning subsets in 'menu-nuc-subsets'.
	  'scan-this-subset'

	  Scanning and colored view on on 'generic-maybe?' conditions.

	  Generic maybe-do words that get the type from '(maybe-do-type-xt)'
	  'show-coloured-generic' 'generic-maybe>fg-color'
	  based on 'generic-maybe?'
	  'maybe-do-on-everybody-generic' and '|maybe-do-on-everybody-generic|'

	  Set '(maybe-do-type-xt)' in all fields, as I use it in generic words.

	  'maybe-string' can handele 'evaluate-expr' now, and got a bugfix.
	  'maybe-generic-string'

	  Bugfix in 'conditional-expression-entries'.

	  Inactivated: 'maybe-do-scratch-field', only needed for testing now.

	  'save-maybe-do-field'
	  '?record-maybe-do-generic' '?record-change-selections'
	  '?record-do-on-selected-nucs'

	  Feed manually in 'food-menu'.
	  Added: '|feed-world|' recording version of 'feed-world'.
	  '?record-feed-world'.

	* TODO: updated.

	* basics.fs: Added '+trailing':  Remove leading blancs from string.
	  Not used, deactivated.

	* brew.fs: Evaluating conditional expressions for 'maybe-do'.
	  'evaluate-expr' '(evaluate-expr)'
	  Added   '(evaluate-buffer-expr)' and '(evaluate-expr-pointer)'
	  Renamed '(evaluate-buffer)' to '(evaluate-buffer-do)'
	          '(evaluate-count)'  to '(evaluate-count-do)'
	  'write-evaluate-buffer' takes the buffer ( a u ) as argument.
	  'write-evaluate-buffer-do' 'write-evaluate-buffer-expr'

	  Renamed 'toggle-main-subset-do' to 'toggle-do-type'.

	  Factored out 'maybe-do-type-entry'.

	  Bugfix in 'menu-nuc-scan': use 'count-living'.

	* menu.fs: Tricky scale input manipulation ;-)
	  '?scale-adaptions':  word to guess the meaning of things like
	  '2 *' or '10 /' in scale inputs.  Experimental.

	* brew.fs: Use new maybe-do mechanism for work on selected nucs too:
	  'maybe-select-field' 'maybe-do-on-selected-field'
	  'in/exclude/toggle-selection'
	  'do-change-selections' 'do-on-selected-nucs'
	  Record functions not done yet.

	  Many old obsolete words removed:
	  '(selection-var)' '(select-comparison)' '(include-selection)'
	  '(select-boundary)' '(change-selection?)' '(?add-selection)'
	  '(?remove-selection)' '(?include/exclude)' '(do-on-nuc-index)'
	  '(do-on-nuc-value)' 'do-on-nucs-actions' 'set-nuc-var'
	  'add-to-nuc-var' 'sub-from-nuc-var' 'scale-nuc-var' '(do-on-nuc-xt)'
	  '|do-with-selected-nucs|' '?record-|do-with-selected|'
	  '|menu-select-var|'     Have all been removed...
	  Renamed: '(expr-xt)' to '(expr-xt-1)'  '(xt-do-it)' to '(xt-do-it-1)'

	  'write-evaluate-buffer' a little bit better...

	  Nuc subsets continued: 'conditional-expression-entries' and others.

	  Changed chapter order.

	* brew.fs: Pretty chapter titles.
	  Bugfix in 'variable-number!'
	  Added: 'fertile?'

	* brew.fs: Doing things on nuc subsets is working now.
	  'menu-nuc-subsets' works now directly in the mmaybe-do field,
	  which make it's separate variables obsolete: '(subset-main-do-xt)'
	  '(subset-condition)' '(subset-simple-expression)' '(subset-do-it-xt)'
	  Added: 'choose-nuc-var-xt-entry' and some others.
	  Renamed 'condition-and-do-entries' to 'entries-do-and-condition'
	  Added key bindings in 'menu-nuc-subsets' and some sub menu titles.

	  Splitted '(simple-expression-xt)' from '(expression-xt)':
	  As the field gets used in menus, it's convenient to have these
	  as two separate variables.

	  Added 'maybe-do-automatic' choosing between 'maybe-do' and
	  'maybe-do-simple'.

	  LIST: condition-words (was 'select-functions').
	  Renamed '2address-contents' to '2-variables'.
	  Renamed 'address-and-number' to 'variable-number'.

	  Added 'select-nuc-xt-to-addr'.

	  Added 'count' living to fix 'menu-select-nucs' bug.

2001-06-16  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: use 'choose-xt-entry'.

	* brew.fs: Changed back to old mechanism for conditional coloring,
	  as 'maybe-do' is not well suited for this job.
	  Done some changes on old mechanism:
	  '(nuc-var-for-color)' '(nuc-value-for-color)' '(color-condition-xt)'

	  You can use 'nuc-var-condition>fg-color' and 'nuc-var-diff>fg-color'
	  as normal x>fg-color display words now.

	* brew.fs: Work in progress on 'menu-nuc-subsets':
	  'condition-and-do-entries' 'simple-expression-entry'
	  'condition-?and-do-entries' 'do-what-entry'
	  'toggle-main-subset-do'

	  Reorganised 'maybe-do':
	  All xt's and parameters are now stored in a field: 'MAYBE-DO-FIELD:'
	  'MAYBE-DO-TERM:'
	  LIST: simple-do-expressions
	  LIST: do-it-xt's
	  'set-variable' 'set-variable!' 'add-to-variable' 'add-to-variable!'
	  'sub-from-variable' 'sub-from-variable!'
	  'scale-variable' 'scale-variable!'
	  'evaluate-do' 'evaluate-do!'
	  'maybe-simple-string'
	  'maybe-do-with-everybody' 'simple-maybe-do-with-everybody'
	  'do-with-selected-nucs'

	  added: 'choose-xt-entry'

	  Work in progress using maybe-do mechanism for 'show-coloured-on-nuc-var'.

2001-06-15  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_6

	* DEVELOPMENT: Structuring 'brew.fs':
	  Code is in thematic chapters now.

	  Conditionally executing code ( or evaluating strings ) on nucs
	  or spots in words designed for 'do-with+everybody' and the like.

	  Scanning nuc subsets.

	* TAGS, TODO: updated.

	* brew.fs: Evaluating strings in '(do-it-xt)'.
	  '(evaluate-buffer)' '(evaluate-do-pointer)' '(evaluate-count)'
	  '(evaluate-do)' 'evaluate-do' 'evaluate-do!'
	  'write-evaluate-buffer'

	  use same-menu-entry
	  renamed: '(maybe-do-xt)' to '(do-it-xt)'

	* menu.fs: added 'same-menu-entry'

	* menu.fs: Menus can pass three stack parameters now.
	  Bugfix in test code.

	* brew.fs: Changed order.
	  'var-value-eq-scan-only' is not deferred any more.

	* brew.fs: 'do-with-selected-nucs' redone.
	  added: 'selected?' 'simple-maybe-do-with-everybody'

	* TODO: updated (keeps always changing...)

	* brew.fs: Subset scans: 'maybe-do'.
	  Conditionally executing xt's on nucs (or spots).
	  Gives many more possibilities...
	  '(expression-xt)' '(condition-xt)' '(maybe-do-xt)'
	  '(expr-parameter)' '(expr-parameter-2)'
	  '(expr-xt)' '(expr-xt-2)'
	  'maybe?' 'maybe!' 'maybe-do' 'maybe-do!'
	  'maybe-do-simple' 'maybe-do-simple!'
	  '2address-contents' '2address-contents-?do!'
	  'address-and-number' 'address-and-number!'
	  'address-and-number-?do!'
	  'simple-?do-with-everybody' 'addr-addr-?do-with-everybody'
	  'addr-n-?do-with-everybody'
	  'maybe-string' 'maybe-simple-string'

	  Working on subsets:
	  '(do-with-whom-xt)' 'maybe-do-with-everybody'
	  '|do-with-selected-nucs|'

	  Scanning subsets: 'var-value-eq-scan-only'
	  'scan-whom-xt!' 'reset-scan-whom'
	  'scan-only-some-nucs' 'scan-selected'

	  Added: 'save-value' 'save-xt-value'
	  Extended: 'menu-this-genome'
	  Structuring and editing continued.
	  'play' switches recording off, just to make sure it *is* off...
	  Some new menu key bindings.

2001-06-13  Robert Epprecht  <epprecht@sunweb.ch>

	* lists.fs: Initialize 'to-list'.

	* display.fs: 'display-on-off' moved here.

	* brew.fs: Code reorganised in thematic chapters.

	* brew-basics.fs: 'LISTED-MASK:' moved to 'basics.fs'
	  Some words moved here from 'brew.fs':
	  '?type' 'spot>at' 'page-type' 'accept>stringbuf'

	* basics.fs: 'LISTED-MASK:' moved here.

2001-06-12  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Selection of nucs.  Many new analytic display tools.
	  'menu-current-genomes' and 'menu-this-genome'.

	* mutation-0.3.fs, mutation-0.2.fs: Use 'on-trial?'.
	  Renamed 'wake-me-trial' to 'nuc-on-trial'.
	  Spelling correction: 'genom-xxx' to 'genome-xxx'.

	* brew.fs: new: '.menu-select-nucs' 'menu-this-genome'
	  Work on selection of nucs and on nucs sharing genome.
	  Showing nucs colored according different conditions
	  in spot view out of menus.
	  Improved 'menu-current-genomes'.
	  Select nucs (hereditary): show them, work on them, scan them
	           Filters for selection and deselection.
	           lists 'select-functions' 'do-on-nucs-actions'
	           actions: 'add-to-nuc-var' 'sub-from-nuc-var'
	                    'scale-nuc-var' 'remove-nuc'
	           '|do-with-selected-nucs|'
	           'select-nuc' 'de-select-nuc' 'nuc-selected?'
	           'toggle-selection' 'invert-selections'
	           'de-select-all-nucs'
	           'select-some-nucs' '(maybe-select-nuc)'
	           'de-select-some-nucs' '(maybe-de-select-nuc)'
	           'do-with-selected-nucs' 'do-if-selected'
	           'selected>fg-color' 'selected>bg-color'
	           'show-selected' '.selected' for '.info'
	           selection in 'nuc-menu'
	           Nuc scans on selected nucs only: 'scan-selected'
	           'selected-only-ON' 'selected-only-OFF'
	  changed: 'menus-menu'
	           '(do-xt)' is a value now, as it's faster.
	           'genomes' list has changed structure.
	  added:   'nuc-var-index' 'on-trial?' 'selected'
	           'show-some-coloured' 'color-of-selected'
	           'nuc-var-condition>fg-color' 'show-coloured-on-nuc-var'
	           'show-coloured-on-nuc-var-eq'
	           'show-coloured-on-nuc-var-less'
	           'show-coloured-on-nuc-var-more'
	           'show-coloured-on-nuc-flags-AND'
	           'show-coloured-on-nuc-flags-NAND'
	           'nuc-var-diff>fg-color'
	           'show-coloured-on-nuc-var-diff'
	           'NOT-recording?'
	           and others.
	  renamed: 'var-menu' to 'system-menu'
	           'wake-me-trial' to 'nuc-on-trial'.
	           '|menu-select-nuc-var|' to 'select-scanned-nuc-var'
	           'do-at-random-spots' to 'do-with-random-nucs'.
	           'genom-generation' to 'genome-generation'
	           and corrected all other 'genom-xxx' words.
	  bugfix:  '.menu-short-help': Sometimes scrolling was
	           indicated when scrolling was not active.
	  bugfix:  'brew-redisplay': Can be used outside menus now
	           which is essential for including record files.

2001-06-09  Robert Epprecht  <epprecht@sunweb.ch>

	* TAGS: updated.

	* DEVELOPMENT: 'menu-current-genomes'
	  New list features.
	  association-lists.fs
	  sorted-lists.fs

	* brew.fs: 'menu-current-genomes'.
	  'genomes' list:
	  'add-nucs-genome' 'build-genomes-list'
	  'sort-genomes-list' based on '(genome-sort-index)' '(sort-upwards)'
	  'save-menu-configuration'

	* sorted-lists.fs: Test double data field list sorting:
	  use new '.all-list-data' based on '.all-node-data'.

	* lists.fs: Changed test code:
	  '.all-list-data' replaces '.all-data'.
	  Based on '.all-node-data' (new) which can deal with
	  multiple data fields.

2001-06-08  Robert Epprecht  <epprecht@sunweb.ch>

	* association-lists.fs: 'key-to-list' 'key-is-in?' return node address.
	  'count-key' and 'count-LIST:' deactivated.

2001-06-07  Robert Epprecht  <epprecht@sunweb.ch>

	* sorted-lists.fs: Build a sorted copy of a list.
	  Not code I'm especially proud of ;-)

	* association-lists.fs: Lists of key's with associated data.

	* lists.fs: A couple of new words:
	  'insert-after-node' 'insert-node' 'data-fields' 'remove-list'.

	* brew.fs: Added 'menu-step-presets' template.

2001-06-06  Robert Epprecht  <epprecht@sunweb.ch>

	* statistics.fs: 'statistic-status-bg-color'.

	* brew.fs: Better color handling in step display.
	  Fewer scans needed.

	* brew.fs: New display type: text display.
	  'nuc-text-display' 'world-text-display'.

	* DEVELOPMENT: New display type: text displays.
	  'nuc-text-display' 'world-text-display'.

	* display.fs: new display-switch-masks:
	  'scan-display-used' 'text-display-used'

	* VERSION-README: transit versions

2001-06-04  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_5

	* TAGS: updated.

	* DEVELOPMENT: Bugfixes: code cost (and some others).
	  Code file cosmetics and bugfixes.
	  Menu cosmetics.

	* TODO: updated.

	* mutation-0.3.fs: Factored out code entries from 'start-to-follow':
	  'mutation-start-code-entry' and 'start-definition-code-entry'
	  both now called from 'initialise-mutation'.
	  Corrected '(code-indent)' in 'top-level-snip'.
	  'store-actual-stack-and-frame' preserves '(code-indent)' too.

	* mutation-0.2.fs: Factored out code entries from 'start-to-follow':
	  'mutation-start-code-entry' and 'start-definition-code-entry'
	  both now called from 'initialize-mutation'.
	  Corrected '(code-indent)' in 'top-level-snip'.
	  'store-actual-stack-and-frame' preserves '(code-indent)' too.

2001-06-03  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Use 'genes-dir'.  Added:  'include-genes'

	* brew-init.fs: horizontal-zoom-scale [0] fixed.

	* brew.fs: Bugfix: 'init-scan-array' added.

	* mutation-0.2.fs, mutation-0.3.fs:
	Support 'file-mutation-type': ?mutation-type>code-file
	  New: 'code-file-gene-name' replaces 'step&spot-name'.
	  Use 'no-code-cost' to get rid of snip-types code cost bug.
	  (all '...-mute' functions do use it).
	  New: '?aborted>code-file'.

	* brew.fs: Changed 'code-file-menu':
	  support 'file-mutation-type'and new key bindings.

	* reporting.fs: New code-file-mask 'file-mutation-type'.

	* brew-basics.fs: New run-mode-mask: 'no-code-cost'.

	* fileselect.fs: 'fileselect-menu' cursor on next line.

2001-06-02  Robert Epprecht  <epprecht@sunweb.ch>

	* genes-0.3.fs: added: gene' (used in recorded sessions).

	* brew.fs: 'edit-probabilities-menu' titles corrected.
	  Bugfix in 'page-see' (Gforth specific, probably).
	  'individuals-menu' slightly changed.
	  'record-on/off' gives a hint how to proceed.
	  'rec/play-menu' keys 'i' and 'I' go to 'individuals-menu'.

2001-06-01  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_4

	* TAGS: updated.

	* DEVELOPMENT: Bugfixes:
	  rare crashes scanning nuc details.
	  'edit-probabilities-menu' leaving sublists.
	  simple-bench

	* TODO: updated.

	* brew.fs: Bugfix in 'edit-probabilities-menu'
	  Coming back from nested sublist ascends just one level now.
	  (The title get's lost, but I can live with that...)

2001-05-31  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Minor corrections.

2001-05-30  Robert Epprecht  <epprecht@sunweb.ch>

	* benchmarks/simple-bench.fs: Quick&dirty adaption to current brew.

	* debuging.fs: defer <debug>

	* statistics.fs: Bugfix initialising '<vertical-zoom-scale>'.

2001-05-29  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_3

	* DEVELOPMENT: New and old genes and mutation types behaving equally.
	  Bugfixes.

	* TODO: updated.

	* mutation-0.3.fs, mutation-0.2.fs:
	Bugfix: snipping code *does* reduce code cost now.

	* mutation-0.3.fs, mutation-0.2.fs: Use 'forth-with-lowercase'.

	* system-dependent.fs: Determine 'forth-with-lowercase'.

	* system-dependent.fs:
	Deleted "buggy..." statement for bigFORTH version.

	* mutation-0.3.fs:
	Reactivated evaluation of 'my-diversification-bitmap'
	  in 'follow-&-add'.

	* mutation-0.2.fs:
	Bugfix in code cost when a mutation is tried more than once.
	  Compatibility with 'mutation-0.3.fs' ('new-genes').

	* genes-0.3.fs: Cost for ;gene as for other primitives.

	* genes-0.2.fs: Old code snipped.

	* brew.fs: Child gets diversified *after* mutation now.
	  'log-nuc-organs' does 'my-diversification-bitmask' now.

2001-05-28  Robert Epprecht  <epprecht@sunweb.ch>

	* genes-0.2.fs: Fixed bug in 'GENE-INTERNALS:' (bigFORTH only)
	  Factored out the corrected code into 'is-structure-word?'

	* mutation-0.3.fs:
	'(mutate)' does 'top-level-insertion' on empty genes.
	  'log-mutation' is now enough to report mutated genome.

	* gforth.fs: New ekey mapping (Debian update changed it!).

	* make-ekey-map.fs: Helper file to make ekey map.  Not really finished.

	* brew.fs: Changed include order for (new and old) genes.

2001-03-23  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_2

	* TODO: updated.

	* DEVELOPMENT: Working new-genes (slow), old ones still in.

	* compile-options.fs: Compile option new-genes is back.

	* TAGS: tags for new-genes.

	* brew.fs: New genes working (but slower), old ones still in.
	  Listed NUC-VAR: to get easy access to the names.
	  Some words factored out to encapsulate differences between
	  old and new genes, like 'save-nucs-genes'

2001-03-22  Robert Epprecht  <epprecht@sunweb.ch>

	* mutation-0.3.fs: Close internals buffer in 'decrease-eb-count'

2001-03-21  Robert Epprecht  <epprecht@sunweb.ch>

	* mutation-0.3.fs: First working version of the new implementation.
	  Slower than expected.

	* genes-0.3.fs: Comments edited.
	  'internals-string'  'get-gene-xt'

	* INPUTS/genes/store.fs, INPUTS/genes/store-normalised.fs, INPUTS/genes/insight.fs, INPUTS/genes/fetch.fs:
	gene aliases not possible with noname words.

	* INPUTS/genes/conditionals.fs: some corrections.

2001-03-20  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: 'get-name' 'get-xt'

2001-03-17  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-transit_1

	* DEVELOPMENT: Work on new gene and mutation implementation.

	* TAGS: Tags are for old gene and mutation versions.

	* brew.fs: New gene and mutation implementation.
	  Including old versions          (genes-0.2.fs mutation-0.2.fs),
	  new version is work in progress (genes-0.3.fs mutation-0.3.fs).

	  Use INPUTS/ for new genes: INPUTS/genes/

	  ['] max-if-items save-variable

	* TODO: updated a bit.

	* mutation-0.3.fs, genes-0.3.fs: New gene and mutation implementation.
	  Work in progress...

	* compile-options.fs: 'new-genes'  Work in progress...

	* brew-init.fs: deactivated swap(aa-aa).

	* brew-basics.fs: Added input-dir inputs-sub-dir genes-dir.

	* INPUTS/genes/insight.fs, INPUTS/genes/nuc-parameters.fs, INPUTS/genes/off.fs, INPUTS/genes/organs.fs, INPUTS/genes/qualities.fs, INPUTS/genes/spot-properties.fs, INPUTS/genes/store-normalised.fs, INPUTS/genes/store.fs, INPUTS/genes/fetch.fs, INPUTS/genes/conditionals.fs, INPUTS/genes/basic-stack.fs, INPUTS/genes/basic-arithmetics.fs:
	New gene type for genes-0.3.fs.

	* INPUTS/basic-stack.fs, INPUTS/conditionals.fs, INPUTS/fetch.fs, INPUTS/basic-arithmetics.fs:
	*** empty log message ***

	* INPUTS/fetch.fs, INPUTS/conditionals.fs, INPUTS/basic-stack.fs, INPUTS/basic-arithmetics.fs:
	New gene type for genes-0.3.fs.

2001-03-16  Robert Epprecht  <epprecht@sunweb.ch>

	* stringbuf-0.3.fs: 'buffer-data-addr' 'string!' 'cat-n'

2001-03-14  Robert Epprecht  <epprecht@sunweb.ch>

	* mutation-0.2.fs: variable '(nesting)' obsolete, deleted.

2001-03-13  Robert Epprecht  <epprecht@sunweb.ch>

	* reporting.fs: added: 'log-number'

2001-03-08  Robert Epprecht  <epprecht@sunweb.ch>

	* basics.fs: added 'third'.

2001-02-28  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT, cvs-tags: brew-transit_0

	* TAGS, brew-init.fs: updated.

	* TODO: Many items added, done and removed again ;-)

	* brew.fs: Reactivated sporadic.

	* brew.fs: Old organ defining code snipped.
	  Thousendfold probabilities for 'last-gene-into-pool'.

	* genes/genes-basic-stack.fs, genes/genes-conditionals.fs, genes/genes-fetch.fs, genes/genes-organs.fs, genes/genes-qualities.fs, genes/genes-store-normalised.fs, genes/genes-store.fs, genes/spot-properties.fs, genes/nuc-parameters.fs, genes/insight.fs, genes/genes-basic-arithmetics.fs:
	Tousendfold probabilities for 'last-gene-into-pool'.

	* DEVELOPMENT: 'mutation-types' using probability list.

	* lists.fs: 'n'th-or-new-node' (to rebuild list while playing back).
	  'next-or-new-node' stack comment fixed.

	* brew.fs: 'save-continuous-display' rewritten.
	  Helper words 'cont-node-out' 'cont-n-out' 'cont-xt-out'.
	  'cont-unique' obsolete, removed.

2001-02-27  Robert Epprecht  <epprecht@sunweb.ch>

	* lists.fs: added 'unlink' and 'empty-list'.

2001-02-26  Robert Epprecht  <epprecht@sunweb.ch>

	* probability-lists.fs: Bugfix in 'it's-node'.
	  'nul-all-probabilities'.

	* brew.fs: 'save-xt-probability-pool'.
	  Renamed 'save-probability-pool' to 'save-actual-gene-pool'
	  redundant, should use 'save-xt-probability-pool'.

	  ['] mutation-types save-xt-probability-pool in 'save-brew-variables'.

2001-02-25  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: 'edit-probabilities-menu'
	  Include 'probability-lists.fs' earlier.
	  'menu-title' renamed from 'title-choose-xt!'.

	  Use probability list for mutation types: 'mutation-menu'.
	  Saving not done yet.

	  Use 'how-many'.

	  'goodbye' does 'reset-default-colors' now, thanks Aljoscha :-)

	* probability-lists.fs: xt as key of sublist.
	  This makes it possible to use always xt>name on xt keys.

	* gene-pool.fs: 'probability-lists.fs' included from 'brew.fs'.

	* mutation-0.2.fs: Use probability list for mutation types.
	  'MUTATION-TYPE-POOL:'
	  '(mutate)' rewritten.
	  All muation types return a success flag now.

	* brew.fs: Demo 'intro' removed.

	* bigFORTH.fs: No more demo 'intro'.

	* README: Update regarding (missing) benchmarks and demos.

	* DEVELOPMENT: 'gene-pool.fs' using 'probability-lists.fs'.
	  Removed old benchmarks and demos that do mutation.

	* TODO: updated.

	* genes/spot-properties.fs, genes/nuc-parameters.fs:
	Adapted to new 'gene-pool.fs'.

	* genes/genes-basic-stack.fs: Bugfix in 'replace-nip(xy-y)' words.

	* brew.fs: Adapted to new 'gene-pool.fs'.

	* brew-options.fs: old mutation pool setup snipped.

	* mutation-0.2.fs, genes-0.2.fs: Use new 'gene-pool.fs'.

	* gene-pool.fs: 'probability-lists.fs' makes this file trivial.

2001-02-24  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs, mutation-0.2.fs, genes-0.2.fs, compile-options.fs:
	'use-pool-select' obsolete, deleted.

	* gene-pool.fs: Comments fixed.
	  List of currently from outside used words.

	* DEVELOPMENT: no more 'support-single-individuals?'

2001-02-21  Robert Epprecht  <epprecht@sunweb.ch>

	* menu.fs: 'noop-entry'

2001-02-19  Robert Epprecht  <epprecht@sunweb.ch>

	* compile-options.fs: No more 'support-single-individuals?'

	* brew.fs: Single individuals not supported any more.
	  No more 'support-single-individuals?'

2001-02-18  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-0_03z9

	* DEVELOPMENT: z9 final.
	Last version with old benchmarks and demos.
	Compatibility with these will break now.

	* benchmarks/long-mutations.fs:
	Corrected screen position of phase 2 display.

	* benchmarks/long-mutations.fs: snipped out old variable.

	* README, TAGS, TODO: updated.

	* VERSION-README: z9 version.

	* probability-lists.fs: Selecting data out of probability lists.
	  Probability lists can be nested.
	  Seems to work now.

	* gene-pool.fs: use 'mask:' and 'list>flags'

	* lists.fs: immediate '>list-descriptor'
	  'list>flags'
	  use 'mask:'

	* basics.fs: <=

	* iForth.fs: Color and ekey mapping.

2001-02-17  Robert Epprecht  <epprecht@sunweb.ch>

	* probability-lists.fs: up tp here with probability row.    buggy

	* probability-lists.fs: buggy

2001-02-15  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: 'log-meal' logs 'nuc-do-cost' also.
	  Work on sporadic big diversifications.  Not activated yet.
	  'sporadic-replace-value' 'sporadic-value-range' 'sporadic-value-rate'
	  edited 'diversification-menu' 'log-menu'

	* compile-options.fs: comments about 'log-mask'

	* cvs-tags: brew-0_03z8b

	* DEVELOPMENT: Fine grain mutation logging.

	  Thoughts about individually structured nucs, atomic gene sequences,
	  building top of stack type probability tools.

	* README: small update.

	* stringbuf-0.3.fs: Compile switch 'debugging' immediate versions of
	  's-buf-count' 's-buf>string' 's-buf-clear'

	* debuging.fs: debugging debuging ;-)

	* brew.fs: mention PFEs new -e" option.

	* VERSION-README: updated.

	* brew.fs: Fine grain mutation logging.
	  'debug-mutation' was integrated in 'log-mask' and split into masks.
	  'log-menu' redone.  Logging has improved a lot.
	  Logging meals is possible.

	  New handling of nucs in the dictionary:
	  'nuc-flags' has 'nuc-is-word'.  'my-code-start' depreciated.
	  'clone' and 'save-nuc' doe clear 'nuc-is-word'.

	  Increased 'record-line-max#'.

	* mutation-0.2.fs: Fine grain mutation logging.
	  'debug-mutation' was integrated in 'log-mask' and split into masks.

	* brew-options.fs: adaptions to the new logging style.

	* reporting.fs: Fine grain mutation logging.
	  'debug-mutation' was integrated in 'log-mask' and split into masks.
	  New log-masks.

	* gene-pool.fs: adaptions to the new logging style.

	* compile-options.fs: 'log-mask' takes the roll of 'debug-mutation'.
	  Note that 'log-mask' is a compile time and a run time switch.
	  It has 3 possible states at compile time.  See 'compile-options.fs'.

	* TODO: updated.

	* NAMING: additions.

2001-02-14  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: consistency:  'NUC-VAR:' instead of 'nuc-var'

	* stringbuf-0.3.fs: I meant 'handle' not 'file-id'.

	* bigFORTH.fs: added check for 'compare' bug.

2001-02-13  Robert Epprecht  <epprecht@sunweb.ch>

	* genes/spot-properties.fs, genes/genes-qualities.fs, genes/genes-organs.fs, stringbuf-0.3.fs, reporting.fs, mutation-0.2.fs, genes-0.2.fs, cvs-tags, brew.fs, brew-basics.fs, DEVELOPMENT:
	'stringbuf-handle:' words return *handle* now.

	* cvs-tags: brew-0_03z7

	* DEVELOPMENT: Possibility to log user interactions.
	  Cutting away unique comments before filing.
	  User interface and bug fixes.
	  Changed terminology: 'report' gets 'log'.

	* bigFORTH.fs: redefined 'compare'

	* reporting.fs: factored out '?open-log-file'
	  Renamed 'log-population-emergency' to 'log-emergency'.

	* mutation-0.2.fs: bug fix in 'top-level-insertion'
	  It was logging always 'playing head symbols...'

	* brew.fs: Possibility to log user interaction using 'record-changes'.
	  'record-changes' takes the file id as argument now.
	  '?open-log-file' make sure the log file is open, call 'save-before'.
	  Changed flag using in 'save-brew-variables'.

	  New way for unique comments using stringbuffer '(unique)'.
	  'cont-unique' and 'step-unique' to build the strings.
	  Cut unique comments away before recording or logging 'remove-unique'

	  'save-continuous-display' works different than before.

	  Function keys in 'function-key-menu' ;-)

	* benchmarks/simple-bench.fs, benchmarks/mutations-1.fs, benchmarks/long-mutations.fs, benchmarks/displayed-bench.fs, OUTPUT/rec-play/intro.fs, reporting.fs, mutation-0.2.fs, brew.fs, brew-options.fs, brew-init.fs, brew-basics.fs, README:
	'reporting' is now called 'logging'

	* compile-options.fs: When unclear, spot or step display?
	  'spot-display-prefered'
	  some edits

	* display.fs: 'display-on-off' replaced by new version in 'brew.fs'

	* brew.fs: extended 'menu-step-display'.
	  with switchable info amount and scrolling.

	  'report-random-generator'
	  '?step-display-sanity' checks color xt's.

	  'spot-display-prefered' compile option for ambivalent situations.
	  'toggle-display-type' does better if step *and* spot display is on.
	  'display-on-off' moved here from display.fs and respects the option.

	* brew-basics.fs: edited.

	* DEVELOPMENT: 'menu-edit-spot'.   scrolling 'choose-xt-menu'.

2001-02-12  Robert Epprecht  <epprecht@sunweb.ch>

	* console-codes.fs: AT? and bigFORTH 2.0.0

	* brew.fs: 'choose-xt-menu' learned scrolling.
	  renamed '.choose-xt-menu' (was '.xt-list')
	  '.menu-short-help' tells about scrolling.

	* brew.fs: 'menu-edit-spot' '?record-edit-spot'
	  '?|see-genome-or-spot|'  (instead of '?|see-genome|')
	  use (and fix) 'n'th-spot-variable'
	  'spot-vars@' 'spot-vars!'

	  AT? is defined in bigFORTH 2.0.0 (include console-codes.fs)

	* statistics.fs, iForth.fs, compile-options.fs, cvs-tags, brew-basics.fs, DEVELOPMENT:
	typo: 'lower-right-scrolls'
	  cant tell left from right ;-)

	* brew.fs: work on key bindings and menus.

	* cvs-tags: brew-0_03z6

	* DEVELOPMENT: More work on keybinding and menus.

	* DEVELOPMENT: Compile time switch 'lower-left-scrolls'.

	* brew.fs: respect 'lower-left-scrolls'.
	  Use it in '.info-line'.  Use 'clear-line-to-end' wherever
	  possible to encapsulate 'lower-left-scrolls'.

	  Factored out 'end-title'.
	  Renamed 'set-title-colors' to 'title-colors'.

	  Work in progress on key bindings and '.keybindings'.

	* brew-basics.fs: 'clear-line-to-end' respecting 'lower-left-scrolls'.
	  Use it wherever possible to encapsulate 'lower-left-scrolls'.

	* statistics.fs:
	use 'clear-line-to-end' to respect 'lower-left-scrolls'.

	* iForth.fs: 'lower-left-scrolls' introduced.

	* compile-options.fs: 'lower-left-scrolls'
	  for systems that scroll on writing to very last screen position.

2001-02-11  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: 'save-listed-mask' saves bitmasks as readable text.

	  'display.fs' gets included after 'brew-basics.fs'

	  '.menu-short-help' back here.
	  'set-title-colors' 'title-colors-xt' also.

	* reporting.fs: Use listed masks for 'report-mask' and 'code-file-mask'

	* display.fs: Use listed masks for 'display-switch'.

	* brew-basics.fs: LISTED-MASK:  (very nice new feature)
	  Bit masks that can be written to files as readable text.
	  Use it on 'run-mode'.

	  '.menu-short-help' moved back to 'brew.fs'
	  'set-title-colors' 'title-colors-xt' moved to 'brew.fs'

	* brew.fs: Removing cells by hand and recording it.
	  |remove-cell| ?record-remove-cell
	  :NONAME definitions of deferred recording words:
	  '?record-remove-cell' '?record-free-field' '?record-sow'

	* iForth.fs: 'c-l' and 'l-s' as constants.

	* cvs-tags: brew-0_03z5

	* DEVELOPMENT: spot-scan-menu and bug fixes.

	* brew-init.fs, benchmarks/mutations-1.fs, benchmarks/long-mutations.fs, benchmarks/displayed-bench.fs, OUTPUT/rec-play/intro.fs:
	replaced '.spot-scan' by 'spot-scan-menu'.

	* brew.fs: 'menu-spot-scan' second version.
	  |spot-scan-display| does more of the job now.

	  Found longstanding scanning bug 'spot-scan-display'.  :-)

	  Factored '?reset-continuous-column' out of 'common-menu-entries'
	  Use it in '.keybindings' too.

	* brew.fs: spot-scan-menu (first version).

	* brew.fs: 'bell' and 'ping' have swapped meaning.

	* iForth.fs: 'bell' and 'ping' have swapped meaning.
	  Added -work for Marcel.

	* brew-basics.fs, debuging.fs, keybuf.fs, menu.fs, mutation-0.2.fs, random.fs, reporting.fs, worlds.fs, benchmarks/displayed-bench.fs, benchmarks/mutations-1.fs, benchmarks/simple-bench.fs:
	'bell' and 'ping' have swapped meaning.

	* basics.fs: added: 'bell'.

	* brew.fs: Fixed bug in '.info-line'.
	  'last-line' instead of 'at-last' (no 'at-xy' done).

	* menu.fs, fileselect.fs, brew-basics.fs:
	'last-line' instead of 'at-last' (no 'at-xy' done).

2001-02-10  Robert Epprecht  <epprecht@sunweb.ch>

	* TAGS: updated.

	* cvs-tags: brew-0_03z4

	* BUGS: updated.

	* DEVELOPMENT: Recording of step display and continuous display.
	  Status line in 'continuous-display'.
	  Bug fixes.

	* brew.fs: Changed function of <space> while brewing (old bug fixed)
	  Bug fixes.
	  'do-after-2' passed to 'default-function-keys'
	  'brew-redisplay' tries to deal with (continuous-column)
	  .cont-status-line makes sure to be at the right line.

	  Better 'menu-step-display'
	  |define-step-display-item|

	  Renamed 'max-step-scans#' to 'max-step-display-items#'

	* TODO: updated.

	* menu.fs: 'default-function-keys' takes an xt to set prefixes.

	* basics.fs: Added: ?execute
	  In the following example passing an xt (to set menu prefixes)
	  to 'default-function-keys' saying ' NOOP default-function-keys
	  would give a wrong impression.  So using FALSE instead is allowed.

	* brew.fs: Recording of step display and continuous display.
	  Bug fixes.
	  'max-continuous-items#' needed to have a constant line number
	  in diff files.  'run-mode' mask 'write-diff'  See 'save-before'
	  'display-switch' mask 'continuous-display-used':
	  Set by '?step-display-sanity'.
	  It's *not* switching 'continuous-display', but only used
	  to prevent 'common-menu-entries' from changing
	  '(continuous-column)' in vain, as this would be recorded.

	  'save-offset-variable' 'save-offset-xt-variable'

	  'brew' does '?step-display-sanity', needed for playback.

	* display.fs: New display-switch mask 'continuous-display-used'.
	  It's *not* switching 'continuous-display', but used to prevent
	  'common-menu-entries' from changing '(continuous-column)' in vain,
	  as this would be recorded.

	* brew-basics.fs: New run-mode mask 'write-diff'.

	* display.fs: updated comment on 'step-display-on'.

2001-02-09  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: Status line in 'continuous-display'.
	  '.cont-status-line' 'cont-item-name' '?type'

	* BUGS: Demo 'intro' did crash when called a second time.
	  fixed.

	* brew.fs: no need for '[DEFINED] default-color [IF]'

	* benchmarks/displayed-bench.fs, OUTPUT/rec-play/intro.fs:
	fixed step display for new defaults.

	* stringbuf-0.3.fs: bug fix in 'STRINGBUF-HANDLE:'
	  Calling 'intro' twice triggered this bug.  Fixed now.

2001-02-08  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: bug fix in 'check-continuous-display-sanity'

	* cvs-tags: brew-0_03zzz

	* DEVELOPMENT: continuous-display
	titles in 'choose-xt-menu'

	* brew-init.fs: Settings for 'brew-0_03zzz'

	* BUGS: No wrapped gene primitives any more. pfe ok now.

	* brew.fs: Continuous display.
	  Items stored in a list, as we don't know how many there are.
	  'menu-continuous-display'
	  'save-continuous-display' (not for recording yet).

	  'select-nuc-var-menu' works different now.
	  |menu-select-nuc-var| for old behaviour.
	  'select-nuc-var-to-addr'
	  Same for 'menu-select-spot-var' |menu-select-spot-var|
	  'select-spot-var-to-addr'

	  Titles in 'choose-xt-menu'.
	  No 'free-menus' in there any more. (hope that's ok).

	  'lists.fs' and 'display.fs' get loaded earlier.  'color-list'

	  New 'char-to-addr' (moved to 'menu.fs')  Use it in 'nuc-menu'.

	  'save-variable' 'save-2variable' 'save-xt-variable' for offsets.

	* compile-options.fs: Obsolete option 'use-default-color' removed.

	* iForth.fs: 'use-default-color' does not exist any more.
	  obsolete.

	* menu.fs: Added two data cells to menu cell.
	  '>menu-any-data' '>menu-any-data2'
	  I use them for storing pointer and length of the title string
	  for 'choose-xt-menu'.

	  Renamed 'mde' to 'MDE:'

	  Added 'char-to-addr' 'simple-menu-entry-char'

	* lists.fs: 'next-or-new-node' 'copy-simple-list-elements'

	* display.fs: <color-foreground> <color-background> removed.
	  Correction gegarding default-color.

	* console-codes.fs: color-list

	* brew-basics.fs: '(none)' and 'title-colors-xt' moved here.
	  no need for <color-foreground> <color-background> any more.

2001-02-04  Robert Epprecht  <epprecht@sunweb.ch>

	* brew.fs: renamed (added '#') 'time-planes#' 'field-planes#'.
	  Spelling corrections.
	  Thoughts about continuous display (not implemented yet).
	  'display-menu' more convenient.

	* brew.fs:
	  Initialize 'diversification-mask' by 'init-diversification-mask'.

	* OUTPUT/rec-play/intro.fs, benchmarks/displayed-bench.fs:
	corrected (scan-detail-index).

2001-02-03  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: unwrapped genes.

	* pfe.fs: pfe works now with unwrapped genes.

	* mutation-0.2.fs: Compile internals word *before* gene.
	  No 'genes-not-wrapped' needed any more.

	* genes-0.2.fs: Compile internals *before* genes now (on genomes).
	  Makes it easy to unwrap genes.
	  'compile-internals' takes string on stack now.

	* genes/genes-store.fs, genes/genes-store-normalised.fs, genes/genes-qualities.fs, genes/genes-organs.fs, genes/genes-fetch.fs, genes/genes-conditionals.fs, genes/genes-basic-stack.fs, genes/genes-basic-arithmetics.fs:
	dropped wrapped versions.

	* benchmarks/mutations-1.fs, benchmarks/long-mutations.fs, benchmarks/displayed-bench.fs, OUTPUT/rec-play/intro.fs, compile-options.fs:
	dropped 'genes-not-wrapped'

	* cvs-tags: brew-zz-guess-A

	* compile-options.fs: brew-zz-guess-A version.

	* brew-init.fs: for brew-zz-guess-A
	  guess-A experiment with hit at step 72.

	* TODO: updated.

	* BUGS: brew-zz-guess-A not for pfe (unwrapped genes).

	* mutation-0.2.fs:
	Replacements in 'do-replacements' using list 'replacements'.
	  'replace' gives strings if substring length differs.

2001-02-02  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Major design flaw in generating internals data.

2001-02-01  Robert Epprecht  <epprecht@sunweb.ch>

	* DEVELOPMENT: Nuc and spot variable number compile time configurable.

	  Compile switch policy.

	  Changed color syntax.
	  Use some colors in menus and messages.

	  'gene-pool-menu' and 'actual-pool-menu'.

	  'see-genome' by pressing 'l' over a cell.

	  Enhanced scrolling.  Support <end> key.

	* gene-pool.fs: LIST: gene-pools  (not really used yet).

	* menu.fs: enhanced scroll support.  Support <end> key.  'scroll-end'
	  'scroll-sanity'

	  work in progress: 'show-key-bindings'  (buggy!)

	* key-mapping.fs: support the <end> key.

	* gforth.fs: added: <end>

	* brew.fs: 'gene-pool-menu' and 'actual-pool-menu'.

	  You can 'see-genome' by pressing 'l' over a cell now.
	  Cursor returns to the cell looked at.

	  adapt to configurable organ number 'report-organs-&-qualities'

	  colored '.sorry'

	  dropped slot display functions '.organ-A' and family.

2001-01-31  Robert Epprecht  <epprecht@sunweb.ch>

	* genes/genes-organs.fs:
	define nuc-organs# named organs with 'define-organ-primitives'.
	  No unwrapped version for nuc-organs# <> 7.

	* compile-options.fs: 'title-colors-xt'

	* brew.fs: 'common-menu-entries' factored out.

	* brew.fs: fixed 'see-genome' '?|see-genome|' and 'page-see'.
	  Menu title colors configurable with 'title-colors-xt'
	  'set-title-colors'

	  Hack to get balanced stack type probabilities:
	  'more-n-consumer-genes'

	  Bug fix: 'nuc-parameters' defined even if 'nuc-parameters#' = 0.

	* benchmarks/long-mutations.fs, benchmarks/displayed-bench.fs, benchmarks/mutations-1.fs, OUTPUT/rec-play/intro.fs:
	respect 'genes-not-wrapped'.

	* genes/nuc-parameters.fs: 'more-n-consumer-genes' moved to 'brew.fs'.

	* genes/spot-properties.fs:
	defining property genes with 'define-property-genes'.

	* genes/nuc-parameters.fs:
	defining parameter genes with 'define-parameter-genes'.
	  Old code left in.
	  Quick hack to get balanced stack type probabilities:
	  'more-n-consumer-genes'

	* genes/genes-qualities.fs:
	defining quality genes with 'define-quality-genes'
	  Old code left in.

2001-01-30  Robert Epprecht  <epprecht@sunweb.ch>

	* compile-options.fs:
	compile time VALUEs for number of nuc and spot variables.
	  'nuc-organs#' 'nuc-parameters#'
	  planed: 'nuc-invisible#' 'nuc-secrets#'
	  'spot-qualities#' 'spot-properties#'
	  planed: 'spot-secrets#'

	* display.fs: set '<color-foreground>' and '<color-background>'

	* brew.fs:
	Nuc and spot compile time configurable. Changed nuc structure.

	  action pointers first: (see source)
	  genes
	  CONSTANT nuc-genes-limit	nuc indices
	  CONSTANT nuc-xt's
	  xt's
	  CONSTANT nuc-xt-limit
	  CONSTANT nuc-variables
	  nuc intern data
	  CONSTANT nuc-diversificable-area
	  CONSTANT nuc-organs       \ index of first organ
	  named organs configurable by VALUE nuc-organs#
	  the cells can read and write them
	  CONSTANT nuc-parameters   \ base index
	  named parameters configurable by VALUE nuc-parameters#
	  the cells can read but not change them
	  0 CONSTANT nuc-invisible#     \ planed invisible, diversified
	  ( # ) CONSTANT nuc-diversificable-items
	  0 CONSTANT nuc-secrets#       \ planed invisible, not diversified
	  others			\ planed
	  cells CONSTANT nuc-length#

	  Define named variables: 'define-nuc-organs' 'define-nuc-parameters'
	  Adapted: 'nuc-var-name'  No more 'nuc-var-name-txt'.

	  Compile time configurable spot variable counts:
	  'spot-qualities#' 'spot-properties#' 'spot-secrets#'
	  Defining named properties 'define-properties'
	  Details see source.

	  Changes in nuc and diversification menus, save nuc.

	  Menu titles coloured.
	  Coloured messages.

	  Better nuc menu.
	  Interface to 'my-diversification-bitmask'.

	  Better 'menu-step-display'.
	  'define-step-display-item' does 'choose-displayed-item' too.
	  More checks in '?step-display-sanity'.  'step-display-adapt-size'

	  'choose-xt-men' does key menu entry of first char now.

	  You can see genome by pressing 'G' now. Work on 'page-see' and so.
	  '?|see-genome|' not finished.
	  Catch 'see' error.

	  New char display function 'show-code-length'

	  Bug fixes. (different places).
	  'sow' does 'new-id'

	* brew-basics.fs: colored messages.
	  'message-fg-color-xt' 'message-bg-color-xt'
	  colored .menu-short-help (cyan blue hardcoded).

2001-01-28  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs: do-FORTH continues with <space>

2001-01-27  Robert Epprecht  <epprecht@sunweb.ch>

	* compile-options.fs: forgot to mention plans for number of variables.
	  These are planed to become a compile time value:
	  nuc-organs# nuc-parameters# nuc-invisible# nuc-secrets#
	  qualities# spot-secrets# properties#

	* compile-options.fs:   defining compile time options policy:

	  * CONSTANTs are pure compile time switches.
	  * a VALUE can be used instead, in cases where it might be reset.
	  * CREATEd names are switching by their existence.
	    Be careful with names that could be predefined in a system...

	  * If a VARIABLE is defined it gets compiled as run time switch.
	    It's value gets the default run time value.
	    (There are exceptions, see 'ekey-cursor-support')

	  * Words that do something can be defined system dependent,
	    if the source checks with [UNDEFINED]
	    Tell me, if other words should be checked for.

	* pfe.fs: strange bug: ;gene seems not to switch back to interpret.
	  I must look at this.  Set 'genes-not-wrapped' to false for now.

	* gforth.fs, menu.fs, genes-0.2.fs:
	changed compile time options definitions.

	* brew.fs: changed compile time options definitions.
	  Plans to pass number of spot and nuc variables of the different
	  kinds through compile time values:
	  'nuc-organs#' 'nuc-parameters#' 'nuc-invisible#' 'nuc-secrets#'
	  'qualities#' 'properties#' 'spot-secrets#' or so.

	* brew-init.fs, mutation-0.2.fs, reporting.fs, genes/genes-store.fs, genes/genes-store-normalised.fs, genes/genes-qualities.fs, genes/genes-organs.fs, genes/genes-fetch.fs, genes/genes-conditionals.fs, genes/genes-basic-stack.fs, genes/genes-basic-arithmetics.fs:
	changed compile time options definitions.

	* statistics.fs: new color syntax.

	* display.fs: New color syntax:  cyan color-foreground
	  'color-foreground' 'color-background'
	  ('foreground' 'background' 'paint' are gone.)

	  'default-color' see compile time switch 'use-default-color'

	* compile-options.fs:
	'use-default-color' for systems like Linux text console
	  having a color code, that resets to a default color.
	  It must give a different result on foreground and background.

	* brew.fs: use new color syntax.

	* iForth.fs: New color syntax: Quick guess what could work.

	* brew-options.fs: mentioning 'my-brew-options.fs'

	* benchmarks/long-mutations.fs, benchmarks/displayed-bench.fs, OUTPUT/rec-play/intro.fs:
	adapted to the new step display.

	* my-compile-options.fs, my-brew-options.fs:
	Included a empty file in cvs.
	  In some systems (like iForth) you can't do
	  ' include catch somefile
	  without getting a critical error when the file doesn't exist.

	* DEVELOPMENT: Detailed spot scans.  Multiple scans.

	* brew.fs: multiple scans of nuc and/or spot variables.
	  (There is some redundant code left.)

	  Changed: 'display-menu' new: 'menu-step-display'
	  'select-nuc-var-men' revitalized, scrolling version.
	  'menu-select-spot-var' and many other new words.
	  'toggle-display-type' does '?step-display-sanity'
	  'display-switch' just 'step-display-on', no 'scan-display-spot'
	  'save-step-display-settings'

	  New 'code-file-mask': 'write-code-file'
	  Changed: 'code-file-menu'

	  'save-xt-variable' can deal with empty xt variables now.

	  Bugfix: clear last line if there's no info line.
	  Corrected inconsistency of 'd'/'D' key menu entries.
	  Use 'last-left' and 'at-last'

	* statistics.fs:
	deferred '<vertical-zoom-scale>' '<vertical-display-range>'

	* reporting.fs: new code-file-mask 'write-code-file'

	* mutation-0.2.fs: use new code file mask 'write-code-file'
	  Nested conditions for speed optimation.

	* menu.fs: use 'at-last' and 'last-left'

	* fileselect.fs: use 'at-last'

	* compile-options.fs: added default zoom scales:
	  'default-horizontal-zoom-scale' 'default-vertical-zoom-scale'

	* brew-init.fs: use new step display variables.

	* brew-basics.fs: added:	'clear-line-to-end'

2001-01-25  Robert Epprecht  <epprecht@sunweb.ch>

	* brew-basics.fs:
	'last-left' and use it.  Use 'at-last' in many more places.

	* statistics.fs: 'statistic-display' takes a lines parameter now.
	  This makes it possible to display multiple scans on screen.

	* display.fs: eliminated 'scan-display-spot' bit mask.

	* basics.fs: 'n-ARRAY' 'n-2ARRAY', both unused.

2001-01-24  Robert Epprecht  <epprecht@sunweb.ch>

	* compile-options.fs: max-step-scans#

	* display.fs, brew.fs: spot scans.
	  Intermediate version just *one* scan in step display.

	* iForth.fs: added: 'xt>name'

	* genes/genes-basic-stack.fs:
	hack to get rid of type variants in compiled genes.
	  This will change with the new gene/mutation implementation.

	* gene-pool.fs: input/output stack type statistics: '.pool-stackdata'
	  Didn't bring so much, but I leave it in.

	* benchmarks/long-mutations.fs, benchmarks/displayed-bench.fs, OUTPUT/rec-play/intro.fs, brew-init.fs:
	renamed '(step-scan-min-max)' to '(nuc-scan-min-max)'

	* basics.fs: added:	-rot

2001-01-21  Robert Epprecht  <epprecht@sunweb.ch>

	* cvs-tags: brew-0_03zz

	* DEVELOPMENT: Moving towards a compatibility break.
	  You can choose which genes to include in code files now,
	  all or just successful ones.

	* VERSION-README: coming compatibility break.  No demos for a while.

	* benchmarks/long-mutations.fs:
	Probability pool inserted.  Use gene' on g-noop.

	* compile-options.fs: fake conservative settings for snapshot.

	* OUTPUT/rec-play/intro.fs: use gene' on g-noop

	* brew-init.fs: file-code file-stack or code-file-mask !

	* benchmarks/mutations-1.fs, benchmarks/displayed-bench.fs:
	Probability pool inserted.

	* brew.fs: Change on nuc-parameter's: fixed named versions.
	  It seems more efficient (not elegant and unflexible though)
	  Will change again, probably.

	  'play' does not influence search order any ,ore.
	  Use GENE' to save 'wake-me-xt' in 'save-nuc'.

	* genes/nuc-parameters.fs: bugfix.
	  Use new 'nuc-parameter-A' and sisters.
	  It's nor elegant nor flexible but efficient.

	* genes-0.2.fs: added [gene'] and gene'

	* TODO: Plans for the coming compatibility break.

	* iForth.fs: background/foreground hack.
	  d= version of ?/
	  Warning about screen size.

